using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Text;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Microsoft.MapPoint.VirtualEarth.Content;
using Microsoft.MapPoint.VirtualEarth.Common;
using Microsoft.MapPoint.VirtualEarth.Location;

namespace VEPRoxy
{
	/// <summary>
	/// Summary description for Flight103.
	/// </summary>
	public class DefaultPage : Flight
	{

		public string locale;	
		public string language;
		public string passportLoginButtonHtml = "";
		public string enableJSWatson = "0";
		public string version = ConfigSettings.JSVersionNumber;
		public bool click2callenabled;
		public string click2callurl;
		public string revIPLat;
		public string revIPLong;

		public override void Load()
		{		
			// Check if the request has an inappropriate slash.
			// Slashes after .aspx extensions are known to cause issues with relatively linked content.
			if(Request.Path.IndexOf(".aspx/") != -1)
			{
				Response.Redirect("default.aspx");
				return;
			}			

			try
			{
				//passportLoginButtonHtml = rpsHttpAuth.LogoTag(!hasTicket, false, null, null, siteName, rpsConstructPropBag);
				if(hasTicket && validated)
				{
					passportLoginButtonHtml = "<a href=" + rpsDomainMap.ConstructURL("logout", siteName, null, rpsConstructPropBag) + ">$L_PassportSignOut_Text$</a>";
				}
				else
				{
					passportLoginButtonHtml = "<a href=" + rpsDomainMap.ConstructURL("auth", siteName, null, rpsConstructPropBag) + ">$L_PassportSignIn_Text$</a>";					
				}

			}
			catch(Exception ex)
			{
				//TODO Log Passport failure
			}
			
			//Extract Lat /Long from reverse IP
			string useripaddress = string.Empty;
			//Check for akamai header
			if((Request.ServerVariables["True-Client-IP"] != null) &&
				(Request.ServerVariables["True-Client-IP"].Length > 0))
			{
				useripaddress = Request.ServerVariables["True-Client-IP"];
			}
				//CMS headers
			else if((Request.ServerVariables["Source-IP"] != null) &&
				(Request.ServerVariables["Source-IP"].Length > 0))
			{
				useripaddress = Request.ServerVariables["Source-IP"];
			}
			else 
			{	
				useripaddress = Request.ServerVariables["REMOTE_ADDR"];
			}		
			try
			{
				CountryInfo revIPCountryInfo= IPCountryProvider.GetCountryInfo(useripaddress);
				if ( revIPCountryInfo != null )
				{
					revIPLat = revIPCountryInfo.LatLong.Latitude.ToString();
					revIPLong = revIPCountryInfo.LatLong.Longitude.ToString();
				}
			}
			catch
			{
			}

			MarketDetectionHelper marketHelper = new  MarketDetectionHelper();
			// retrieve the locale
			locale = marketHelper.GetMarket();
			//retrieve the language
			language = marketHelper.GetLanguage();

			//Set JSWatson flag
			if(ConfigSettings.JSWatsonEnabled)
			{
				enableJSWatson = "1";
			}
			else
			{
				enableJSWatson = "0";
			}
			//retrieve the click2callenabled
			ConfigSettings conSettings = new ConfigSettings(locale);
			click2callenabled = conSettings.Click2CallEnabled;
			//retrieve the Click2CallUrl
			click2callurl = ConfigurationHelper.GetValue("Click2CallUrl");	
		}
		

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}

