//------------------------------------------------------------------------------
// API/Color.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: keithkin
//
// <header>	$Color$</header>
//------------------------------------------------------------------------------

//class VEColor 
//public interface:
//   public properties:
//      R: red component value int
//      G: green component value int
//      B: blue component value int
//      A: transparency alpha value float
//
//   VEColor(r, g, b a)
//      constructor
//      parameters:
//         r: red int. Default 0.
//         g: green int. Default 0.
//         b: blue int. Default 0.
//         a: transparency alpha float. Default 1.0.
//
// TODO: Add enums for common colors (i.e. Red, Blue, LightBlue) and methods for getting/setting color string .(i.e."#ffff00")
//
function VEColor(r, g, b, a)
{
	try
	{
		VEValidator.ValidateInt(r, "r");
		VEValidator.ValidateInt(g, "g");
		VEValidator.ValidateInt(b, "b");
		VEValidator.ValidateFloat(a, "a");

		this.R = r;
		this.G = g;
		this.B = b;
		this.A = a;
	}
	catch(ex)
	{
		throw ex;
		return;
	}
}
