//------------------------------------------------------------------------------
// API/LatLonDecoder.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: keithkin
//
// <header>	$LatLonDecoder$</header>
//------------------------------------------------------------------------------

//VELatLongDecoder
//   Decode
//      Copies the encoded VELatLong and returns a copy of it decoded.
//      The passed in VELatLong remains unchanged. This is important because
//      we do not want to expose unencoded data to customers if it is supposed to be encoded.
//      If the VELatLong passed in is not encoded, returns a copy of the VELatLong.
//
function VELatLongDecoder()
{
	var m_latlongEncoding = new VELatLongEncoding();

	this.Decode=function(veLatLong)
	{
		VEValidator.ValidateObject(veLatLong, "veLatLong", VELatLong, "VELatLong");
		var veLatLongCopy = veLatLong.Clone();
		if ((veLatLongCopy.Latitude == null) || (veLatLongCopy.Longitude == null) &&
		    (veLatLongCopy._reserved != null))
		{
			var latLong = m_latlongEncoding.Decode(veLatLongCopy._reserved);
			veLatLongCopy.Latitude = latLong[0];
			veLatLongCopy.Longitude = latLong[1];
			veLatLongCopy._reserved = null;
		}
		return veLatLongCopy;
	}
}

