//------------------------------------------------------------------------------
// API/Message.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Cthota, keithkin
//
// <header>	$Message$</header>
//------------------------------------------------------------------------------
function VEMessage(vemap)
{
	VEValidator.ValidateObject(vemap, "vemap", VEMap, "VEMap");
	this.m_vemap= vemap;
	var self=this;

	this.Show = function(message)
	{
		if(message == null || message == "undefined" || message.length <= 0)
			return;

		message = _FilterMessageForAPI(message);
					
		if(this.vemessagepanel == null || this.vemessagepanel == "undefined")
		{
			var e=document.createElement("div");
			e.id = this.m_vemap.ID + "_vemessagepanel";
			e.className = "VE_Message";
			e.style.zIndex = Msn.VE.API.Globals.vemessagepanelzIndex;
			e.style.top = this.m_vemap.GetHeight()/2 - Msn.VE.API.Globals.vemessagepanelheight/2  + "px";
			e.style.left = 30  + "px";
			e.style.width = this.m_vemap.GetWidth() - 60 + "px";
			e.style.height = Msn.VE.API.Globals.vemessagepanelheight  + "px";
			e.style.position = "absolute";
			this.vemessagepanel=e;

			// Create the title element
			var title = document.createElement("a");
			title.className = "VE_Message_Title";
			title.style.zIndex = parseInt(Msn.VE.API.Globals.vemessagepanelzIndex) + 1;
			title.style.top = "1px";
			title.style.left = "1px";
			title.style.width = parseInt(this.vemessagepanel.style.width) - 5 + "px";
			title.innerHTML = IOSec.EncodeHtml(L_error_text);
			title.unselectable = "on";
			this.vemessagepanel.appendChild(title);
			
			// Create the close button
			var cb = document.createElement("a");
			cb.className = "VE_Message_Close";
			cb.style.zIndex = parseInt(Msn.VE.API.Globals.vemessagepanelzIndex) + 2;
			cb.style.top = "1px";
			cb.style.right = "1px";
			
			cb.onclick = self.Hide;
			cb.unselectable = "on";
			cb.innerHTML = L_close_text;
			this.vemessagepanel.appendChild(cb);
			
			// Create the body	
			var body = document.createElement("div");
			body.id = this.m_vemap.ID + "_vemessagepanel_body";
			body.className = "VE_Message_Body";
			body.style.zIndex = parseInt(Msn.VE.API.Globals.vemessagepanelzIndex) + 3;
			body.style.top = 22  + "px";
			body.style.width = parseInt(this.vemessagepanel.style.width) - 8 + "px";
			body.onclick = self.Hide;
			body.unselectable = "on";
			body.innerHTML = message;
			this.vemessagepanel.appendChild(body);
			
			// Add the panel to the document
			this.m_vemap.AddControl(this.vemessagepanel, Msn.VE.API.Globals.vemessagepanelzIndex);
		}
		else
		{
			var body = document.getElementById(this.m_vemap.ID + "_vemessagepanel_body");
			body.innerHTML  = message;
		}
		
		this.vemessagepanel.style.display = "block";
		this.timeoutIntervalID = window.setInterval(this.Hide,10000);
	}

	this.Hide = function()
	{
		VEMap.ValidateState();
		if((self.vemessagepanel != null) && 
		   (self.vemessagepanel != "undefined"))
		{
			self.vemessagepanel.style.display = "none";
			if (self.timeoutIntervalID != null)
			{
			   window.clearInterval(self.timeoutIntervalID);
			   self.timeoutIntervalID = null;
			}
		}
	}

	this.Dispose = function()
	{
		if ((this.vemessagepanel != null) &&
			(this.vemessagepanel != "undefined"))
		{	    
			this.vemessagepanel = null;
		}
	}
	
	function _FilterMessageForAPI(message)
	{
		//Remove all server-side generated VE link markup from messages since they do not make sense
		//in an API context. Keep the link text so the message will still be readable and translated.
		var regExp = /<a[^>]*>/ig;
		message = message.replace(regExp, "");
		regExp = /<\/a>/ig;
		message = message.replace(regExp,"");
		return message;
	}
}
