//------------------------------------------------------------------------------
// Annotation/AnnotationUtil.js - Utility methods for Annotations 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: BayardB
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// returns true/false if pin is an annotation
VE_Annotations.ElementIsAnnotationPin = function (elem)
{
  var idParts = elem.id.split ("_");
  if ( VE_Annotations.PinType != idParts[idParts.length-1] )
  {
    return false;
  }
  return true;
}

// returns true/false if serialized rep is an annotation
VE_Annotations.SerializedRepIsAnno = function ( strTest )
{
	var strAnnoType = VE_Annotations.PinType + '.';
	var strType = strTest.substr ( 0, strAnnoType.length ); // +1 for '.'
	
	if ( strType.toLowerCase () != strAnnoType.toLowerCase () )
	{
		return false;
	}
	
	return true;
}

//
// for validation of fields in the annotation panel
// prevents a user from entering more than a prescribed number
// of characters in the text field
//
// params:
// intMaxChars - the max number of chars allowed
// elmTextField - the textfield to validate
//
// returns true if the function modified the field value
VE_Annotations.TextFieldLimiter = function ( intMaxChars, elmTextField )
{
	if ( elmTextField.value.length > intMaxChars )
	{
		elmTextField.value = elmTextField.value.substr (0, intMaxChars);
		return true;
	}
	return false;
}
