//------------------------------------------------------------------------------
// Directions/Disambiguation.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, EShinn, sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Sets the start point when the user selects a location in the disambiguator
VE_Directions.ChooseStart=function(e)
{
	var latLong = VE_Directions.startAmbiguousSelect.GetSelectedItem();
	
	// if ( none of the above ) item is selected
	if ( latLong.data == null )
	{			
		// reset the Directions Result section 
		ResetDirectionsResult();
		HideStartAmbiguator();					
		document.getElementById("start").focus();
	}	
	else
	{
		document.dd.start.value = latLong;
		VE_Directions.startLat = latLong.data.latitude;
		VE_Directions.startLon = latLong.data.longitude;
		
		HideStartAmbiguator();	
		if (document.selection)
			document.onselectstart = function(){return false;}	

		// check of Ambiguity on the end field
		if (VE_Directions.endAmbiguousSelect.GetCount() == 0)
			VE_Directions.GetDirections();
		else
		{
			ShowEndAmbiguator();
		}
	}
}

// Sets the end point when the user selects a location in the disambiguator
VE_Directions.ChooseEnd=function(e)
{
	var latLong = VE_Directions.endAmbiguousSelect.GetSelectedItem();	
	
	// if ( none of the above ) item is selected
	if ( latLong.data == null )
	{	
		// reset the Directions Result section 
		ResetDirectionsResult();
		HideEndAmbiguator();
		document.getElementById("end").focus();
	}
	else
	{
		document.dd.end.value = latLong;
		VE_Directions.endLat = latLong.data.latitude;
		VE_Directions.endLon = latLong.data.longitude;	
			
		HideEndAmbiguator();
		if (document.selection)
			document.onselectstart = function(){return false;}	
			
		// check of Ambiguity on the end field	
		if (VE_Directions.startAmbiguousSelect.GetCount() == 0)
			VE_Directions.GetDirections();
		else
		{
			ShowStartAmbiguator();
		}	
	}			
}

// Displays the disambiguator for the specified end point.
VE_Directions.Disambiguate=function(field, locations)
{
	var select = (field == "start") ? VE_Directions.startAmbiguousSelect : VE_Directions.endAmbiguousSelect;	
	select.ClearItems();

	// Display locations if we have any.
	if (locations)
	{	
		for (var i=0; i<locations.length; i++)
		{
			select.AddItem(new VE_SelectItem(new VE_Location(locations[i].name,
															 locations[i].latitude,
															 locations[i].longitude),
											 locations[i].name));
		}		
		if ( locations.length > 0 ) 
			select.AddItem( new VE_SelectItem( null, L_DisambiguationNoneOfTheAbove_Text ));
		
		if (!VE_Directions.startAmbiguousSelect.isVisible)
		{	
			select.Show();				
			VE_Directions.ShowMessage(field, L_DisambiguationDoYouMean_Text );
		    
   		    var parentElement = document.getElementById(select.id).parentElement;		    
			parentElement.attachEvent("onkeydown", DisambiguatorOnKeyDownHandler );
			parentElement.attachEvent("onblur", DisambiguatorOnBlurHandler );
			parentElement.focus();
			parentElement = null;
		}
	}
	else
	{
		select.Hide();
		VE_Directions.ShowMessage(field, null);
	}
}

function HideStartAmbiguator()
{
	VE_Directions.ShowMessage("start", null);	
	VE_Directions.startAmbiguousSelect.Hide();	
	VE_Directions.startAmbiguousSelect.ClearItems();	
	// Detach events
	var startAmbiguousElement = document.getElementById("startAmbiguous");
	startAmbiguousElement.detachEvent("onkeydown", DisambiguatorOnKeyDownHandler );
	startAmbiguousElement.detachEvent("onblur", DisambiguatorOnBlurHandler );
	startAmbiguousElement = null;
}
function ShowStartAmbiguator()
{
	VE_Directions.startAmbiguousSelect.Show();	
	VE_Directions.ShowMessage("start", L_DisambiguationDoYouMean_Text );
	//Attach Events		
	var startAmbiguousElement = document.getElementById("startAmbiguous");
	startAmbiguousElement.attachEvent("onkeydown", DisambiguatorOnKeyDownHandler );
	startAmbiguousElement.attachEvent("onblur", DisambiguatorOnBlurHandler );
	startAmbiguousElement.focus();
	startAmbiguousElement = null;
}

function HideEndAmbiguator()
{
	VE_Directions.ShowMessage("end", null);
	VE_Directions.endAmbiguousSelect.Hide();
	VE_Directions.endAmbiguousSelect.ClearItems();
	// Detach events
	var endAmbiguousElement = document.getElementById("endAmbiguous");
	endAmbiguousElement.detachEvent("onkeydown", DisambiguatorOnKeyDownHandler );
	endAmbiguousElement.detachEvent("onblur", DisambiguatorOnBlurHandler );
	endAmbiguousElement = null;
}

function ShowEndAmbiguator()
{
	VE_Directions.endAmbiguousSelect.Show();
	VE_Directions.ShowMessage("end", L_DisambiguationDoYouMean_Text );
	//Attach Events
	var endAmbiguousElement = document.getElementById("endAmbiguous");
	endAmbiguousElement.attachEvent("onkeydown", DisambiguatorOnKeyDownHandler );
	endAmbiguousElement.attachEvent("onblur", DisambiguatorOnBlurHandler );
	endAmbiguousElement.focus();
	endAmbiguousElement = null;
}

function DisambiguatorOnKeyDownHandler(e)
{
	if (!e)
	{
		e = window.event;
	}
	
	switch (e.keyCode)
	{		
		case 27: // esc		
			if ( e.srcElement == document.getElementById("startAmbiguous" ) )
			{
				// reset the Directions Result section 
				ResetDirectionsResult();
				// Hide Start Ambiguator
				HideStartAmbiguator();
				// set focus
				document.getElementById("start").focus();		
			}
			else if ( e.srcElement == document.getElementById("endAmbiguous" ) )
			{			
				// reset the Directions Result section 
				ResetDirectionsResult();
				// Hide End Ambiguator
				HideEndAmbiguator();
				// set focus
				document.getElementById("end").focus();		
			}							
			return false;
		default:
			break;
	}	
	return true;
}
function DisambiguatorOnBlurHandler(e)
{
	//IE only
	// Handles the scenario when the scrollbars are visible and user is interacting
	if ( document.all )
	{
		var sElem = "";
		sElem = document.getElementById("directions_body").componentFromPoint(e.clientX,e.clientY );
		if ( sElem == "scrollbarVThumb" || sElem == "scrollbarHThumb" )
		{
    		var currentElement = null;
    		var startElement = document.getElementById("startAmbiguous" );
    		var endElement = document.getElementById("endAmbiguous");	    		
    		currentElement = ( e.srcElement == startElement )? startElement	: endElement ;				
			currentElement.focus();
			currentElement = null;
			return;
		}	
	}	
    
	if ( e.srcElement == document.getElementById("startAmbiguous" ) )
	{
		// reset the Directions Result section 
		ResetDirectionsResult();
		// Hide Start Ambiguator
		HideStartAmbiguator();
		// set focus
		document.getElementById("start").focus();	
	}
	else if ( e.srcElement == document.getElementById("endAmbiguous" ) )
	{	
		// reset the Directions Result section 
		ResetDirectionsResult();
		// Hide End Ambiguator
		HideEndAmbiguator();
		// set focus
		document.getElementById("end").focus();		
	}
	return false;		
}
// A simple data class to represent someplace.
function VE_Location(name, latitude, longitude)
{
	this.name = name;
	this.latitude = latitude;
	this.longitude = longitude;
}
