//------------------------------------------------------------------------------
// Favorites.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: kamonmo
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
function VE_Favorites()
{
}

// A reference to the panel
VE_Favorites.panel = null;
VE_Favorites.items = null;
VE_Favorites.xmlHttp = GetXmlHttp();
VE_Favorites.GetServiceUrl = "favorites.ashx?mkt={0}&action=get";
VE_Favorites.DeleteServiceUrl = "favorites.ashx?mkt={0}&action=delete&title={1}";
VE_Favorites.zIndex = 31;
VE_Favorites.lastRetrievedTime = null;
VE_Favorites.lastAddedTime = null;


VE_Favorites.GetPanelBody=function()
{
	var body = "<div class=\"msve_favorites\">";
	
	var items = VE_Favorites.items;
	if(!items || (items.constructor) != Array || (items.length ==0)) 
	{
		//if there is no favorite items, display no favorite items message
		var listEmptyHtml = VE_Favorites.GetEmtyListHTML();
		body += listEmptyHtml;
	} 
	else 
	{
		var ul = "<ul id=\"msve_favorites_items\" class=\"list_favoriteItems\">";
		
		var validItemsCnt = 0;
		
		for(var i=0; i<items.length; i++) 
		{
			if(items[i] && items[i].IsValidItem()) 
			{
				var url = IOSec.TruncateUrlSafe ( items[i].url, 2020 );
				var cidIndex = url.indexOf(VE_State.ItemCollectionId + "=");
				if(cidIndex > -1)
				{
					validItemsCnt++;
					var cid = url.substring(cidIndex+VE_State.ItemCollectionId.length+1);
					var newParamIndex = cid.indexOf("&");
					if(newParamIndex > -1) 
					{
						cid = cid.substring(0,newParamIndex);
					}
					var listItem = "<li>"
					
					var iTitle = items[i].title;
					iTitle = iTitle.replace(/'/g,"\\'");
					iTitle = IOSec.EncodeHtml (iTitle);

					var h3 = "<h3 onclick=\"VE_CollectionsManager.RetrieveCollectionDetails('"+cid+"','"+window.locale+"');VE_Analytics.Log('VE | Favorites Browser','Open Public Favorite')\">"+IOSec.EncodeHtml(items[i].title)+"</h3>";
					
					var removeItemDiv = "<div class=\"toolRemoveItem\" onclick=\"VE_Favorites.DeleteFavorite('"+iTitle+"')\"></div>";
					
					listItem += h3;
					listItem += removeItemDiv;
					listItem += "</li>";
					
					ul += listItem;
				}
			}
		}
		ul += "</ul>";
		if(validItemsCnt > 0) 
		{
			body += ul;
		} 
		else 
		{
			var listEmptyHtml = VE_Favorites.GetEmtyListHTML();
			body += listEmptyHtml;
		}
	}
	body += "</div>";
	return body;
}
VE_Favorites.GetEmtyListHTML = function()
{
	var listEmptyHtml = "<div class=\"emptyMessage\">" + L_FavoritesListEmpty_Text + "</div>";
	listEmptyHtml = listEmptyHtml.replace(/%1/, "<h3>");
	listEmptyHtml = listEmptyHtml.replace(/%2/, "</h3><p>");
	var link = "<a href=\"javascript:VE_Help.Open('"+ L_Help_Text +"','./help/"+ window.locale +"/favAbout.htm');\">";
	listEmptyHtml = listEmptyHtml.replace(/%3/, link);
	listEmptyHtml = listEmptyHtml.replace(/%4/, "</a>");
	listEmptyHtml = listEmptyHtml.replace(/%5/, "</p>");
	
	return listEmptyHtml;
}

VE_Favorites.GetToolbarHTML = function() 
{
	
	var toolbarDiv = "<div class=\"favorites_toolbar\">";
	toolbarDiv += "<ul>";	
	var li = "<li class=\"favoriteslink\" onclick=\"OpenNewWindow('"+liveFavoritesUrl+"', '_blank' , 'all');VE_Analytics.Log('VE | Favorites Browser','Manage Live Favorites Link')\">"+L_GoToLiveFavorites_Text+"</li>";
	toolbarDiv += li;	
	li = "<li><div class=\"icnHelp\" onclick=\"VE_Help.Open(L_Help_Text, 'Help/' + window.locale + '/favAbout.htm');\"></div></li>"
	toolbarDiv += li;
	toolbarDiv += "</ul>";
	toolbarDiv += "<div class = \"clear\" ></div>"			
	toolbarDiv += "</div>";
	return(toolbarDiv);
}

// Create the favorites panel
VE_Favorites.CreatePanel=function()
{
	var htmlbody =VE_Favorites.GetPanelBody();
	
	var p = new VE_Panel(	'favorites',	//id
							8,				// x
							0,				// y
							'auto',			// width
							'auto',			// height 
							'searchResults',	// color (sstchur:  in this case it's actualy now a 'type' rather than a color)
							VE_Favorites.zIndex,			// z index
							L_Favorites_Text,					// title 
							htmlbody,			// body
							'',					// footer
							true,		// mouseovertitle
							true,					// opaque
							taskArea_data);		//parent
	
	p.title.className = 'VE_Panel_title VE_Panel_title_favorites';
	
	p.onTitleClick = function(e)
	{
		//if user added favorite after the last time that we retrieved favorites, then we will refresh favorites
		if(VE_Favorites.lastRetrievedTime && VE_Favorites.lastAddedTime && (VE_Favorites.lastAddedTime > VE_Favorites.lastRetrievedTime)) 
		{
			VE_Favorites.GetFavorites();
		} 
		else 
		{
			var panel = e.srcPanel;
			taskArea.setCurrent(panel);
		}
	};
	p.onCloseClick = function(e)
	{
		var panel = e.srcPanel;
		taskArea.removeItem(panel);	
		panel.Destroy();
		VE_Favorites.panel = null;
		VE_Favorites.items = null;
	};
	
	p.onMaximize = function(e)
	{
		resetWhatBox();
	};	
	
	// Make IE obey the pseudo class :hover for any search's TitleBar
	pseudoHover(p.title);
	
	var toolbarHTML = VE_Favorites.GetToolbarHTML();
	if(toolbarHTML) 
	{
		p.SetToolbar(toolbarHTML);
	}	
	
	p.Hide();
	VE_Favorites.panel = p;
	
	// Add the panel to the Task Area	
	taskArea.addItem(p);
}

VE_Favorites.UpdatePanel=function()
{
	var htmlbody =VE_Favorites.GetPanelBody();
	VE_Favorites.panel.SetBody(htmlbody);
}

VE_Favorites.Show = function()
{	
	toggleTaskArea(true);
	if (!VE_Favorites.panel)
	{
		VE_Favorites.CreatePanel();
	} else 
	{
		VE_Favorites.UpdatePanel();
	}
	var ul = document.getElementById("msve_favorites_items");
	if(ul) 
	{
		pseudoHoverForChildren(ul);
	}
	VE_Favorites.panel.Show();	
	taskArea.setCurrent(VE_Favorites.panel);
}
VE_Favorites.SetItems = function(items)
{
	if(!items || items.constructor != Array)
	{
		return;
	}
	VE_Favorites.lastRetrievedTime = new Date();
	VE_Favorites.items = items;
	
	VE_Favorites.Show();
}

VE_Favorites.ResponseHandler = function() 
{
	if(VE_Favorites.xmlHttp.readyState==4) 
	{
		var code = VE_Favorites.xmlHttp.responseText;
		try
		{
			if((code != null) && (code.length > 0)) 
			{
				eval(code);
			}
		}
		catch(ex)
		{
			ShowMessage( L_ErrorServerBusy_Text );
		}
	}
}
VE_Favorites.GetFavorites = function()
{
	if(VE_Favorites.xmlHttp)
	{
		var url = VE_Favorites.GetServiceUrl;
		url = url.replace(/\{0\}/, window.locale);
		VE_Favorites.xmlHttp.open("GET", url, true);
		VE_Favorites.xmlHttp.onreadystatechange=VE_Favorites.ResponseHandler;
		VE_Favorites.xmlHttp.send(null);
	}
}
VE_Favorites.DeleteFavorite = function(title)
{
	if(title && (title.length > 0)) 
	{
		if(VE_Favorites.xmlHttp)
		{
			var url = VE_Favorites.DeleteServiceUrl;
			url = url.replace(/\{0\}/, window.locale);
			url = url.replace(/\{1\}/, encodeURIComponent(title));
			VE_Favorites.xmlHttp.open("GET", url, true);
			VE_Favorites.xmlHttp.onreadystatechange=VE_Favorites.ResponseHandler;
			VE_Favorites.xmlHttp.send(null);
		}
	}
}
VE_Favorites.AddFavorites = function(title,url) 
{
	var isSignedIn = VE_Passport.CheckPassportSignedInSync();

	if(isSignedIn)
	{
		VE_Favorites.lastAddedTime = new Date();
		var favoriteTitle = encodeURIComponent(title);
		
		var favoriteUrl = IOSec.TruncateUrlSafe ( url, 2020 );
		favoriteUrl = encodeURIComponent(favoriteUrl);
		
		var favoriteFolder = encodeURIComponent(liveFavoritesFolderName);
		
		var quickAddUrl = liveFavoriteQuickAddUrl;
		quickAddUrl=quickAddUrl.replace(/\{0\}/, favoriteTitle);
		quickAddUrl=quickAddUrl.replace(/\{1\}/, favoriteUrl);
		quickAddUrl=quickAddUrl.replace(/\{2\}/, favoriteFolder);
		
		OpenNewWindow(quickAddUrl, "_blank" , "menubar=0,resizable=1,scrollbars=0,status=0,titlebar=0,toolbar=0");

	} else
	{
		ShowMessage(L_FavoritesSignInSuggestion_Text);
	}
}

function VE_FavoritesItem(title, url)
{
	this.title = title;
	this.url = url;
}
VE_FavoritesItem.prototype.IsValidItem = function() 
{
	return(this.title && this.url && (this.title.length > 0) && (this.url.length > 0) );
}