
















function OutputEncoder_EncodeHtml( strInput )
{
	var c;
	var EncodeHtml = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);
		
		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeHtml = EncodeHtml + String.fromCharCode(c);
		}
		else
		{
			EncodeHtml = EncodeHtml + '&#' + c + ';';
		}
	}
	
	return EncodeHtml;
}

function OutputEncoder_EncodeHtmlAttribute( strInput )
{
	var c;
	var EncodeHtmlAttribute = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeHtmlAttribute = EncodeHtmlAttribute + String.fromCharCode(c);
		}
		else
		{
			EncodeHtmlAttribute = EncodeHtmlAttribute + '&#' + c + ';';
		}
	}
	
	return EncodeHtmlAttribute;
}

function OutputEncoder_EncodeXml( strInput )
{

	return OutputEncoder_EncodeHtml( strInput );
}

function OutputEncoder_EncodeXmlAttribute( strInput )
{

	return OutputEncoder_EncodeHtmlAttribute( strInput );
}
	
function OutputEncoder_EncodeJs( strInput )
{
	var c;
	var EncodeJs = '';
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeJs = EncodeJs + String.fromCharCode(c);
		}
		else if ( c > 127 )
		{
			EncodeJs = EncodeJs + '\\u' + OutputEncoder_TwoByteHex(c);
		}
		else
		{
			EncodeJs = EncodeJs + '\\x' + OutputEncoder_SingleByteHex(c);
		}
	}
	
	return '\'' + EncodeJs + '\'';
}

function OutputEncoder_EncodeVbs( strInput )
{
	var c;
	var EncodeVbs = '';
	var bInQuotes = false;
	
	if (strInput == null)
	{
		return '';
	}
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) ) ||
			( c == 32 ) ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 44 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{

			if ( !bInQuotes )
			{
				EncodeVbs = EncodeVbs + '&\"';
				bInQuotes = true;
			}
			
			EncodeVbs = EncodeVbs + String.fromCharCode(c);
		}
		else
		{

			if ( bInQuotes )
			{
				EncodeVbs = EncodeVbs + '\"';
				bInQuotes = false;
			}
			
			EncodeVbs = EncodeVbs + '&chrw(' + c + ')';
		}
	}

	if ( EncodeVbs.charAt(0) == '&' )
	{

		EncodeVbs = EncodeVbs.substring(1);
	}
	
	if ( EncodeVbs.length == 0 )
	{

		EncodeVbs = '\"\"';
	}
	
	if ( bInQuotes )
	{

		EncodeVbs = EncodeVbs + '\"';
	}
	
	return EncodeVbs;
}

function OutputEncoder_AsUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( strInput.search(/^(?:http|https|ftp):\/\/[a-zA-Z0-9\.\-]+(?:\:\d{1,5})?(?:[A-Za-z0-9\.\;\:\@\&\=\+\$\,\?\/]|%u[0-9A-Fa-f]{4}|%[0-9A-Fa-f]{2})*$/i) )
	{
		throw ("Unsanitized value passed to AsUrl");
	}
	
	return strInput;
}


function OutputEncoder_QualifyUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if ( strInput.search(/^(?:http|https|ftp):\/\//i) )
	{
		if (document.location.protocol == 'HTTPS' )
		{
			return "https://" + document.location.hostname + OutputEncoder_QualifyUrl_MakePath(strInput);
		}
		else
		{
			return "http://" + document.location.hostname + OutputEncoder_QualifyUrl_MakePath(strInput);
		}
	}
	else
	{

		return strInput;
	}
}

function OutputEncoder_QualifyUrl_MakePath( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( ! strInput.search(/^[\/\\]/) )
	{
		return strInput;
	}
	

	var re = /^(\/(?:.*\/|))(?:[^\/\\]*\.\w+|\w*)$/;
	if( ! document.location.pathname.search(re) )
	{
		var path = re.exec(document.location.pathname);
		return path[1] + strInput;
	}
	
	return '/' + strInput;
}

function OutputEncoder_AsNumeric( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	if( isNaN(parseFloat(strInput)) )
	{
		// Error out!
		throw "IOSec.AsNumeric(): Error input ["+strInput+"] not a valid number.";
	}
	
	return strInput;
}

//
// safely truncate an url (meaning: don't leave any dangling encoded characters)
// also, append optional notification when the string is truncated
function OutputEncode_TruncateUrlSafe( strUrl, intMaxLength, strNotification )
{
	if ( strUrl.length <= intMaxLength )
	{
		return strUrl;
	}
	
	var strEncNotification = "";
	if ( strNotification && strNotification.length > 0 )
	{
		strEncNotification = OutputEncoder_EncodeUrl ( strNotification );
		intMaxLength -= strEncNotification.length;
	}
	
	//
	// truncate the url to the max length
	var strUrl = strUrl.substring ( 0, intMaxLength );
	
	//
	// search at most 5 characters back for a '%'
	for (var ii=1; ii < 6; ii++)
	{
		if ( strUrl.charAt ( intMaxLength - ii ) == "%" )
		{
			//
			// cut off the dangling encoded character
			strUrl = strUrl.substring ( 0, intMaxLength - ii );
			break;
		}
	}
	
	return strUrl + strEncNotification;
}
	
//
// url encodes a string with a specified set of delimiters and '%'
// if ( strDelim == null ) the original string is returned unmodified
// otherwise, the string is returned with the correct escaping
// note that "" is a valid delim and will return the string with '%' escaped
function OutputEncode_EncodeUrlDelims( strDelim, strInput )
{
	
	if ( !strDelim )
	{
		return strInput;
	}

	var c; // char in string
	var d; // delim
	var EncodeUrl = '';
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);
		//
		// escape % and move to the next character
		if ( 37 == c ) // 37 == '%'
		{
			EncodeUrl = EncodeUrl + '%' + OutputEncoder_SingleByteHex(c);
			continue;
		}
		
		//
		// escape each delimiter
		
		
		var encodedCharacter = strInput.charAt(cnt);
		for(var dcnt = 0; dcnt < strDelim.length; dcnt++)
		{
			d = strDelim.charCodeAt(dcnt);
			
			if ( d == c )
			{
				if ( c > 127 )
				{
					encodedCharacter = '%u' + OutputEncoder_TwoByteHex(c);
				}
				else
				{
					encodedCharacter = '%' + OutputEncoder_SingleByteHex(c);
				}
				//
				// exit the delim loop
				break; // no more encoding for this char
			}
		} // end for (delims)
		
		EncodeUrl += encodedCharacter;
	}
	
	return EncodeUrl;
}
function OutputEncoder_EncodeUrl( strInput )
{
	if (strInput == null)
	{
		return '';
	}
	
	var c;
	var EncodeUrl = '';
	
	for(var cnt = 0; cnt < strInput.length; cnt++)
	{
		c = strInput.charCodeAt(cnt);

		if (( ( c > 96 ) && ( c < 123 ) ) ||
			( ( c > 64 ) && ( c < 91 ) )  ||
			( ( c > 47 ) && ( c < 58 ) ) ||
			( c == 46 ) ||
			( c == 45 ) ||
			( c == 95 ))
		{
			EncodeUrl = EncodeUrl + String.fromCharCode(c);
		}
		else if ( c > 127 )
		{
			EncodeUrl = EncodeUrl + '%u' + OutputEncoder_TwoByteHex(c);
		}
		else
		{
			EncodeUrl = EncodeUrl + '%' + OutputEncoder_SingleByteHex(c);
		}
	}
	
	return EncodeUrl;
}
	
function OutputEncoder_SingleByteHex( charC )
{
	if (charC == null)
	{
		return '';
	}
	
	var SingleByteHex = charC.toString(16);

	for ( var cnt = SingleByteHex.length; cnt < 2; cnt++ )
	{
		SingleByteHex = "0" + SingleByteHex;
	}
	
	return SingleByteHex;
}

function OutputEncoder_TwoByteHex( charC )
{
	if (charC == null)
	{
		return '';
	}
	
	var TwoByteHex = charC.toString(16);

	for( var cnt = TwoByteHex.length; cnt < 4; cnt++ )
	{
		TwoByteHex = "0" + TwoByteHex;
	}
	
	return TwoByteHex;
}

function OutputEncoder()
{
	this.EncodeHtml = OutputEncoder_EncodeHtml;
	this.EncodeHtmlAttribute = OutputEncoder_EncodeHtmlAttribute;
	this.EncodeXml = OutputEncoder_EncodeXml;
	this.EncodeXmlAttribute = OutputEncoder_EncodeXmlAttribute;
	this.EncodeJs = OutputEncoder_EncodeJs;
	this.EncodeVbs = OutputEncoder_EncodeVbs;
	this.AsNumeric = OutputEncoder_AsNumeric;
	this.EncodeUrl = OutputEncoder_EncodeUrl;
	this.EncodeUrlDelims = OutputEncode_EncodeUrlDelims;
	this.TruncateUrlSafe = OutputEncode_TruncateUrlSafe;
	this.SingleByteHex = OutputEncoder_SingleByteHex;
	this.TwoByteHex = OutputEncoder_TwoByteHex;
	this.AsUrl = OutputEncoder_AsUrl;
	this.QualifyUrl = OutputEncoder_QualifyUrl;
}

var IOSec = new OutputEncoder();



