//------------------------------------------------------------------------------
// JSWatson.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: cthota
//
// <header>	$JSWatson$</header>
//------------------------------------------------------------------------------
//Define JSWatson
function JSWatson()
{
}

JSWatson.Errors = new Array();
JSWatson.ErrorsToLog = new Array();
JSWatson.HandleError = function(error, source, line)
{
	try
	{
		if(error != null && error != "undefined")
		{
			var jswe = new JSWatsonError(error, source, line);
			JSWatson.Errors.push(jswe);
			JSWatson.ErrorsToLog.push(jswe);
			JSWatson.SetupLogging();
		}
		else
		{
			//Unknown error
		}
	}
	catch(err)
	{	
		alert(err.message);
	}
	finally
	{
		return true;
	}
}
//Wire-up logging
JSWatson.SetupLogging = function()
{
	JSWatson.logTimer = setInterval(JSWatson.Log,60000);
}
JSWatson.ClearLogging = function()
{
	if(JSWatson.logTimer)
		clearInterval(JSWatson.logTimer);
}

//Logs the errors
JSWatson.Log = function()
{
	try
	{
		if(JSWatson.ErrorsToLog == null ||
			JSWatson.ErrorsToLog.length <= 0)
		{
			return;
		}
		var len = JSWatson.ErrorsToLog.length;
		for(var i=0;i<len;i++)
		{
			var jswe = JSWatson.ErrorsToLog.pop();
			if(jswe != null)
				VE_Analytics.LogJSWatson(jswe.ToString());
		}
	}
	catch(err)
	{
		//Swallow
	}
	finally
	{
		//Clear logging
		JSWatson.ClearLogging();	
	}
}

//Shows the report of errors; to be used in debug mode
JSWatson.Show = function()
{
	alert(JSWatson.Report());
}

//Creates a report on existing errors
JSWatson.Report = function()
{
	var string = "";
	var counter = 0;
	try
	{
		string = "Total Errors: " + JSWatson.Errors.length + "\n";
		for(var i=0;i<JSWatson.Errors.length;i++)
		{
			counter = i + 1;
			string += "\n";			
			string += counter + ". ";
			string += JSWatson.Errors[i].ToString();
			string += "\n";
		}
	}
	catch(err)
	{
		string += "## JSWatson Error ##.";
	}
	
	return string;
}
//Gets the environment details for a given window
JSWatson.Environment = function()
{
	var string = "";
	if(navigator)
	{
		for(var property in navigator)
		{
			string += property + " : " + navigator[property] + "\n";
		}
	}
	else
	{
		string = "Unable to identify navigator.";
	}
	
	return string;
}
//Define JSWatsonError object
function JSWatsonError(message, source, line)
{
	this.Message = message;
	this.Source = source;
	this.LineNumber = line;
}
function ToString()
{
	return "Error: " + this.Message + "\n" + "Source: " + this.Source + "\n" + "Line: " + this.LineNumber;
}
JSWatsonError.prototype.ToString = ToString;
//End of JSWatsonError


//Wire-up the inevitable onerror on the current window
if(enableJSWatson && enableJSWatson == "1")
{
	window.onerror = JSWatson.HandleError;
}