//------------------------------------------------------------------------------
// JS/Main.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: cthota, sstchur, keithkin, a-pratin, a-jayab
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
var layers = new Array();
var state;
var usertype = 1;
var usertype_MSNRedirect = 2;

var printDirectionOption = null;

var printableDirectionsPage = "PrintableMap.aspx?mkt=" + locale;
// structure the printableDirection url
var lastfslash = window.location.pathname.lastIndexOf("/");
var hosturl = window.location.protocol+"//"+window.location.hostname+window.location.pathname.substring(0,lastfslash+1);
var printUrl = hosturl + printableDirectionsPage;

var executedPassportCallback;
var passportRelatedUICreated;
var passportSignedIn;
var passportReturned;

// Javascript entry point
// e - event
function Main() 
{
	windowWidth = GetWindowWidth();
	windowHeight = GetWindowHeight();
	scrollbarWidth = GetScrollbarWidth();
	
	state = new VE_State();	
	SetupSearchManager();	
	SetupTrafficManager();
	SetupAnalytics();
	
	// Commented out for now b/c IE does not handle this correctly
	//document.getElementById('what').select();	
	
	//attach onload event to the hiddenIframeForPrintDirections 	
	document.getElementById("hiddenIframeForPrintDirections").attachEvent("onload", hiddenIframeForPrintDirections_OnLoad );	
	
	//Check campaign
	window.setTimeout(CheckCampaign, 500);
	
	//Omniture logging for parameter
	OmnitureUrlParameterLogging();
}

function SetupSearchManager()
{
	var elm = document.getElementById("where");	
	elm.onpaste = VE_SearchManager.HandleOnPaste;	
}

function SetupTrafficManager()
{
	window.setTimeout(VE_TrafficManager.GetMarkets, 100);
}

function SetupDirections()
{
	document.getElementById("startAmbiguous").appendChild(VE_Directions.startAmbiguousSelect.GetElement());
	document.getElementById("endAmbiguous").appendChild(VE_Directions.endAmbiguousSelect.GetElement());
	
	VE_Directions.startAmbiguousSelect.Hide();
	VE_Directions.endAmbiguousSelect.Hide();	
	
	VE_Directions.startAmbiguousSelect.OnSelect = VE_Directions.ChooseStart;
	VE_Directions.endAmbiguousSelect.OnSelect = VE_Directions.ChooseEnd;
}

function SetupAnalytics()
{
	// Disable the omniture onclick event handler stuck to the body of the element.
	// This will get around the bug in their element type detection code.
	document.body.detachEvent("onclick", s.bc);

	// Set the flag on whether or not analytics is enabled.
	VE_Analytics.analyticsEnabled = state.GetAnalyticsEnabled();

	s.linkInternalFilters="javascript:,.msn.";
	s_account  = omnitureAccount;
	s.server   = location.hostname;
	s.pageName = "Home Page";
	s.channel  = "VirtualEarth";
	/* Product Name */
	s.prop1 = "VirtualEarth";
	/* Culture and Language */
	s.prop2 = window.locale;
	/* MapTheme */
	s.prop3 = "";
	/* ZoomLevel */
	s.prop4 = "";
	/* Region Code */
	s.prop5 = "";
	/* Navigation Action */
	s.prop6 = "";
	/* Navigation Control */
	s.prop7 = "";
	/* Search Keyword */
	s.prop8 = "";
	/* Search Location */
	s.prop9 = "";
	
	//add event listeners to map
	map.AttachEvent("onendzoom", VE_Analytics.LogZoom);
	map.AttachEvent("onendcontinuouspan", VE_Analytics.LogPan);
	map.AttachEvent("onobliquechange", VE_Analytics.LogResponseTimes);
	//log home page visit
	VE_Analytics.Log("VE | Home Page");
	
	
}
// Clean up
function Destroy()
{
	//log tile request statistics	
	VE_Analytics.LogResponseTimes();	
	VE_Analytics.LogScrachPadItems();
			
	state.StoreStateInCookies();	
	
	//Clean up the collections manager.
	VE_CollectionsManager.CleanUp();	
	
	VE_Directions.Destroy();	
	
	// detach onload event of the hiddenIframeForPrintDirections
	document.getElementById("hiddenIframeForPrintDirections").detachEvent("onload", hiddenIframeForPrintDirections_OnLoad );	
	
	try
	{	
		map.Destroy();
		map = null;	
	}
	catch(ex)
	{
		//swallow
	}
	
	if (window.dragController)
	{
		dragController.destroy();
		dragController = null;
	}

	if (window.scratchPad)
	{
		scratchPad.destroy();
		scratchPad = null;
	}
		
	if (window.ero)
	{
		ero.destroy();
		ero = null;
	}
	
	if (window.taskArea)
	{
		taskArea.destroy();
		taskArea = null;
	}
	
	//clean globals
	removeGlobals();
	
	//clear events
	removeListeners();
	
	//clean Traffic stuff
	try
	{
		VE_TrafficManager.Destroy();
	}
	catch(ex)
	{
		//swallow		
	}
	
	// In IE we can force a garbage collect
	try
	{
		CollectGarbage();
	}
	catch (ex)
	{
		// Ignore exception if browsers other than IE complain
	}

	
	return true;
}

// Handles all key presses not handled by controls.
function body_OnKeyDown(e)
{
	if (!e)
	{
		e = window.event;
	}
	
	switch (e.keyCode)
	{
		case 18: // alt			
			// If we are panning, stop panning if...
			if (map != null && map.panning && map.keyboardPan)
			{
				map.StopContinuousPan();
				return false;
			}
			break;
		case 27: // esc
			// stop panning
			if (map != null && map.panning)
			{
				map.StopContinuousPan();
			}
			
			// blur selection
			if (e.srcElement.blur)
			{
				e.srcElement.blur ();
			}
			// focus map
			document.getElementById ("wl_ve_mapInput").focus ();
			return false; 
			break;
		case 119: // f8
			var wwfWhere = document.wwf.where;
			var wwfWhat = document.wwf.what;
			// blur selection
			if (e.srcElement.blur)
			{
				e.srcElement.blur ();
			}
			if (e.srcElement == wwfWhere)
			{
				wwfWhat.focus ();
				wwfWhat.select ();
			}
			else
			{
				wwfWhere.focus ();
				if (wwfWhere.value != useCurrentViewText)
				{
					wwfWhere.select ();
				}
			}
			e.cancelBubble = true;
			return false;
			break;
		default:
			break;
	}
	
	return true;
}

window.onresize = function() 
{
	windowWidth = GetWindowWidth();
	windowHeight = GetWindowHeight();	
	
	checkNeedForLowResStylesheet(windowWidth, windowHeight);
	
	/*	Because IE incorrectly fires window.onresize event when the <body> element changes, we need to add a special check here
			to make sure the map exists at the time of this call (it is possible for this resize even to be called when users start
			with very very small browser windows) */	
	try
	{
		map.Resize();		// no parameters means 100% for height and width	
		ero.setBoundingArea(new Microsoft.Web.Geometry.Point(5, 5), new Microsoft.Web.Geometry.Point(document.body.clientWidth, document.body.clientHeight));	
		dragController.setBoundingArea(getVisibleMapRect());
	
		VE_Help.Redraw();
		taskArea.redraw();	
	}
	catch(everything) { }
}

function AddQueryToLink(a)
{
    var q = document.wwf.what.value;
    if (window.encodeURIComponent)
        q = encodeURIComponent(q);
    else
        q = "";

    if (a.href.indexOf('?') > -1)
        a.href = a.href + '&q=' + q;
    else
        a.href = a.href + '?q=' + q;
}

function resetWhereBox()
{
	var txtWhere = document.getElementById('where');	
	if (txtWhere.value != L_SearchUseCurrentViewText_Text)
	{
		txtWhere.value = L_SearchUseCurrentViewText_Text;		
		Msn.VE.Search.strLastWhere = '';		
	}
	
	setInactive(txtWhere);
	map.SetFocus();
}

function resetWhatBox()
{
	var txtWhat = document.getElementById('what');	
	txtWhat.value = L_MainWhatHelp_Text;
	setInactive(txtWhat);
	
	/* IE hack */
	if (document.all)
		txtWhat.blur();	
		
	if(VE_ScopingBar)
	{
		VE_ScopingBar.Hide();	
		dragController.setBoundingArea(getVisibleMapRect());
	}
}

function setActive(inputElem)
{
	// Class needs to be set on the containing div (the parent element)
	var parent = inputElem.parentNode;
	if (parent)
		parent.className = 'search activeSearch';
}

function setInactive(inputElem)
{
	// Class needs to be set on the containing div (the parent element)
	var parent = inputElem.parentNode;
	if (parent)
		parent.className = 'search inactiveSearch';
}

function fieldIsEmpty(field)
{
	return (field.value == '' || /^\s+$/.test(field.value));
}

function setActivePanel(className)
{
	/* sstchur:  This pushes the search POIs that are associated w/ the active panel to the top of the map's z-index */
	var pinClass = className.match(/\s*viewer|\s*search[1-9]/);																		// match either, '[ ]search1', '[ ]search2', '[ ]search3', or '[ ]viewer'	
	
	document.body.className = document.body.className.replace(/\s*viewer|\s*search[1-9]/, '');			// clear out the existing class that may have been applied to the mapDiv previously
	document.body.className += ' ' + pinClass;																											// append the class, (either 'search1', 'search2', 'search3', or 'viewer') to the map's DIV container (this is where all the magic happens)
}


// Generic function for opening a new window via javascript
// for the options variable, just pass a string of comma-delimited option names:
//  example: OpenNewWindow("http://site", "newWin", "toolbar, scrollbars, resizable", 500, 300);
//  Any option strings that you do not specifically pass will automatically be set to false
// Alternatively, pass the string "all" and all window options will be set to true
function OpenNewWindow(url, name, options, width, height, x, y)
{
	// If "all" is passed, all option strings will be passed to open function (making all true)
	var allOptionsTrue = "toolbar, location, directories, status, menubar, scrollbars, resizable";
	// Set window width and height. Default is width/height of parent window
	var winWidth = "width=" + (width > 0?width:GetWindowWidth()) + ", ";
	var winHeight = "height=" + (height > 0?height:GetWindowHeight()) + ", ";
	// Sets the xy position of where the window opens. If nothing passed 0,0 is the default.
	x = x?x:0;
	var winX = "screenX=" + x + ", left=" + x + ", ";
	y = y?y:0;
	var winY = "screenY=" + y + ", top=" + y;
	// Open the new window
	var newWindow = open(url, name, (options == 'all'?allOptionsTrue:options) + ", " + winWidth + winHeight + winX + winY);
	newWindow.focus();
}

function hiddenIframeForPrintDirections_OnLoad()
{		
	var iframeElement = document.getElementById("hiddenIframeForPrintDirections");
	if ( iframeElement.contentWindow.document.location.href == printUrl )
	{	
		//Expand the size of the hiddenIFrame
		iframeElement.style.width = "685";
		iframeElement.style.height = "600";	
		//Set focus and Invoke Print
		hiddenIframeForPrintDirections.focus();		
		hiddenIframeForPrintDirections.InvokeDirectPrintAction(printDirectionOption);					
	}		
}

function ResizeRightPanels()
{
	// sstchur:  There are no more "Right" panels to resize
	return;	
}

		
/*	sstchur:
		Global function: toggleTaskArea
		Purpose:  To show or hide the TaskArea and resize/reposition any elements that may be affected by showing or hiding the TaskArea */
		
		function toggleTaskArea(visible)
		{	
			// Shortcut the Microsoft.Web.Animation Namespace Chain
			var ani = Microsoft.Web.Animation;
			
			if (!visible)
				taRoller.rollIn(ani.RollDirection.RightLeft);
			else if (!taRoller.isExpanded())
				taRoller.rollOut(ani.RollDirection.LeftRight);
				
			dragController.setBoundingArea(getVisibleMapRect());

		}
		
		
/* sstchur:
		Global function :  taskAreaSlide
		Purpose:  To "slide" the TaskArea in or out automatically based on it's current staus */
		function taskAreaSlide(e)
		{
			if (e.srcElement && (e.srcElement.id != 'msve_TaskArea_transparency' && e.srcElement.id != 'glyph_taSlider'))
				return;
			
			toggleTaskArea(!taRoller.isExpanded());	
		}		
	

/* sstchur:
		Global functions:  pageInit
		Purpose:  This is the function that essentially gets the app going */
		function pageInit()
		{	
			VE_Passport.passportExpiredTime = new Date();
			VE_Passport.passportExpiredTime.setHours(VE_Passport.passportExpiredTime.getHours()+VE_Passport.maxPassportCookieAge); 
			// Constants
			window.REGEX_PUSHPIN_ID = /^(scratch){0,1}pin_([a-zA-Z0-9]+)_[a-zA-Z0-9]+$/;		// matches a valid pushpin ID
			executedPassportCallback = false;
			passportReturned = false;
			VE_Passport.CheckPassportSignedIn(
				function() 
				{
					passportSignedIn = true;
					passportReturned = true;
					OnPassportSignedIn();
					//Show Add Favorite Menu on collection viewer panel
					if(VE_CollectionsManager.Viewer)
					{
						VE_CollectionsManager.Viewer.EnableAddFavoriteMenu();
						VE_CollectionsManager.Viewer.HideCollectionViewerInfoBar();
					}
				}, 
				function()
				{
					passportSignedIn = false;
					passportReturned = true;
					OnPassportNotSignedIn();
					if(VE_CollectionsManager.Viewer)
					{
						VE_CollectionsManager.Viewer.DisableAddFavoriteMenu();
						VE_CollectionsManager.Viewer.ShowCollectionViewerInfoBar();
					}
				}); 
			passportRelatedUICreated = false;
			
			loadUI();
			setupGlobals();
			
			//At this point action menu is already created
			passportRelatedUICreated = true;
			if(passportReturned) 
			{
				if(passportSignedIn)
				{
					OnPassportSignedIn();
				} 
				else 
				{
					OnPassportNotSignedIn();
				}
			}
			setTrafficConstants();
			addListeners();
						
			// Go VE Go!			
			Main();
			createDashboardRoller();	// Create the Roller object that will be used to "roll/slide" the Dashboard in and out			
			if (checkNeedForLowResStylesheet(GetWindowWidth(), GetWindowHeight()))
			{
			 map.Resize();
			 taskArea.redraw();			 
			}
						
			// Tell the Task Area Roller (taRoller, created in setupGlobals()) object to take a few extra elements along for the ride
			taRoller.associate(new Array(mapActionBar, extraDiv1, document.getElementById('dashboard')));
			
			setupDraggableObjects();			

			// Make IE obey the :hover pseudo class for the MapActionBar, the ScratchPad's drop down menu, and the TaskArea slider glyph
			// Notes:  The pseudoHoverForChildren() and pseudoHover() functions are smart enough to bypass this for Mozilla
			var mapActionBar_menu = document.getElementById('msve_MapActionBar_menu');
			pseudoHoverForChildren(mapActionBar_menu);
			
			// Wireup a couple events to make the MapActionBar menu dismiss children when a sub item is clicked			
			mapActionBar_menu.attachEvent('onclick', mabDismissChildren);
			mapActionBar_menu.attachEvent('onmouseover', mabRevertDismissal);
			
			var scratchPad_menu = document.getElementById('scratchpad_menu');
			pseudoHoverForChildren(scratchPad_menu);
			if (scratchPad.getItems().getCount() > 0)
				scratchPad.show();
				
			var glyph = document.getElementById('glyph_taSlider');
			if (glyph) { pseudoHover(glyph); }
				
			
			//init scoping bar			
			VE_ScopingBar.Init("msve_ScopingBar_container");			
			
			
			// disable context menus
			disableContextMenus();
		}
		
/* a-jayab Setting Constants required for traffic set up */
	function setTrafficConstants()
	{		
		RegisterNamespaces('Msn.VE.UI');
		Msn.VE.UI.Color = {Red:"red", Orange:"orange", Yellow:"yellow"}
	}
	
/* sstchur:
	Global function: loadUI
	Purpose:  To build the UI for VE in a localized manner */
	function loadUI()
	{
		// set the Window Title
		//window.document.title = Msn.VE.Features.ProductName;
		
		window.document.title = "VE Flight101 Baby!";
		
		// set meta tag title content
		document.getElementById("msve_title").content = Msn.VE.Features.ProductName;
		// set meta tag description content
		document.getElementById("msve_description").content = L_MainMetaDescription_Text.replace(/%1/g,Msn.VE.Features.ProductName);

		var ui =		
		// Header Start		
		'<div class = "transparency_wrapper">' +
		'<div id = "msve_Header">' +
			'<span id = "msve_ProductLogo"></span>' +
			'<form id = "wwf" name = "wwf" method = "get" onsubmit = "return false;">' +
				'<fieldset>' +
					'<legend></legend>' +
						'<div class = "search inactiveSearch"><input id = "what" tabindex = "1" type = "text" value = "' + L_MainWhatHelp_Text + '" /></div>' +
						'<div class = "search inactiveSearch"><input id = "where" tabindex = "2" type = "text" value = "' + L_SearchUseCurrentViewText_Text + '" /></div>' +
						'<button id = "searchbttn" tabindex = "3" type = "submit"> </button>' +					
				'</fieldset>' +
			'</form>' +
						
			'<div id = "msve_Header_tools"></div>' +

			'<div id = "msve_ScopingBar_container"></div>' +			

		'</div>' +		
		'</div>' +		
		// Header End
		
		// TaskArea Start
		'<div id = "msve_TaskArea_positioner" class = "expanded">' +
			'<div id = "msve_TaskArea_transparency">' +
				'<div id = "msve_TaskArea_data"></div>' +				
			'</div>' +
			'<span id = "glyph_taSlider"></span>' +
		'</div>' +
		// TaskArea End

				
		// MapActionBar Start
		'<div id = "msve_MapActionBar" onselectstart = "return false;">' +
			'<ul id = "msve_MapActionBar_menu" class = "wll_dropDownMenu firstChild"></ul>' +
		'</div>' +
		// MapActionBar End
		
		// Footer Start		
		'<div id = "msve_Footer">' +
			'<ul id="msve_listOne" class = "listOne">' +
				'<li class = "firstChild">&copy; 2006 Microsoft Corporation</li>' +
			'</ul>' +
			
			'<ul id="msve_listTwo" class = "listTwo"><ul>' +
		'</div>' +
		// Footer End

		'<div id = "ExtraDiv1"></div>' +
		
		'<iframe name="hiddenIframeForPrintDirections" id="hiddenIframeForPrintDirections" src=""></iframe>' +
		
		// TODO:  See if this markup can be cleaned up at all...
		'<div id = "whereambiglist" tabIndex = "1000" onlosecapture = "HideAmbiguousList()" onkeydown = "keydown_Go(this);" style = "left: 288px; top: 117px; z-index: 200;"></div>' +
		'<iframe name = "hiddenframe" width = "1" height = "1" style = "z-index: 0;"></iframe>' +

		'<div id = "logging"></div>' +
		'<div id = "shareInIM" style = "visibility=hidden;">' +
		   '<iframe id= "shareInIMHiddenFrame" width = "0" height = "0" style = "z-index: 0;" frameborder="0" src=""></iframe>' +
		'</div>';
		
		var wll_body = document.getElementById('windows_live_local');		
		wll_body.innerHTML = ui;
		
		//Build Header tools item
		// Help link		
		var wll_Header = document.getElementById('msve_Header_tools');
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Header.Help ) )
		{
			var oNewItem = document.createElement('a');
			oNewItem.setAttribute('href','javascript:VE_Help.Open(\'' + L_Help_Text + '\', \'./help/' + window.locale +'/help.htm\'); VE_Analytics.LogHelp();');
			oNewItem.innerText = L_Help_Text;			
			BuildHeaderFooterItem( oNewItem , wll_Header);
			oNewItem = null;
		}		
		// Divider
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Header.Help ) && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Header.Settings ) )
		{
			var oNewItem = document.createElement('span');
			oNewItem.innerHTML = '&nbsp;&nbsp;|&nbsp;&nbsp;'; 
			BuildHeaderFooterItem( oNewItem, wll_Header);
			oNewItem = null;
		}
		// Settings link
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Header.Settings ) )
		{
			var oNewItem = document.createElement('a');
			oNewItem.setAttribute('href','javascript:OpenOptionsPanel();');
			oNewItem.innerText = L_Settings_Text;			
			BuildHeaderFooterItem( oNewItem , wll_Header );
			oNewItem = null;

			//set passport div
			if(passportLoginButtonHtml != null &&
				passportLoginButtonHtml.length > 0)
			{
				var oPassportItem = document.createElement('span');
				oPassportItem.innerHTML = "&nbsp;&nbsp;|&nbsp;&nbsp;" + passportLoginButtonHtml;
				BuildHeaderFooterItem( oPassportItem , wll_Header );
				oPassportItem = null;
			}
		}
		wll_Header = null;
		
		/* --- BEING BUILDING MAPACTIONBAR BASED ON MARKET -- */
		var wll_mapActionBar = document.getElementById('msve_MapActionBar_menu');
		
		// Welcome menu
		if (Msn.VE.Marketization.IsEnabled(Msn.VE.Features.MapAction.Welcome))
			BuildMapActionBarMenuItem(L_Welcome_Text, function() { VE_Help.OpenIntro(); }, wll_mapActionBar);
		
		// Collections menu
		if (Msn.VE.Marketization.IsEnabled(!Msn.VE.Features.MapAction.Collections.DisplayNone))		
		{
			var mabCollections = document.createElement('li');
			mabCollections.className = 'multiLevel';
			mabCollections.appendChild(document.createTextNode(L_Collections_Text));
			mabCollections.appendChild(document.createElement('span'));
			var mabCollectionsSubLinks = document.createElement('ul');
			mabCollections.appendChild(mabCollectionsSubLinks);
			wll_mapActionBar.appendChild(mabCollections);
						
			// Collections | Open
			if (Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Collections.Open))
				BuildMapActionBarMenuItem(L_MainOpen_Text, function() { VE_Scratchpad.Show(); VE_Analytics.Log('VE | Map Action Bar','Open Collections on map action bar'); }, mabCollectionsSubLinks, 'mab_CollectionsOpen');

			// Collections | New
			if (Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Collections.New))
				BuildMapActionBarMenuItem(L_MainNew_Text, function() 
				{ 
					VE_Scratchpad.Show(); 
					try
					{
						var id = parseInt(Math.random() * 10000);
						VE_CollectionsManager.CreateCollection (L_ScratchPadNewCollection_Text + ' ' + id,
																false, [], 0, null, window.locale);
					}
					catch(errorx)
					{
						ShowMessage(L_ErrorServerBusy_Text);					
					}										
					VE_Analytics.Log('VE | Map Action Bar','New Collection on map action bar'); 
				}, mabCollectionsSubLinks, 'mab_CollectionsNew');
				
			if (Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Collections.AddPushpin))
				BuildMapActionBarMenuItem( L_MainAddPushpinLink_Text , function() { VE_Annotations.AnnotateMapCenter(); VE_Analytics.Log('VE | Map Action Bar','Add Pushpin on map action bar'); }, mabCollectionsSubLinks );
				
			// My Favorite Collecitons menu	
			if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Collections.Favorites))
				BuildMapActionBarMenuItem( L_Favorites_Text , function() { VE_Favorites.GetFavorites(); VE_Analytics.Log('VE | Map Action Bar','Favorites on map action bar');  }, mabCollectionsSubLinks , 'mab_CollectionsFavorites');
		}
		
		//Driving Directions menu	
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.DrivingDirections ) )
			BuildMapActionBarMenuItem( L_Directions_Text , function(){VE_Directions.Show();}, wll_mapActionBar );			
		//
		
		// Traffic menu				
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Traffic ) )
			BuildMapActionBarMenuItem( L_Traffic_Text , function(){VE_Analytics.Log('VE | Map Action Bar','Traffic entry map action bar'); VE_TrafficManager.GetTrafficInfo(true);}, wll_mapActionBar );	
		//		
		
		// Map Tools | Locate Me
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.LocateMe ) )
			BuildMapActionBarMenuItem( L_MainLocateMeLink_Text , function() { AutoLocate(); VE_Analytics.LogLocate();}, wll_mapActionBar );
		//
			
		// Share menu
		if ( Msn.VE.Marketization.IsEnabled( !Msn.VE.Features.MapAction.Share.DisplayNone ) )
		{
			// Share menu item is unconditional; options under the share menu item are market specific
			var mabShare = document.createElement('li');
			mabShare.className = 'multiLevel';
			mabShare.appendChild(document.createTextNode(L_MainShare_Text));
			mabShare.appendChild(document.createElement('span'));
			var mabShareSubLinks = document.createElement('ul');
			mabShare.appendChild(mabShareSubLinks);
			wll_mapActionBar.appendChild(mabShare);
			
			// Share | Share In Messenger		
			if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Share.ShareInMessenger ) )
				BuildMapActionBarMenuItem( L_MainShareInMessengerLink_Text , function(){ShareInMessenger();VE_Analytics.Log('VE | Map Action Bar','Share In Messenger');}, mabShareSubLinks );
			//
			
			// Share | Email
			if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Share.EmailPermalink ) )
				BuildMapActionBarMenuItem( L_PermalinkEmail_Text , function(){EmailPermalink();}, mabShareSubLinks );
			//			
			
			// Share | Copy To Clipboard
			if ( document.all && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Share.CopyToClipboard ) )
				BuildMapActionBarMenuItem(L_MainShareCopyToClipboard_Text, function() { CopyPermalink();}, mabShareSubLinks);
			//
			
			// Share | Add Blog Entry
			if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Share.AddBlogEntry ) )
				BuildMapActionBarMenuItem( L_MainShareAddBlogEntry_Text , function(){VE_Scratchpad.Blog();}, mabShareSubLinks );
			
			// Share | View permalink Entry
			if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Share.ViewPermalink ) )
				BuildMapActionBarMenuItem(L_MainShareViewPermalink_Text, function(){ShowPermalinkPanel();}, mabShareSubLinks );
		}

		// Map Print menu should be visibile unconditionally
		var mabPrint = document.createElement('li');
		mabPrint.className = 'multiLevel';
		mabPrint.attachEvent('onmouseover', UpdatePrintMenuItems);
		mabPrint.appendChild(document.createTextNode(L_DirectionsPrint_Text));
		mabPrint.appendChild(document.createElement('span'));
		var mabPrintSubLinks = document.createElement('ul');
		mabPrint.appendChild(mabPrintSubLinks);
		wll_mapActionBar.appendChild(mabPrint);
		
		// Map Print | Print Maps & Directions
		if (Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.PrintDrivingDirections.MapsAndDirectionsOnly ))
			BuildMapActionBarMenuItem( L_DirectionsPrintMapsAndDirections_Text , function() { VE_Analytics.Log('VE | Map Action Bar', 'PrintTotal'); VE_Directions.InvokePrint( VE_Directions.PrintMapsAndDirections ); VE_Analytics.Log('VE | Map Action Bar','Print MapAndText on map action bar');}, mabPrintSubLinks, "PrintMapsPlus");
		
		// Map Print | Print Map Only
		if (Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.PrintDrivingDirections.MapsOnly ))
			BuildMapActionBarMenuItem( L_DirectionsPrintMapOnly_Text , function() { VE_Analytics.Log('VE | Map Action Bar', 'PrintTotal'); VE_Directions.InvokePrint( VE_Directions.PrintMapsOnly ); VE_Analytics.Log('VE | Map Action Bar','Print Map on map action bar');}, mabPrintSubLinks, "PrintMapsOnly");

		// Map Print | Print Text Directions	
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.PrintDrivingDirections.DirectionsOnly ) )
			BuildMapActionBarMenuItem( L_DirectionsPrintTextDirections_Text , function() { VE_Analytics.Log('VE | Map Action Bar', 'PrintTotal'); VE_Directions.InvokePrint( VE_Directions.PrintDirectionsOnly ); VE_Analytics.Log('VE | Map Action Bar','Print Text on map action bar');}, mabPrintSubLinks, "PrintTextOnly");
		
		// Map Print | Customizable Printing
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.PrintDrivingDirections.Customized ) )
			BuildMapActionBarMenuItem( L_DirectionsCustomizePrinting_Text , function() { VE_Analytics.Log('VE | Map Action Bar', 'PrintTotal'); VE_Directions.InvokeCustomizePrint(); VE_Analytics.Log('VE | Map Action Bar','Print Custom on map action bar');}, mabPrintSubLinks );
		
		var divClear = document.createElement('div');
		divClear.style.clear = 'both';
		wll_mapActionBar.appendChild(divClear);
		wll_mapActionBar = null;
		/* --- END BUILD MAPACTIONBAR --- */
		
		
		//Build FooterLeftItem based on Market
		// About link
		var wll_FooterLeft = document.getElementById('msve_listOne');
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.About ) )
		{
			var oNewItem = document.createElement('li');
			oNewItem.innerHTML = '<a href = "javascript:VE_Help.Open(\'' + L_MainAbout_Text + '\', \'Help/'+ window.locale +'/About.htm\'); VE_Analytics.LogAbout();">' + L_MainAbout_Text + '</a>';

			BuildHeaderFooterItem( oNewItem , wll_FooterLeft );			
			oNewItem = null;
		}
		// Privacy link
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Privacy ) )
		{
			var oNewItem = document.createElement('li');			
			oNewItem.innerHTML = '<a href = ' + privacyStatement + ' target = "_new">' + L_Privacy_Text + '</a>';
			BuildHeaderFooterItem( oNewItem , wll_FooterLeft );
			oNewItem = null;
		}
		// Developer link
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Developers ) )
		{
			var oNewItem = document.createElement('li');			
			oNewItem.innerHTML = '<a href = ' + developersLink + ' >' + L_MainDevelopers_Text  + '</a>';
			BuildHeaderFooterItem( oNewItem , wll_FooterLeft );
			oNewItem = null;
		}
		wll_FooterLeft = null;
		
		//Build FooterRightItem based on Market
		// Help link
		var wll_FooterRight = document.getElementById('msve_listTwo');
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Help ) )
		{
			var oNewItem = document.createElement('li');				
			oNewItem.innerHTML = '<a href = "javascript:VE_Help.Open(\'' + L_Help_Text + '\', \'./help/' + window.locale + '/help.htm\'); VE_Analytics.LogHelp();">' + L_Help_Text + '</a>';
			BuildHeaderFooterItem( oNewItem , wll_FooterRight );			
			oNewItem = null;
		}	
		// Divider
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Help ) && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Feedback ) )
		{
			var oNewItem = document.createElement('li');				
			oNewItem.innerText = '|';
			BuildHeaderFooterItem( oNewItem , wll_FooterRight );
			oNewItem = null;
		}
		// Feedback link
		if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Feedback ) )
		{
			var oNewItem = document.createElement('li');
			oNewItem.innerHTML = '<a href = "javascript:OnFeedbacklinkClicked();">' + L_Feedback_Text + '</a>';
			BuildHeaderFooterItem( oNewItem , wll_FooterRight );			
			oNewItem = null;
		}
		wll_FooterRight = null;
		
	}

	//Feedback link clicked
	function OnFeedbacklinkClicked()
	{
		var what = document.wwf.what.value;
		var where = document.wwf.where.value;
		if (what == L_MainWhatHelp_Text) what = '';
		if (where == L_SearchUseCurrentViewText_Text) where = '';
		
		var latlong = map.GetCenterLatitude() + '/' + map.GetCenterLongitude();
		
		var url = 'http://feedback.live.com/default.aspx?productkey=wlsearchlocal&local=' + locale +
		'&P2=' + IOSec.EncodeUrl(what) + '&P4=LIVE&P6=' + IOSec.EncodeUrl(where) +
		'&P9=' + latlong +'&searchtype=Local%20Search';	
		OpenNewWindow(url, 'CommunityPage', 'status,scrollbars,resizable', 800, 600, window.screenLeft, window.screenTop);		
		VE_Analytics.Log('VE | Community Page');
	}
	
	function BuildMapActionBarMenuItem( title, onClickEvent, containerElement, itemId )

	{	
		var oNewItem = document.createElement('li');
		if(itemId) 
		{
		   oNewItem.id = itemId;
		}

		if (onClickEvent)
			oNewItem.onclick = onClickEvent;
		oNewItem.innerText = title;
		containerElement.appendChild( oNewItem );
	}
	function BuildHeaderFooterItem( element, containerElement )
	{	
		containerElement.appendChild( element );
	}

	
/* sstchur:
		Global function;  setupGlobals
		Purpose:  To setup any variables that will be needed throughout the app on a global level */
	function setupGlobals()
	{	
		window.header = document.getElementById('msve_Header');
		window.footer = document.getElementById('msve_Footer');
		window.taskArea_positioner = document.getElementById('msve_TaskArea_positioner');
		window.taskArea_transparency = document.getElementById('msve_TaskArea_transparency');
		window.taskArea_data = document.getElementById('msve_TaskArea_data');					
		window.mapActionBar = document.getElementById('msve_MapActionBar');					
		window.extraDiv1 = document.getElementById('ExtraDiv1');		
		
		// TaskAreaManager object -- this is an abstract representation of the TaskAreaManager:  NOT a <div>
		window.taskArea = new VE_TaskAreaManager();
		taskArea.onremoveitem = function()
		{
			if (taskArea.isEmpty())
			{
				taRoller.LeaveAmount = 0;				
				toggleTaskArea(false);
				/*	Set focus on something germane (like the body) in case focus was on the what or when box
						when the user closed out all tasks.  Otherwise, there exists the potential that the user
						could 'select' the help text and that would not be good */
				document.body.focus();
				resetWhatBox();
			}
		}

		// Create a DraggableObjects Factory that will manage the creation (and destruction) of any draggable objects		
		window.dragController = new Microsoft.Web.UI.DragDrop.DragController();
		
		// Gets (and places on the page) a singleton instance of an Enhanced Rollover
		window.ero = ERO.getInstance();
		
		// Create a new ScratchPad object and define it's initial (unpopulated) presentation
		createScratchPad();		
		
		// Create the Roller object that will be used to "roll/slide" the TaskArea in and out
		createTaskAreaRoller();
	}
	
	function removeGlobals()
	{
		try
		{
			window.header = null;
			window.footer = null;
			window.taskArea_positioner = null;
			window.taskArea_transparency = null;
			window.taskArea_data = null;
			window.mapActionBar = null;
			window.extraDiv1 = null;
			window.taskArea = null;
			window.dragController = null;
			window.ero = null;
			window.scratchPad = null;
			window.taRoller = null;
		}
		catch(ex)
		{
			//Swallow
		}
	}
		
/* sstchur:
		Global function:	createScratchPad
		Purpose:	To create and define the initialize state of an unpopulates Scratchpad (menu options, collections, footer, etc...) */
		function createScratchPad()
		{
		
			//VE_CollectionsManager.CheckSignIn();
			
			window.scratchPad = new Microsoft.Web.VirtualEarth.Collections.ScratchPad('msve_ScratchPad');
								
			buildScratchPadHeader();
			buildScratchPadTitleList();
			buildScratchPadInfoBar();
			buildScratchPadMenuBar();			
			//buildScratchPadEmptyListContent();
			buildScratchPadItemTools();		
			buildScratchPadFooter();
			
			addScratchPadEventListeners();
			setScratchPadPseudoHover();									
			
			var scratchPad_element = scratchPad.getElement();
			
			// create the ScratchPad Roller
			window.spRoller = new Microsoft.Web.Animation.Roller(scratchPad_element);
			spRoller.AccFunction = AccelerationFunctions.CrazyElevator;
			spRoller.onafterrollin = function(_elem)
			{
				// Set the *CSS CLASS* appropriate for a "collapsed" version of the ScratchPad
				scratchPad.setCollapsed();
			};
			
			spRoller.onbeforerollout = function(_elem)
			{
				// Set the *CSS CLASS* appropriate for an "expanded" version of the ScratchPad
				scratchPad.setExpanded();
				dragController.setBoundingArea(getVisibleMapRect());
			};
			
			// Get the DOM Element that represents the ScratchPad and add it to the page
			document.body.appendChild(scratchPad_element);
		}
	
/* sstchur:
		Global function:	createTaskAreaRoller
		Purpose:	To create the Roller object that will be used to "roll/slide" the TaskArea in and out */
		function createTaskAreaRoller()
		{
			window.taRoller = new Microsoft.Web.Animation.Roller(taskArea_positioner, 10);			
			taRoller.AccFunction = AccelerationFunctions.CrazyElevator;
			taRoller.onafterrollin = function(_elem)
			{
				taskArea_positioner.className = 'collapsed';
				taRoller.LeaveAmount = 10;
			};
			
			taRoller.onafterrollout = function(_elem)
			{
				taskArea_positioner.className = 'expanded';
			};
		}
		
		function createDashboardRoller()
		{
			// create the Dashboard Roller
			var toggleGlyph = map.GetDashboard().GetHeader().lastChild;
			map.GetDashboard().ShowToggleGlyph();
			
			window.dbRoller = new Microsoft.Web.Animation.Roller(map.GetDashboard().GetElement());
			dbRoller.AccFunction = AccelerationFunctions.CrazyElevator;
			dbRoller.LeaveAmount = 17;
			
			dbRoller.onbeforerollin = function()
			{
				dbRoller.LeaveAmount = map.GetDashboard().GetHeader().offsetHeight + 1;
			};
			
			dbRoller.onafterrollin = function()
			{
				map.GetDashboard().GetElement().className = map.GetDashboard().GetElement().className.replace(/\s*expanded/g, '');
				map.GetDashboard().GetElement().className += ' collapsed';
			};
			
			dbRoller.onbeforerollout = function()
			{
				map.GetDashboard().GetElement().className = map.GetDashboard().GetElement().className.replace(/\s*collapsed/g, '');
				map.GetDashboard().GetElement().className += ' expanded';
			};
			
			
			toggleGlyph.onclick = function()
			{
				if (dbRoller.isExpanded())
					{ dbRoller.rollIn(Microsoft.Web.Animation.RollDirection.BottomUp); }
				else
					{ dbRoller.rollOut(Microsoft.Web.Animation.RollDirection.TopDown); }
			}
			
			toggleGlyph = null;
		}	
		

	

/* sstchur:
		Global function:  setupDraggableObjects
		Purpose:  To create any objects that will be perpetually draggable throughout the application.
		Notes:  Some objects get created and destroyed on demand, and if any of those "on-demand" objects need to be draggable, that will be taken care of on creation -- NOT in this function */
		function setupDraggableObjects()
		{	
			var sp = document.getElementById('msve_ScratchPad');
			var sp_dragArea = sp.firstChild.firstChild;
			dragController.makeDraggableObject(sp, sp_dragArea);
			dragController.setBoundingArea(getVisibleMapRect(), false);
		}
	
	
/* sstchur:
		Global function:  addListeners
		Purpose:  Wireup all needed events */
		function addListeners()
		{	
			// Window events
			window.attachEvent('onclick', function() { if (document.releaseCapture) document.releaseCapture(); });
			window.attachEvent('onkeydown', function() { return (body_OnKeyDown(event)); });

			// TaskArea Slider
			taskArea_transparency.attachEvent('onclick', taskAreaSlide);
			document.getElementById('glyph_taSlider').attachEvent('onclick', taskAreaSlide);
			
			// What and Where Box Events			
			var txtWhat = document.getElementById('what');
			var txtWhere = document.getElementById('where')
			
			txtWhat.attachEvent('onfocus', searchInputFocus);			
			txtWhat.attachEvent('onblur', searchInputBlur);
			txtWhere.attachEvent('onfocus', searchInputFocus);			
			txtWhere.attachEvent('onblur', searchInputBlur);
			
			function searchInputFocus(e)
			{
				var target = e.srcElement || e.target;		
				if (target.value == L_SearchUseCurrentViewText_Text || target.value == L_MainWhatHelp_Text)
				{
					target.value = '';
					SelectText(target, 0, 0);			// this fixes an IE bug
				}
				else
					target.select();
					
				setActive(target);																			
			}
			
			function searchInputBlur(e)
			{
				var target = e.srcElement || e.target;
				if (fieldIsEmpty(target))
				{
					if (target == txtWhat)
						resetWhatBox();
					else if (target == txtWhere)
						resetWhereBox();
				}
			}
			
			/* This one is temporary until we get the Shared Header implemeneted */
			document.getElementById('searchbttn').attachEvent('onclick', Search);
		}

		function removeListeners()
		{	
			try
			{
				// Window events
				window.detachEvent('onclick', function() { if (document.releaseCapture) document.releaseCapture(); });
				window.detachEvent('onkeydown', function() { return (body_OnKeyDown(event)); });
				
				// MapActionBar									
				mapActionBar.detachEvent('onmouseover', function() { mapActionBar.className += ' opaque'; });					
				mapActionBar.detachEvent('onmouseout', function() { mapActionBar.className = ''; });
				
				// TaskArea Slider
				taskArea_transparency.detachEvent('onclick', taskAreaSlide);
				document.getElementById('glyph_taSlider').detachEvent('onclick', taskAreaSlide);
				
				// What and Where Box Events
				var txtWhat = document.getElementById('what');
				var txtWhere = document.getElementById('where')
				txtWhat.detachEvent('onfocus', searchInputFocus);
				txtWhat.detachEvent('onclick', searchInputFocus);
				txtWhere.detachEvent('onfocus', searchInputFocus);
				txtWhere.detachEvent('onclick', searchInputFocus);
				
				/* This one is temporary until we get the Shared Header implemeneted */
				document.getElementById('searchbttn').detachEvent('onclick', Search);
			}
			catch(ex)
			{
				//swallow
			}
		}

		
/* sstchur:
		Global function:  getVisibleMapRect
		Purpose:  Get a Rectangle object representing the visiable map area */		
		function getVisibleMapRect()
		{
			var geo = Microsoft.Web.Geometry;
			var x1 = taRoller.isExpanded() ? taskArea_transparency.offsetWidth : taRoller.LeaveAmount;
			var y1 = header.offsetHeight + mapActionBar.offsetHeight;
			var x2 = document.body.clientWidth;
			var y2 = document.body.clientHeight - footer.offsetHeight;
			var rect = new geo.Rectangle(new geo.Point(x1, y1), new geo.Point(x2, y2));
			return rect;
		}
		
/* sstchur:
		Global function:  disableContextMenus
		Purpose:  Disable context menus for the map and the mapactionbar */
		function disableContextMenus()
		{
			var noContext = function(e)
			{
				// There are two exceptions:  the WHAT and the WHERE boxes
				var target = e.srcElement || e.target;
				if (target == document.getElementById('what') || target == document.getElementById('where'))
					e.returnValue = true;
				else
					e.returnValue = false;
			};
			
			document.attachEvent('oncontextmenu', noContext);
		}
		
/* sstchur:
		Global function:  mabDismissChildren
		Purpose:  Make the MAB more user-friendly by manually dismissing the sub-items when an option has been selected */
		function mabDismissChildren(e)
		{
			// Get a reference to the item that was clicked
			var target = e.srcElement || e.target;			
			
			/*	If the target item (item that was clicked) is a top-level menu item, then we DON'T want to dismiss
					the sub-options.  We can test for this by checking to see if the item has any child UL tags.  The presense
					of a UL tag underneath a top-level menu item indicates that there are sub-options.  In this case, we simply
					return from the function prematurely.
			*/
			if (target.getElementsByTagName('UL').length > 0)
				{ return; }
		
			var mab = document.getElementById('msve_MapActionBar_menu');
			if (!mab || typeof mab == 'undefined')
				{ return; }
				
			if (mab.className.indexOf('dismissChildren') == -1)
			{
				mab.className += ' dismissChildren';
				
				/* For IE Only (fire a synthetic event to "fool" IE into removing the ms_pseudoHover class) */				
				if (target && typeof target != 'undefined')
				{
					var parent = target.parentNode;
					if (parent && typeof parent != 'undefined' && typeof parent.fireEvent != 'undefined')
						{ parent.fireEvent('onmouseout'); }
				}
			}
		}
		
		function mabRevertDismissal(e)
		{
			var mab = document.getElementById('msve_MapActionBar_menu');
			if (!mab || typeof mab == 'undefined')
				return;

			if (mab.className.indexOf('dismissChildren') != -1)
				{ mab.className = mab.className.replace(/\s*dismissChildren/g, ''); }
		}
		
		
/* sstchur:
		Global function: checkNeedForLowResStylesheet
		Purpose:  Check to see if the browser window has been resized smaller than the minimum allowable width and height, and if so,
							apply a special low-resolution stylesheet */
		function checkNeedForLowResStylesheet(width, height)		
		{
			var MINWIDTH = 790;
			var MINHEIGHT = 550;
			
			var bNeeded = false;
			
			// NOTE:  Valid only for IE5+ and W3C Browsers
			var htmlElement = document.documentElement;
			
			if (width <= MINWIDTH)
			{
				bNeeded = true;
				if (htmlElement.className.indexOf('lowResX') == -1)
					{ htmlElement.className += ' lowResX'; }
			}
			else
				{ htmlElement.className = htmlElement.className.replace(/\s*lowResX/g, ''); }
				
			if (height <= MINHEIGHT)
			{
				bNeeded = true;
				if (htmlElement.className.indexOf('lowResY') == -1)
					{ htmlElement.className += ' lowResY'; }
			}
			else
				{ htmlElement.className = htmlElement.className.replace(/\s*lowResY/g, '');	}
				
			return bNeeded;
		}
		
		
		function pinToTop(pinId)
		{
			var pin = document.getElementById(pinId);
			if (typeof pin != 'undefined')
			{
				if (pin.className.indexOf('topMost') == -1)
					pin.className += ' topMost';		
			}				
		}

		function revertPin(pinId)
		{
			var pin = document.getElementById(pinId);			
			if (typeof pin != 'undefined')
				pin.className = pin.className.replace(/\s*topMost/g, '');
		}	
	
	
	//cthota - Integrate from FEB release
	function CheckCampaign()
	{
		var urlParameters = GetUrlParameters();
		var cid = "";	
		for (var i = 0; i < urlParameters.length; i += 2)
		{	
			if ( urlParameters[i].toLowerCase() == "s_cid")
			{
				cid = urlParameters[i+1] ;
				VE_Analytics.SetCampaignId(cid);
				break;			
			}
		}

	}
	
	function isFileExistOnServer(paramWelcome)
	{
		var defaultWelcomeUrl = "Help/" + window.locale + "/Intro.htm" ;
		var fileSpecificWelcomeUrl = "Help/" + window.locale + "/Intro_" + paramWelcome + ".html" ;		
		var helpFileExist_xmlhttp = GetXmlHttp();
		
		if( helpFileExist_xmlhttp )
		{	
			var fileExistFlag = false;
			
			helpFileExist_xmlhttp.open("GET", GetUrlPrefix() + fileSpecificWelcomeUrl, true);
			helpFileExist_xmlhttp.onreadystatechange= function () 
			{		
				if( helpFileExist_xmlhttp.readyState == 4 )
					{
						if( helpFileExist_xmlhttp.status == 200 ) 
							fileExistFlag = true; 
					}
			};		
			helpFileExist_xmlhttp.send(null);	
			
			if(fileExistFlag) return fileSpecificWelcomeUrl;
			else return defaultWelcomeUrl;
		}
		else return defaultWelcomeUrl;
	}
	
	//Build Welcome link 
	function BuildWelcomeLink()
	{
		// Check on special behaviors for URL parameters
		var urlParameters = GetUrlParameters();	
		var paramMsnCulture;
		var paramMsnUrl;
		var paramWelcome;
		
		for (var i = 0; i < urlParameters.length; i += 2)
		{	
			switch ( urlParameters[i].toLowerCase() )
			{
				case "msnculture" :
					paramMsnCulture = urlParameters[i+1];
					break;
				case "msnurl" :
					paramMsnUrl = urlParameters[i+1];
					break;
				case "wip" :				
					paramWelcome = urlParameters[i+1] ;
					break;	
			}
		}
		
		//validate wip to be a numeric value between 2-100 ( 1 is reserved for default )
		try
		{
			paramWelcome = IOSec.AsNumeric( paramWelcome ) ;
			if (!( 1 < paramWelcome &&  paramWelcome < 101 ))
				paramWelcome = null;			
		}
		catch(ex)
		{
			paramWelcome = null;
		}		
		
		//set the global usertype variable 
		if ( paramWelcome != null )
			usertype = paramWelcome;
			
		// build the Welcome Url
		welcomeUrl = ( paramWelcome == undefined || paramWelcome == null ) ? "Help/" + window.locale + "/Intro.htm" : isFileExistOnServer(paramWelcome) ;
		
		//rebuild msnMapQuerString and build the msnMapRedirectPath Url only if coming from MSN maps and directions
		if ( paramWelcome == usertype_MSNRedirect ) 
		{
			msnMapQueryString = "wip=" + paramWelcome;
			if ( paramMsnCulture != undefined )		
				msnMapQueryString += "&msnculture=" + IOSec.EncodeUrl(paramMsnCulture);
			if ( paramMsnUrl != undefined )
				msnMapQueryString += "&msnurl=" + IOSec.EncodeUrl(paramMsnUrl);
			
			paramMsnUrl = ( paramMsnUrl == undefined )? "home.aspx" : paramMsnUrl ;
			msnMapRedirectPath = GetMsnRedirectPath( ( paramMsnCulture == undefined )? "en-us" : paramMsnCulture ) + "/" + paramMsnUrl;
		}
		
	}
	function OnPassportSignedIn()
	{
		if((!executedPassportCallback) && passportRelatedUICreated && passportReturned)
		{
			executedPassportCallback = true;
			
			// MAB:  Show Collections | New
			var newMenu = document.getElementById('mab_CollectionsNew');
			if(newMenu)
				newMenu.style.display = 'block';				
				
			// MAB:  Show Collections | Favorites
			var favoriteMenu = document.getElementById('mab_CollectionsFavorites');
			if(favoriteMenu)
				favoriteMenu.style.display = 'block';
			
			VE_CollectionsManager.CheckingSignIn = false;		
			VE_CollectionsManager.OnSignIn();
			// Calling the retrieve all collections to populate the 
			// the list of collections. 
			VE_CollectionsManager.RetrieveAllCollections(window.locale);			
		}
	}	
	function OnPassportNotSignedIn()
	{
		if(!executedPassportCallback && passportRelatedUICreated && passportReturned)
		{
			executedPassportCallback = true;
			
			// MAB:  Hide Collections | New
			var newMenu = document.getElementById('mab_CollectionsNew');
			if(newMenu)
				newMenu.style.display = 'none';
				
			// MAB:  Hide Collections | Favorites
			var favoriteMenu = document.getElementById('mab_CollectionsFavorites');
			if(favoriteMenu)
				favoriteMenu.style.display = 'none';

			VE_CollectionsManager.CheckingSignIn = false;			
			VE_CollectionsManager.OnSignOut();
		}
	}			
	
	function OmnitureUrlParameterLogging()
	{
		var urlParameters = GetUrlParameters();			
		
		for (var i = 0; i < urlParameters.length; i += 2)
		{	
			switch ( urlParameters[i].toLowerCase() )
			{
				case VE_State.ItemCollectionId:									
						window.setTimeout( "VE_Analytics.Log('VE | URL API','CID Parameter') ", 2000 );	
						break;
				default:
					break;	
			}
		}			
	}	

	function UpdatePrintMenuItems(e)
	{
		if (!map)
			return;

		// Step 1: Are there valid pushpins?
		var hasValidPushpins = false;
		var pushpins = map.GetPushpins();
		if (pushpins)
		{
			for(var i=0; i<pushpins.length && !hasValidPushpins; ++i)
			{
				// Exclude pushpins we don't necessarily print
				if (0 > pushpins[i].pin.className.indexOf("VE_Pushpin_context") &&
					0 > pushpins[i].pin.className.indexOf("VE_Traffic") &&
					pushpins[i].pin.id != "veDD_tempStart_pinDiv" &&
					pushpins[i].pin.id != "veDD_tempEnd_pinDiv")
				{
					hasValidPushpins = true;
				}
			}			
		}

		// Step 2: Is the map oblique?
		var isObliqueMap = (map.GetMapStyle() == "o");
		
		// Step 3: Figure out display values
		var mapsPlusDisplay = isObliqueMap || !hasValidPushpins ? 'none' : 'block';
		var mapsOnlyDisplay = isObliqueMap ? 'none' : 'block';
		var textOnlyDisplay = !hasValidPushpins ? 'none' : 'block';
		
		// Step 4: Update the Map Action Bar Print Menu
		var printMapsPlus = document.getElementById("PrintMapsPlus");
		var printMapsOnly = document.getElementById("PrintMapsOnly");
		var printTextOnly = document.getElementById("PrintTextOnly");
		
		if (printMapsPlus)
			printMapsPlus.style.display = mapsPlusDisplay;
		if (printMapsOnly)
			printMapsOnly.style.display = mapsOnlyDisplay;
		if (printTextOnly)
			printTextOnly.style.display = textOnlyDisplay;
		
		// Step 5: Update the Driving Directions Print Menu
		var ddMapsPlus = document.getElementById("DDMapsPlus");
		var ddMapsOnly = document.getElementById("DDMapsOnly");
		var ddTextOnly = document.getElementById("DDTextOnly");

		if (ddMapsPlus)
			ddMapsPlus.style.display = mapsPlusDisplay;
		if (ddMapsOnly)
			ddMapsOnly.style.display = mapsOnlyDisplay;
		if (ddTextOnly)
			ddTextOnly.style.display = textOnlyDisplay;
	}
