//------------------------------------------------------------------------------
// MapControl/Browser.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Eshinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Returns the event object
function GetEvent(e)
{
	return e ? e : window.event;
}

// Cancels an event
function CancelEvent(e)
{
	e.cancelBubble = true;
}

// Ignore a mouse event.  This can be used for any event handler that is not
// supposed to be bubbled up to the parent.
function IgnoreEvent(e)
{
	e = GetEvent(e);
	CancelEvent(e);
	return false;
}

// Returns the X position of the mouse when the event was fired.
function GetMouseX(e)
{
	var posX = 0;
	if (e.pageX)
	{
		posX = e.pageX;
	}
	else if (e.clientX)
	{
		if (document.documentElement && document.documentElement.scrollLeft)
		{
			posX = e.clientX + document.documentElement.scrollLeft;
		}
		else if (document.body)
		{
			posX = e.clientX + document.body.scrollLeft;
		}
	}

	return posX;
}

// Returns the Y position of the mouse when the event was fired.
function GetMouseY(e)
{
	var posY = 0;
	if (e.pageY)
	{
		posY = e.pageY;
	}
	else if (e.clientY)
	{
		if (document.documentElement && document.documentElement.scrollTop)
		{
			posY = e.clientY + document.documentElement.scrollTop;
		}
		else if (document.body)
		{
			posY = e.clientY + document.body.scrollTop;
		}
	}

	return posY;
}

// Returns the delta when the mouse wheel is scrolled.
function GetMouseScrollDelta(e)
{
	if (e.wheelDelta) // IE
	{
		return e.wheelDelta; 
	}
	else if (e.detail) // mozilla
	{
		return -e.detail; // deltas are the opposite of IE's.
	}
	return 0;
}

// Returns the target of the event
function GetTarget(e)
{
	if (!e)
	{
		e = window.event;
	}
	
	var t = null;
	if (e.srcElement)
	{
		t = e.srcElement;
	}
	else if (e.target)
	{
		t = e.target;
	}
	
	// defeat Safari bug
	if (t && t.nodeType)
	{
		if (t.nodeType == 3)
		{
			t = targ.parentNode;
		}
	}
	
	return t;
}

// Gets left position of element
function GetLeftPosition(el) 
{
    var offsetTrail = el;
    var offsetLeft = 0;
    while (offsetTrail) 
    {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTrail = offsetTrail.offsetParent;
    }
    
    if (navigator.userAgent.indexOf("Mac") != -1 && typeof(document.body.leftMargin) != "undefined") 
    {
        offsetLeft += document.body.leftMargin;
    }
    
    return offsetLeft;
}

// Gets top position of element
function GetTopPosition(el) 
{
    var offsetTrail = el;
    var offsetTop = 0;
    while (offsetTrail) 
    {
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    
    if (navigator.userAgent.indexOf("Mac") != -1 && typeof(document.body.topMargin) != "undefined") 
    {
        offsetTop += document.body.topMargin;
    }
    
    return offsetTop;
}
