//------------------------------------------------------------------------------
// MapControl/Matrix.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Multiplies two matrices.  Returns the result of the multiplication
// if the matrices are compatible or null otherwise.
function MatrixMultiply(a, b)
{
	// If the either of the matrices are null or the dimensions are incompatible, 
	// return null
	if (!a || !b || a[0].length != b.length)
	{
		return;
	}
	
	// Calculate the dimensions of the new matrix
	var height = a.length;
	var width = b[0].length;
	
	// Create a 2d array for the new values
	var result = new Array(height);
	
	// The inside shared dimension
	var z = b.length;
	
	for (var i=0; i<height; i++)
	{
		result[i] = new Array(width);
		
		for (var j=0; j<width; j++)
		{
			result[i][j] = 0;
			
			for (var k=0; k<z; k++)
			{
				result[i][j] += a[i][k] * b[k][j];
			}
		}
	}
	
	return result;
}
