//------------------------------------------------------------------------------
// MapControl/Zoom.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Sets the zoom level.  This is a simple wrapper around SetCenterAndZoom which 
// uses the existing center point.
function SetZoom(zoomLevel)
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(zoomLevel);
	SetView(view);
}

// Simple wrapper around SetZoom, which zooms in by one.
function ZoomIn()
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(currentView.zoomLevel + 1);
	SetView(view);
}

// Simple wrapper around SetZoom, which zooms out by one.
function ZoomOut()
{
	var view = preferredView.MakeCopy();
	view.SetZoomLevel(currentView.zoomLevel - 1);
	SetView(view);
}

// Change the zoom level
// If the requested zoom is within 1 zoom level of the current and animated 
// zoom is enabled, this will start a thread to do the animation.
// Otherwise, this will just swap in new tiles for old tiles
function SetCenterAndZoom(latitude, longitude, zoomLevel)
{
	var view = preferredView.MakeCopy();
	view.sceneId = null;
	view.SetCenterLatLong(new Msn.VE.LatLong(latitude, longitude));
	view.SetZoomLevel(zoomLevel);
	SetView(view);
}
