//------------------------------------------------------------------------------
// Permalink.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Codye
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Collects the permalink data and displays the panel.
function ShowPermalinkPanel()
{
	var p = VE_Help.helpPanel;
	var l = state.GetPermalink();
	l = IOSec.TruncateUrlSafe ( l, 2020 );
	
	var html = "<div class=\"VE_Permalink\"><h1>" + L_PermalinkContentTitle_Text.replace(/%1/g,Msn.VE.Features.ProductName) +"</h1><p>" + L_PermalinkContent_Text.replace(/%1/g,Msn.VE.Features.ProductName) + "</p><br>";
	html += "<center><a href=\"" + l + "\" >" + l + "</a><br><br>";
	
	// Only add the bookmark link if the browser has that functionality.
	if(window.external)
	{
		html += "<a href=\"javascript:BookmarkPermalink();\">" + L_PermalinkBookmark_Text + "</a> &nbsp; &nbsp; ";
	}
	
	// Every browser can send email
	html += "<a href=\"javascript:EmailPermalink();\">" + L_PermalinkEmail_Text + "</a> &nbsp; &nbsp; ";
	
	// Only add the copy link if the browser has that functionality.
	if(window.clipboardData)
	{
		html += "<a href=\"javascript:CopyPermalink();\">"+ L_PermalinkCopyToClipboard_Text +"</a>";
	}
	
	html += "</center></div>";
	
	// Show the panel
	p.SetTitle( L_Permalink_Text );
	p.SetBody(html);
	
	p.Show();
    
    //VE_Help knows how much space can be given to the help panel. Add the following line to fix bug #3532
    VE_Help.Redraw();
	
	
	VE_Analytics.Log("VE | Permalink Pane","Permalink");
}

// Adds a bookmark to the current permalink
function BookmarkPermalink()
{
	if(window.external)
	{
		window.external.AddFavorite(state.GetPermalink(), Msn.VE.Features.ProductName );
	}
	VE_Analytics.Log("VE | Permalink Pane","Boomark");
}

// Emails the permalink
function EmailPermalink()
{
	var subject = escape(Msn.VE.Features.ProductName);
	var body = escape( Msn.VE.Features.ProductName + "\n" + state.GetPermalink());		
	var tmp = window.open("mailto:?subject=" + subject + "&body=" + body);
	if (tmp)
		tmp.close();
	VE_Analytics.Log("VE | Permalink Pane","Email");
}

// Copies the permalink string into the clipboard
function CopyPermalink()
{
	if(window.clipboardData)
	{
		window.clipboardData.setData('Text', state.GetPermalink());
		VE_Analytics.Log("VE | Permalink Pane","Copy to Clipboard");
	}
}