//------------------------------------------------------------------------------
// Search/SearchPopup.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, sstchur, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// A reference to the one popup window
VE_SearchManager.popup = null;

// A reference to the entity that the popup is for
VE_SearchManager.popupEntity = null;

// A reference to the pushpin for the popup
VE_SearchManager.popupPushpin = null;

// The original z-index of the popup pushpin.
VE_SearchManager.popupPushpinOrigZIndex;

// popup panel z-index.
VE_SearchManager.popupZIndex = 21;

// id we use to keep track of which search or scratchpad entity the pop-up currently belongs to
VE_SearchManager.popupID;

// The default popup size.
VE_SearchManager.defaultPopupWidth = 200;

// The LatLong associated with the VE_SearchManager
// Note: this LatLong storage mechanism is required for pictometry contractual purposes
// We legally cannot show lat/long coordinates on the status bar in birdseye mode.
VE_SearchManager.LatLong = null;

VE_SearchManager._GetEntityReference=function(e, target) 
{
	var returnValues = new Array();
	if(!e)
	{
		e = window.event;
	}
		
	var t = target;
	if (!t)	
		t = GetTarget(e);
		
	if(!t)
	{
		return;
	}
	
	var id = t.id;
	
	// Based on the pin ID, determine which entity.
	var a = id.indexOf('_');
	var b = id.lastIndexOf('_');
	
	returnValues[0] = id.substr(a+1, b-a-1);
	returnValues[1] = id.substr(b+1, id.length-b);	
	return (returnValues);
}

// Show a popup for a search result
VE_SearchManager._ShowSearchPopup=function(e, searchIndex, entityID, dockElement)
{
	//if (VE_Annotations.PanelOpen || VE_ContextMenu.MenuOpen)
	//	return;
	if (VE_ContextMenu.MenuOpen) 
	{
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
	}
	
	//Fix: Bug 3909
	//Do not close the Annotations Panel because it is annoying if the 
	//user clicks on Add Pushpin and then hovers over a pin on the way to the panel
	//VE_ContextMenu.RemoveContextPin ();
	//VE_Annotations.ClosePanel ();
	
	var target = GetTarget(e);

	if(!searchIndex && !entityID)
	{
		var returnArray = VE_SearchManager._GetEntityReference(null, target);
		if (!returnArray)
			return;
			
		searchIndex = returnArray[0];
		entityID = returnArray[1];	
	} 
		
	// Based on the search index and entity ID, find the result object
	var s = VE_SearchManager.FindByIndex(searchIndex);
	var r = s.GetEntity(entityID);

	//Set the LatLong for the current Search Manager instance
	// Note: this LatLong storage mechanism is required for pictometry contractual purposes
	// We legally cannot show lat/long coordinates on the status bar in birdseye mode.
	VE_SearchManager.SetLatLong(r.latitude, r.longitude);

	var content = VE_SearchManager.CreatePopupContent(r, true, searchIndex);	
	ero.setContent(content);	
	
	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{
 		if (VE_Click2Call.isAllowedCountry(r.country))
 		{
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.SearchResultERO);
 			Click2Call.CreateRenderWidget('mpc.' + entityID + '@search.msn.com', 'c2c');
		}
 	}

	if (!dockElement)
		dockElement = target;
		
	if (dockElement.tagName != 'H3')
		ero.dockToElement(dockElement);						// dock ERO to the POI icon in the SearchResults list (or possibly, a POI on the map)
	else
		ero.dockToText(dockElement, e);						// dock ERO to the Title link in the SearchResults list

}


// Show a popup for a scratchpad entity
VE_SearchManager._ShowScratchpadPopup=function(e, entityID, type)
{
	if (VE_ContextMenu.MenuOpen) 
	{
		VE_ContextMenu.RemoveContextPin();
		VE_ContextMenu.CloseMenu();
	}
	
	// close the annotations panel if it's open
	VE_ContextMenu.RemoveContextPin ();
	VE_Annotations.ClosePanel ();
	
	// Do not show a popup if the map is working
	if (map.panning || map.zooming)
		return;
		
	// If the entityID was not provided, decipher it from the source element
	if (!entityID)
	{
		var returnArray = VE_SearchManager._GetEntityReference(e);
		if (!returnArray) 		
			return;
					
		entityID = returnArray[0];
		type = returnArray[1];
	}
	
	// Based on the entity ID, find the result object
	var r = VE_Scratchpad.GetEntity(entityID, type);
	if (!r || r == VE_SearchManager.popupEntity)	
		return;

	var pin = document.getElementById(VE_Scratchpad.GeneratePinId(r));
	var content = type == 'yp' ? VE_SearchManager.CreatePopupContent(r, false) : VE_Annotations.CreatePopupContent(pin);
	ero.setContent(content);
	
	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{	
 		if (type == 'yp' && VE_Click2Call.isAllowedCountry(r.country))
 		{
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.BusinessListingERO);
 			Click2Call.CreateRenderWidget('mpc.' + entityID + '@search.msn.com', 'c2c');
 		}
 	}	
 	
	ero.dockToElement(pin);
	return;
}

// Creates the html content inside the popup that is shown when hovering over map icons or clicking on search result or scratchpad links
VE_SearchManager.CreatePopupContent=function(r, scratchpadLink, searchIndex)
{
	var poiType = r.type;
	var poiName = r.name;
	var poiAddress = r.description == '' ? poiName : r.description;
	var poiPhone = r.phone;
	var escapedID = escape(r.GetSerializedId());	
	var body = escape(poiName + "\n" + poiAddress + "\n" + GetUrlPrefix() + "?v=" + state.GetCurrentUrlApiVersion() + "&sp=" + escapedID + "\n\n");
	var spItemId = 'scratchpin_' + r.id + '_yp';
	
	var spItem = scratchPad.getItems().retrieveByKey(spItemId);
	
	var content =
	'<div class = "title">%IMG%' + IOSec.EncodeHtml(poiName) + '</div>' +
	'<div class = "intro">' + IOSec.EncodeHtml(poiAddress) + '<br />' + poiPhone +
	'<div id="c2c"></div></div>';
	
	ero.clearActions();	
	
	// Add To Collection Action
	if (scratchpadLink && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.Collections ) )
		ero.addAction('<a href = "javascript:VE_Scratchpad.AddSearchResult(' + searchIndex + ', \'' + r.id + '\');" class = "VE_Panel_sublink" oncontextmenu = "return false;">' + L_SearchPopupAddToScratchPad_Text + '</a>');	
	else
	{
		var editLink = 'javascript:VE_Analytics.Log(\'VE | ERO\',\'Edit Pushpin\');VE_Annotations.OpenPanelEX(\'' + spItemId + '\',\'' + VE_Annotations.PanelColor + '\',\'' + VE_Annotations.EditTitle + '\')';
		var delLink = 'javascript:VE_Analytics.Log(\'VE | ERO\',\'Delete Pushpin\');scratchPad.removeItem(scratchPad.getItems().retrieveByKey(\'' + spItemId  + '\'))';
		
		var editDelLink = '<a href = "' + editLink + '">' + L_AnnotationPopupEdit_Text + '</a>';
		
		editDelLink += ' ' + L_Or_Text + ' ' +	'<a href = "' + delLink + '">' + L_AnnotationPopupDelete_Text + '</a>';
		
		//Edit or Delete Action
		ero.addAction(editDelLink);
	}
	
	// Drive from / to Action
	if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MapAction.DrivingDirections ) )
	{
		var driveAction =
		'<a href = "' + VE_SearchManager._GenerateDriveFrom(poiAddress) + '; VE_Analytics.Log(\'VE | Push Pin Popup\', \'Get Directions\');" class = "VE_Panel_sublink">' + L_SearchPopupDriveFrom_Text + '</a>' +
		' ' + L_Or_Text + ' ' +
		'<a href = "' + VE_SearchManager._GenerateDriveTo(poiAddress) + '; VE_Analytics.Log(\'VE | Push Pin Popup\', \'Get Directions\');" class = "VE_Panel_sublink">' + L_SearchPopupDriveTo_Text + '</a>';
		ero.addAction(driveAction);	
	}
		
	// Email Action
	if (escapedID && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.SendEmailOnSearchItem ) )	
		ero.addAction('<a href = "mailto:?subject=' + escape(L_AtWindowsLiveLocal_Text.replace('%1', poiName).replace(/%2/g,Msn.VE.Features.ProductName)) + '&body=' + body + '" onclick = "VE_Analytics.Log(\'VE | Push Pin Popup\', \'Email\');" class = "VE_Panel_sublink" oncontextmenu = "return false;">' + L_SearchPopupEmailAFriend_Text + '</a>');

	// Zoom to [ city | street ] level
	ero.addAction(VE_SearchManager.PopupZoomContent());
	
	// Details Actions
	if (poiType == 'yp' && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.DetailsOnSearchItem ) )
	{
		var windowW = 775;
		ero.addAction('<a href = "javascript:OpenNewWindow(\'' + GetUrlPrefix() + 'details.aspx?dt=yp.' + r.id + '&style=' + map.GetMapStyle() + '\', \'Detail' + r.id + '\', \'all\', ' + windowW + ', 500, 200, 200); VE_Analytics.Log(\'VE | Push Pin Popup\', \'Get Details\');" class = "VE_Panel_sublink" oncontextmenu = "return false;">' + L_SearchPopupDetails_Text + '</a>');
	}
	
	if(spItem)
	{
		//More info url
		if(spItem.getInfoUrl() && spItem.getInfoUrl() != 'undefined' && spItem.getInfoUrl().length > 0)
		{

			var url = spItem.getInfoUrl();
			
			try
			{
				url = VE_CollectionsManager.GetValidatedUrl(url);
			}
			catch(exp)
			{
				url = "";
			}
					
			if(url != null || url != "undefined")
				url = IOSec.EncodeUrl(url);			

			ero.addAction('<a href = "javascript:OpenNewWindow(\'' + url + '\', \'Information'  + '\', \'all\', ' + windowW + ', 500, 200, 200); VE_Analytics.Log(\'VE | Push Pin Popup\', \'More Information\');" class = "VE_Panel_sublink" oncontextmenu = "return false;">' + L_AnnotationPopupMoreInfo_Text + '</a>');
		}
		
		if(spItem.getPhotoUrl() && spItem.getPhotoUrl() != 'undefined' && spItem.getPhotoUrl().length > 1)
		{

			var purl = spItem.getPhotoUrl();						
			try
			{
				purl = VE_CollectionsManager.GetValidatedUrl(spItem.getPhotoUrl());
			}
			catch(errorx)
			{
				purl = "";
			}
		
			var purl1 = IOSec.EncodeUrl(purl);															
			//start html content 							
			var htmlContent = "<a href=\"javascript:OpenNewWindow('%P1%', '_blank' , 'menubar=0,resizable=1,scrollbars=0,status=0,titlebar=0,toolbar=0', 800, 600, 200, 200);\">";
			htmlContent = htmlContent.replace(/%P1%/g,purl1);		
			//Create image content and encode it
			var imgContent = "<IMG border=0 id=eroImg_" + spItem.getGuid() + " style=\"position: relative; display: block; padding-right: 10px; padding-left: 0px; padding-bottom: 5px; padding-top: 3px; width: 80px; height: 80px; float: left;\" src=\"%P2%\" />";
			imgContent = imgContent.replace(/%P2%/g,IOSec.EncodeHtml(purl));
			//Append the img content to the html content
			htmlContent = htmlContent + imgContent + "</a>";		
			content = content.replace(/%IMG%/g,htmlContent);			

		}
	}
	
	content = content.replace(/%IMG%/g,"");			
	
	spItem = null;
	
	return content;
}

//Sets the Lat/Long coordinates for the Search Manager
// Note: this LatLong storage mechanism is required for pictometry contractual purposes
// We legally cannot show lat/long coordinates on the status bar in birdseye mode.
VE_SearchManager.SetLatLong = function(latitude, longitude)
{
	VE_SearchManager.LatLong = new Msn.VE.LatLong(latitude, longitude);
}

VE_SearchManager.SetCenterAndZoom = function(zoom)
{
	map.SetCenterAndZoom(VE_SearchManager.LatLong.latitude,
						 VE_SearchManager.LatLong.longitude,
						 zoom);
}

VE_SearchManager.PopupZoomContent = function ()
{
	var content = '';
	
	if ( map.GetZoomLevel () < VE_ContextMenu.StreetZoomLevel && map.GetMapStyle () != 'o' && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ZoomToStreet ) )
		content += "<a class=\"VE_Panel_sublink\" href=\"javascript:VE_SearchManager.SetCenterAndZoom("+ VE_ContextMenu.StreetZoomLevel +")\">"+ L_SearchPopupZoomToStreetLevel_Text +"</a>";
	
	return content;
}

// Show a popup for an entity
VE_SearchManager.ShowPopup=function(entity, color, tb, width)
{
	if (VE_Annotations.PanelOpen || VE_ContextMenu.MenuOpen)
		return false;
		
	// close the annotations popup if it's open
	VE_Annotations.ClosePopup();
	
	// If already displaying a popup for this entity, ignore the request
	if (VE_SearchManager.popupEntity == entity)
		return;
		
	// Preserve the entity
	VE_SearchManager.popupEntity = entity;
	
	// Bring the pushpin to the top.
	VE_SearchManager.popupPushpin.style.zIndex = VE_MapPushpin.topZIndex;
	
	// If no color provided, use the default
	if (!color)
		color = "black";
	
	// If the user has not provided a width, use the default.
	if (width == null)
		width = VE_SearchManager.defaultPopupWidth;
	
	// If the popup has not been created, create it
	if(!VE_SearchManager.popup)
	{
		VE_SearchManager.popup = new VE_Panel("searchPopup",										// id
																					5,																// x
																					80,																// y
																					width,														// width
																					200,															// height
																					color,														// color
																					VE_SearchManager.popupZIndex,			// z index
																					"",																// title
																					"",																// body
																					"");															// footer
	
		var p = VE_SearchManager.popup;
		p.SetFooterSize(0);
		p.SetToolbarSize(0);		
	}	
	
	// Use the provided width.
	VE_SearchManager.popup.width = width;
	
	// Always set the popup onCloseClick handler to the default - it may have gotten set to a custom one.
	VE_SearchManager.popup.onCloseClick = VE_SearchManager.CloseSearchPopup;
	
	// Adjust the effective width of the screen for the scratchpad/directions
	var w = windowWidth;
	if((VE_Scratchpad.panel && VE_Scratchpad.panel.visible) || (VE_Directions.panel && VE_Directions.panel.visible))
	{
		w -= 200;
	}
	
	// Convert the latlong to pixel
	var pixel = map.LatLongToPixel(new Msn.VE.LatLong(entity.latitude, entity.longitude));
	
	// Make sure the popup isn't too far to the right
	// If it is, show it on the left side of the pushpin
	var x = pixel.x + 8;
	if(x > w-eval(width))
	{
		x -= eval(width) + 17;
	}
	
	var p = VE_SearchManager.popup;
	p.SetColor(color);
	p.SetTitle(entity.name);
	p.SetBody(tb);	
	p.Show();	
	
	// Make sure the popup isn't too far down
	// If it is, show it above the pushpin
	var y = pixel.y - 11;
	if(y > windowHeight - 120)
	{
		y -= p.height - 20;
	}

	p.SetPosition(parseInt(x), parseInt(y), 180, 80);
	p.Resize();	
	
	p.el.className = 'msve_SearchPopup_active';
}

// Returns the popup body height
VE_SearchManager.GetPopupBodyHeight=function()
{
	var e = document.getElementById("searchPopup_body").getElementsByTagName("table");
	var bh = 0;
	
	if(e != null && e.length > 0)
	{		
		for(var i = 0; i < e.length; i++)
		{
			bh += e[i].offsetHeight;
		}
	}
	
	return bh;
}

// Close the popup if it's open
VE_SearchManager.CloseSearchPopup=function()
{
	ero.hide();	
}

// Sets the z-index of the popup pushpin.
VE_SearchManager._RestorePushpinZIndex=function()
{
	// sstchur; NO!
	return;
	
	if (!VE_SearchManager.popupPushpin)	
		return;	

	VE_SearchManager.popupPushpin.style.zIndex = VE_SearchManager.popupPushpinOrigZIndex;
}

VE_SearchManager.SetDirectionsStart=function(location)
{
	return VE_Directions.SetStart(location, 
							VE_SearchManager.LatLong.latitude,
							VE_SearchManager.LatLong.longitude);
}

VE_SearchManager.SetDirectionsEnd=function(location)
{
	return VE_Directions.SetEnd(location, 
							VE_SearchManager.LatLong.latitude,
							VE_SearchManager.LatLong.longitude);
}

VE_SearchManager._GenerateDriveTo=function(location)
{
	return "javascript:VE_SearchManager.SetDirectionsEnd('" + location + "')";
}

VE_SearchManager._GenerateDriveFrom=function(location)
{
	return "javascript:VE_SearchManager.SetDirectionsStart('" + location + "')";
}