//------------------------------------------------------------------------------
// Search/SearchResult.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// The search result class contains the data for one individual result.
function VE_SearchResult(id, name, description, phone, rating, type, latitude, longitude, infoUrl, photoUrl, keywords, country)
{
	this.id = id;
	this.name = name;
	this.description = description;
	this.phone = phone;
	this.rating = rating;
	this.type = type;
	this.latitude = latitude;
	this.longitude = longitude;
	this.pushPin = null;
	this.pinId = null;
	
	//shankak : added new fields for new spec
	/* Keywords for next release -- not Discovery:  keywords will be empty string for now */
	this.keywords = keywords;
	this.infoUrl = infoUrl;
	this.photoUrl = photoUrl;
	
	this.country = country;
}

VE_SearchResult.prototype.Equals = function ( result )
{
	if(result == null || result == "undefined")
		return false;
	try
	{
		var flag = (this.name == result.name && this.description == result.description && this.phone == result.phone && this.rating == result.rating && this.type == result.type && this.latitude == result.latitude && this.longitude == result.longitude);				
		return flag;
	}
	catch(ex)
	{
		return false;
	}
}

// Returns the serializable ID for this result.
VE_SearchResult.prototype.GetSerializedId = function()
{
	switch (this.type)
	{
		// Autolocate results cannot be serialized, return nothing.
		case "al":
			return "";
		// If this is a location (regular or auto locate), store the name instead.
		// It will be geocoded when we attempt to restore this entity.
		case "adr":
			return "adr" + "." + this.name;
		//
		// annotation data is arbitrary length and can have essentially anything inside of it.
		// all of the data a user enters must be encoded, recorded, and transmitted to
		// recreate the annotation.
		case "aN":
			return VE_AnnotationData.SerializeAnnotation ( this.pinId );
		// Otherwise, just return the id.
		default:
			return this.type + "." + this.id.toString();
	}
}

function VE_SearchResultCategory(id, name)
{
	this.id = id;
	this.name = name;
}