//------------------------------------------------------------------------------
// StateProperties.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: EShinn, keithkin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Dependencies
//
// State.js
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Referred to by
//
// Many many files
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Setters & getters for frequently used configuration items
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// Getters
//------------------------------------------------------------------------------

VE_State.prototype.GetSaveDirectionsUnit = function()
{
	return this._config.GetValue(VE_State.ItemSaveDirectionsUnit);
}

VE_State.prototype.GetTraffic = function()
{
	return this._config.GetValue(VE_State.ItemTraffic);
}

VE_State.prototype.GetMaxInputCount = function()
{
	return this._config.GetValue(VE_State.ItemMaxInputCount);
}

VE_State.prototype.GetMaxSearches = function()
{
	return this._config.GetValue(VE_State.ItemMaxSearches);
}

VE_State.prototype.GetServerPageSize = function()
{
	return this._config.GetValue(VE_State.ItemServerPageSize);
}

VE_State.prototype.GetClientPageSize = function()
{
	return this._config.GetValue(VE_State.ItemClientPageSize);
}

VE_State.prototype.GetWifiServiceUrl = function()
{
	return this._config.GetValue(VE_State.ItemWifiServiceUrl);
}

VE_State.prototype.GetWifiDownloadUrl = function()
{
	return this._config.GetValue(VE_State.ItemWifiDownloadUrl);
}

VE_State.prototype.GetCenterPoint = function()
{
	return this._config.GetValue(VE_State.ItemCenterPoint);
}

VE_State.prototype.GetLatitude = function()
{
	var encoder = new VELatLongEncoding();
	var latLon = this._config.GetValue(VE_State.ItemCenterPoint);
	//If the center LatLong was encoded as a hash String, then extract the 
	//latLong array using the decoder.
	if (latLon.constructor == String)
	{
		var encoder = new VELatLongEncoding();
		latLon = encoder.Decode(latLon);
	}
	return latLon[0];
}

VE_State.prototype.GetLongitude = function()
{
	var latLon = this._config.GetValue(VE_State.ItemCenterPoint);
	//If the center LatLong was encoded as a hash String, then extract the 
	//latLong array using the decoder.
	if (latLon.constructor == String)
	{
		var encoder = new VELatLongEncoding();
		latLon = encoder.Decode(latLon);
	}
	return latLon[1];
}

VE_State.prototype.GetMapStyle = function()
{
	return this._config.GetValue(VE_State.ItemMapStyle);
}

VE_State.prototype.GetZoom = function()
{
	return this._config.GetValue(VE_State.ItemZoom);
}

VE_State.prototype.GetScene = function()
{
	return this._config.GetValue(VE_State.ItemScene);
}

VE_State.prototype.GetSearchKeywords = function()
{
	return this._config.GetValue(VE_State.ItemSearches);
}

VE_State.prototype.GetScratchpadEntityIds = function()
{
	return this._config.GetValue(VE_State.ItemScratchpadIds);
}

VE_State.prototype.GetDontAskWifiLocator = function()
{
	return this._config.GetValue(VE_State.ItemDontAskWiFiLocator);
}

VE_State.prototype.GetAnimatedMovementsEnabled = function()
{
	return this._config.GetValue(VE_State.ItemAnimatedMovementsEnabled);
}

VE_State.prototype.GetSaveLocation = function()
{
	return this._config.GetValue(VE_State.ItemSaveLocation);
}

VE_State.prototype.GetCurrentUrlApiVersion = function()
{
	return this._config.GetValue(VE_State.ItemCurrentUrlApiVersion);
}

VE_State.prototype.GetSaveSearches = function()
{
	return this._config.GetValue(VE_State.ItemSaveSearches);
}

VE_State.prototype.GetCombinedQuery = function()
{
	return this._config.GetValue(VE_State.ItemCombinedQuery);
}

VE_State.prototype.GetSaveScratchpad = function()
{
	return this._config.GetValue(VE_State.ItemSaveScratchpad);
}

VE_State.prototype.GetAutoLocate = function()
{
	return this._config.GetValue(VE_State.ItemAutolocate);
}

VE_State.prototype.GetStartWhere = function()
{
	return this._config.GetValue(VE_State.ItemStartWhere);
}

VE_State.prototype.GetRoutePoints = function()
{
	return this._config.GetValue(VE_State.ItemRoutePoints);
}

VE_State.prototype.GetAnalyticsEnabled = function()
{
	return this._config.GetValue(VE_State.ItemAnalyticsEnabled);
}


//------------------------------------------------------------------------------
// Setters
//------------------------------------------------------------------------------

VE_State.prototype.SetSaveDirectionsUnit = function(value)
{
	this._config.SetValue(VE_State.ItemSaveDirectionsUnit, value);
}

VE_State.prototype.SetTraffic = function(value)
{
	this._config.SetValue(VE_State.ItemTraffic, value);
}

VE_State.prototype.SetCenterPoint = function(value)
{
	this._config.SetValue(VE_State.ItemCenterPoint, value);
}

VE_State.prototype.SetMapStyle = function(value)
{
	this._config.SetValue(VE_State.ItemMapStyle, value);
}

VE_State.prototype.SetZoom = function(value)
{
	this._config.SetValue(VE_State.ItemZoom, value);
}

VE_State.prototype.SetScene = function(value)
{
	this._config.SetValue(VE_State.ItemScene, value);
}

VE_State.prototype.SetSearchKeywords = function(value)
{
	this._config.SetValue(VE_State.ItemSearches, value);
}

VE_State.prototype.SetScratchpadEntityIds = function(value)
{
	this._config.SetValue(VE_State.ItemScratchpadIds, value);
}

VE_State.prototype.SetDontAskWifiLocator = function(value)
{
	this._config.SetValue(VE_State.ItemDontAskWiFiLocator, value);
}

VE_State.prototype.SetAnimatedMovementsEnabled = function(value)
{
	this._config.SetValue(VE_State.ItemAnimatedMovementsEnabled, value);
}

VE_State.prototype.SetRoutePoints = function(value)
{
	this._config.SetValue(VE_State.ItemRoutePoints, value);
}
