//------------------------------------------------------------------------------
// TaskArea.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------
/* Dependencies:
	SetupGobals() method:  more specifically, this method get a reference to the taskArea_data <div>, which is required for this TaskArea object to function properly
*/

var VE_TaskAreaManager = function()
{
	// -- PRIVATE VARIABLES -- //
	var self = this;
	var m_items = new Array();
	var m_currentItem = null;
	
	// -- EVENT FUNCTIONS POINTERS -- //
	this.onremoveitem = null;	
	
	this.destroy = function()
	{
		self = null;
		m_items = null;
		m_currentItem = null;
	}
	
	this.addItem = function(obj)
	{
		m_items.push(obj);
		self.setCurrent(obj);
		
		if (!taskArea_data.childNodes[0])
			taskArea_data.appendChild(obj.el);
		else
			taskArea_data.insertBefore(obj.el, taskArea_data.childNodes[0]);			
	}
	
	this.removeItem = function(obj, supressRedraw)
	{
		var redraw = (supressRedraw == true) ? false : true;
		
		var removeIndex = -1;			
		for (var i = 0; i < m_items.length; i++)
		{
			if (m_items[i] == obj)
				removeIndex = i;
		}		
		
		/* if removeIndex is -1, the item does not exist in the TaskArea's collection of items */
		if (removeIndex == -1)
			return;

		m_items.splice(removeIndex, 1);		
		
		var newIndex = removeIndex - 1;		
		if (newIndex < 0)				
			newIndex = 0;
					
		if (m_currentItem == obj)		
			m_currentItem = m_items[newIndex];
			
		// Unless there was an explicit request NOT to redraw upon item removal, go ahead and redraw the TaskAreanow
		if (redraw)
			self.redraw();		
		
		if (self.onremoveitem)
			self.onremoveitem();
	}
	
	this.getCurrent = function()
	{
		return m_currentItem;
	}
	
	this.setCurrent = function(obj)
	{
		m_currentItem = obj;
		
		for (var i = 0; i < m_items.length; i++)
		{
			var panel = m_items[i];
			if (panel != m_currentItem)
				panel.Minimize();			
			else
				panel.Maximize();			
		}
		
		
		/* Account for a bug in which IE does not correctly redraw elements that have a filter applied.  Resetting the filter (even the samefilter) will force the elements to redraw */
		if (document.all)		
			taskArea_data.className = taskArea_data.className;		
	}	
	
	this.redraw = function()
	{
		self.setCurrent(m_currentItem);
	}
	
	this.getCount = function()
	{
		var count = 0;
		for (var i = 0; i < m_items.length; i++)
			if (m_items[i].el.style.display != 'none')
				count++;
				
		return count;
	}
	
	this.isEmpty = function()
	{
		return m_items.length == 0;			
	}
}