//------------------------------------------------------------------------------
// UserCollections/CollectionsManager.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: shankak
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Class for Annotations. Constructor will be used by all
// objects creating new Annotations.
VE_Annotation = function(id,title,url,photourl,userdate,notes,latitude,longitude,businesslistingid,displayorder,iconid,lastmodified,keywords)
{

	this.Id = id;
	if(title != null && title != "undefined")
	{
		this.Title = title.replace(/%0D%0A/g, '\r\n').replace(/%0A/g, '\n');
	}
	else
	{
		this.Title = title;	
	}
	this.Latitude = latitude;
	this.Longitude = longitude;
	
	this.Notes = notes;
	if(this.Notes != null)
	{
		this.Notes = this.Notes.replace(/%0D%0A/g, '\r\n').replace(/%0A/g, '\n');
	}
	
	if(keywords != null && keywords.length > 0 && keywords[0] != null)
	{
		this.Keywords = keywords;
		this.Keywords[0] = this.Keywords[0].replace(/%0D%0A/g, '\r\n').replace(/%0A/g, '\n');
	}
	else	
	{
		this.Keywords = keywords;
	}
	this.Url = url;
	this.PhotoUrl = photourl;
	this.UserDate = userdate;
	this.DisplayOrder = displayorder;
	this.BusinessListingId = businesslistingid;
	this.IconId = iconid;
	this.LastModified = lastmodified;
	
	//How much has it moved
	this.Delta = 0;
	
	this.MoveUp = function()
	{
		this.Delta = this.Delta - 1;
	};

	this.MoveDown = function()
	{
		this.Delta = this.Delta + 1;
	};
	
	//State
	this.State = VE_AnnotationState.None;
	
	//Pushpin assigned to the annotation
	this.PushPin = "";
}
