// Copyright 2005 Microsoft Corporation
// Version number : 1.3.0518
//****************************************
//****************Resources***************
//****************************************
var L_DetailsWindowTitle_Text = "%1 - Details"; // %1 is the Product name - Windows Live Local
var L_DetailsGetDirections_Text = "Get Directions:";
var L_DetailsToDirLink_Text = "to here";
var L_DetailsFromDirLink_Text = "from here";
var L_DetailsBackHome_Text = "Go to %1";// %1 is the Product name - Windows Live Local
var L_DetailsError_Text = "An error has occurred. Please try your query again later.";

var L_MainAbout_Text = "About";
var L_Privacy_Text = "Privacy";
var L_MainDevelopers_Text = "Developers";
var L_Help_Text = "Help";
var L_Feedback_Text = "Feedback";

//JS/Click2Call/Click2Call.js
var L_CallForFress_Text = "Call For Free";
//------------------------------------------------------------------------------
//	VE.Feature.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: a-pratin
//
// <header>	$Header$</header>
//-----------------------------------------------------------------------------
//Localizable Strings
var L_VEProductName_Text = "Windows Live Local";	

// RegisterNamespace
RegisterNamespaces("Msn.VE");

Msn.VE.Features = new function()
{
	// Product name 
	this.ProductName = L_VEProductName_Text;

	//Settings Dialog options
	this.Settings = new function()
	{
		this.SaveLastLocation = true; 
		this.SaveSearches = false; 
		this.SaveScratchpad = true; 
		this.UseAnimatedPanZoom = true; 
		this.InstallLocationFinderNotification = false; 
	}
	// Footer links
	this.Footer = new function()
	{
		this.About = true;
		this.Privacy = true;
		this.Developers = true;
		this.Help = true;
		this.Feedback = true;
	}
	
	//Search categories
	this.Search = new function()
	{
		this.Categories = true;
	}	
	
	//Header links
	this.Header = new function()
	{
		this.Help = true;
		this.Settings = true;
	}
	
	//Map Action bar
	this.MapAction = new function()
	{
		this.Welcome = true;
		
		this.Collections = new function()
		{
			this.DisplayNone = false;
			this.Open = true;
			this.New = true;
			this.AddPushpin = (this.DisplayNone) ? false : true;
			this.Favorites = true;			
		}
		
		this.DrivingDirections = true;
		this.Traffic = true;	
		this.LocateMe = true;	
		
		this.Share = new function()
		{
			this.ShareInMessenger = true;			
			this.EmailPermalink = true;					// E-mail
			this.CopyToClipboard = true;			
			this.AddBlogEntry = true;
			this.ViewPermalink = true;
			this.DisplayNone = false;
		}
	}
	
	//Context menu / pop-up	
	this.MenuOption = new function()
	{
		this.ZoomToStreet = true;
		this.ZoomToCity = true;
		this.ZoomToRegion = true;
		this.CenterMapHere = true;
		this.SendEmailOnPushpinItem = true;
		this.SendEmailOnSearchItem = true;
		this.DetailsOnSearchItem = true;
	
		//Scratch Pad Panel menu	
		this.ShareScratchPadItems = new function()
		{
			this.SendIM = false;
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.AddBlogEntry = true;				
			this.DisplayNone = false;		
		}
		
		this.MapAllScratchPadItems = true;
		
		//Driving Direction Panel menu
		this.ShareDrivingDirections = new function()
		{
			this.SendEmail = true;
			this.CopyToClipboard = true;
			this.SendIM = true;
			this.DisplayNone = false;		
		}
		
		this.PrintDrivingDirections = new function()
		{
			this.Customized = true;			
			this.MapsOnly = true;
			this.MapsAndDirectionsOnly = true; 
			this.DirectionsOnly = true;			
			this.DisplayNone = false;		
		}
	}
	//Traffic flow Strings
	this.Traffic = new function()
	{
		this.Flow = new function()
		{
			this.Slow = "0-25 mph";
			this.Moderate = "25-45 mph";
			this.Fast = "45+ mph";
		}	
		
		this.Attribution = "Traffic data provided by Traffic.com";
	}
	//Click2Call feature
	this.Click2Call = new function()
	{
		this.Enabled = false;
		this.CountryList = new Array();
	}
	
	this.Ads = new function()
	{	
		//Overture, Telco, OvertureCA, Thompson
		this.AttributionTextOverture = "Sponsors From Overture";
		this.AttributionTextTelco = "Sponsors From Superpages";
		this.AttributionTextOvertureCA = ""; //left blank intentionally
		this.AttributionTextThompson = "Sponsors from ThompsonLocal.com";
	}	
}

//------------------------------------------------------------------------------
// Analytics.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: CodyE, Cthota
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

// Empty constructor, needed to use the class name.
function VE_Analytics()
{
	
}


function VE_Range(min,max)
{
	this.min = min;
	this.max = max;
}

VE_Range.prototype.IsInRange=function(val)
{
	return val >= this.min && 
	       val <= this.max;
	       
};

VE_Range.prototype.toString=function()
{
	return this.min+"-"+this.max;
};
                                        
VE_Analytics.distanceBuckets = new Array(new VE_Range(0,10),
									   new VE_Range(11,25),
									   new VE_Range(26,100),
									   new VE_Range(101,200),
									   new VE_Range(201,500),
									   new VE_Range(501,1000));
// Whether or not analytics is enabled.
VE_Analytics.analyticsEnabled = true;

// Logs the user opening the help from the main header.
VE_Analytics.LogHelp=function()
{
	VE_Analytics.Log("VE | Help Pane","Help");
};
// Logs the user opening the about page from the main header.
VE_Analytics.LogAbout=function()
{
	VE_Analytics.Log("VE | About Pane","About");
};

// Logs the user printing the details from the Details page
VE_Analytics.LogPrintDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Print");
};

// Logs the user getting directions(to/from) from the Details page
VE_Analytics.LogGetDirectionsDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","Get Directions");
};

// Logs the user getting more info from the Details page
VE_Analytics.LogGetMoreInfoDetailsPage=function()
{
	VE_Analytics.Log("VE | Details Page","MSN Search");
};

// Logs the user opening the locate me page from the main header
VE_Analytics.LogLocate=function()
{
	VE_Analytics.Log("VE | Locate Me","Locate Me");
};

VE_Analytics.LogResponseTimes=function()
{
	//Note[a-pratin]: We assign all the calculation to tempVar and then apply toFixed() method because JSRewrite tool 
	//				  used for compression in the release build breaks the javascript format in this function if not applied.	
	
	var tempVar = map.GetFailureRate()*100;
	s.prop33 = tempVar.toFixed(1);
	
	tempVar = map.GetResponseRangeCounts()[0]*100;
	s.prop34 = tempVar.toFixed(1);//taget response time	
	
	tempVar = map.GetResponseRangeCounts()[2]*100;
	s.prop35 = tempVar.toFixed(1);//outlies response time
	
	VE_Analytics.Log("VE | Response Times");
	map.ResetResponseRangeCounts();
};
// Logs the user zooming the map in or out
VE_Analytics.LogZoom=function()
{	
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Zoom","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogPan=function()
{
	VE_Analytics.Log(map.GetMapStyle() == Msn.VE.MapStyle.Oblique ? "VE | Oblique Imagery" : "VE | Home Page","Pan","Mouse/Game Control/Keyboard");
};

VE_Analytics.LogFailedSearch=function()
{
	s.prop11 = "No Search Results";
	VE_Analytics.Log("VE | Exception","Search");
};

VE_Analytics.LogJSWatson=function(errorMessage)
{
	if(errorMessage != null && errorMessage != "undefined" && errorMessage.length > 0)
	{
		s.prop11 = errorMessage;
		VE_Analytics.Log("VE | Exception", "JSWatson");
	}
};


VE_Analytics.LogScrachPadItems=function()
{
	s.prop12 = VE_Scratchpad.highWaterCount;
	VE_Analytics.Log("VE | Scratch Pad","Exit");
};

VE_Analytics.LogAds=function(what, eventName, pagename, numberOfAds, indexOfAdClicked, adsProvider)
{
	s.events = eventName;
	
	if(what == null || what == "undefined")
		s.eVar8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	else
		s.eVar8 = what;
		
	s.eVar9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : document.getElementById("where").value) : "";
	
	if(eventName == "Event6")
	{
		s.eVar11 = indexOfAdClicked;
	}
	else
	{
		s.eVar10 = numberOfAds;		
	}
	
	if(adsProvider != null && adsProvider != "undefined")
	{
		s.eVar12 = adsProvider;		
	}
	else
	{
		s.eVar12 = "";		
	}
	
	//alert(s.events + ":" + s.eVar8 + ":" + s.eVar9 + ":" + s.eVar11 + ":" + s.eVar10 + ":" + s.eVar12);
	
	VE_Analytics.Log("VE | " + pagename,null);
};

//Set campaign id
VE_Analytics.SetCampaignId=function(cid)
{
	if(cid != null && cid != "" && cid != "undefined")
	{
		if(s)
		{
			s.campaign = cid;
			VE_Analytics.Log("VE | Home Page","Campaign Page View");
		}
	}
};

VE_Analytics.LogClick2Call=function(source)
{
	//Source is not supported yet. So it always logs 
	//Search Pane ERO as default
	//Ideally we should be populating s.prop37 
	//Since we dont have source at this point from MPC
	//We will pass default.
	if(source != null && source != "undefined")
	{
		if(source == "1")
			VE_Analytics.Log("VE | Search Pane ERO", "C2C call Entry Point");			
		else if(source == "2")		
			VE_Analytics.Log("VE | Map ERO", "C2C call Entry Point");			
		else if(source == "3")		
			VE_Analytics.Log("VE | Details Page", "C2C call Entry Point");			
		else
			VE_Analytics.Log("VE | Click-2-Call", "C2C call Entry Point");					
	}
	else
	{
		VE_Analytics.Log("VE | Click-2-Call", "C2C call entry point");		
	}
}

VE_Analytics.LogAPI=function(pageName,NavAction)
{
	//currently turn off logging for the API - see Bug 4794
	return; 
	
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;		
	s.prop6 = NavAction ? NavAction : "";	
		
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
}

VE_Analytics.Log=function(pageName,NavAction,NavControl,routeLengthObj)
{
	if ( window.s == 'undefined' || window.s == null )
		return;
		
	// Only log if analytics is enabled.
	if (!VE_Analytics.analyticsEnabled)
	{
		return;
	}
	
	s.pageName = pageName;
	s.prop3 = window["map"] ? map.GetMapStyle() : "";
	s.prop4 = window["map"] ? map.GetZoomLevel() : "" ;
	s.prop5 = window["map"] ? VE_Analytics.FormatLatLong(map.GetCenterLatitude(),map.GetCenterLongitude()) : "";
	s.prop6 = NavAction ? NavAction : "";
	s.prop7 = NavControl ? NavControl : "";
	s.prop8 = document.getElementById("what") ? (document.getElementById("what").value == L_MainWhatHelp_Text ? "" : document.getElementById("what").value) : "";
	s.prop9 = document.getElementById("where") ? (document.getElementById("where").value == L_SearchUseCurrentViewText_Text ? "" : document.getElementById("where").value) : "";
	s.prop36 = ( window.usertype == undefined ) ? 1 : usertype; 
	
	if(routeLengthObj) /* routing information is available */
	{
		
		s.prop10 = VE_Analytics.ConvertDistanceToBucket(routeLengthObj);	
		
		s.prop32 = 	routeLengthObj.numberOfWaypoints;
		
	}
	else 
	{
		s.prop10 = "";
	}
	
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}
	VE_Analytics.ResetLogProps();
};
/* For Ominiture logging region codes needs to be formatted as follows
 * latitude (1 decimal place)+","+longitude (0 decimal places or an integer)

 */
VE_Analytics.FormatLatLong=function(latitude,longitude)
{
	if(!latitude || !longitude)
	{
		if(state && state.GetLatitude() && state.GetLongitude()) 
		{	
			return state.GetLatitude().toFixed(1)+","+Math.round(state.GetLongitude());
		}
		return "0.0,0";
	}
	return latitude.toFixed(1)+","+Math.round(longitude);
};

VE_Analytics.ConvertDistanceToBucket=function(routeLengthObj)
{
	var distance  = routeLengthObj.distance;
	
	if(!distance)
	{
		return "";
	}
    
	if(routeLengthObj.distanceUnit && 
	   routeLengthObj.distanceUnit.indexOf("mi") != -1)
	{ /* convert miles to kilometers first */
		distance = Math.round(distance*1.6093);
	}
	//find the range bucket
	
	for(var i =0;i < VE_Analytics.distanceBuckets.length; i++)
	{
		if(VE_Analytics.distanceBuckets[i].IsInRange(distance))
		{
			return VE_Analytics.distanceBuckets[i].toString();
		}
	}
	
	return "1001 and Above";
};

VE_Analytics.ResetLogProps=function()
{
	s.prop11 = "";
	s.prop12 = "";
	s.prop32 = "";
	s.prop33 = "";
	s.prop34 = "";
	s.prop35 = "";
	
	//Clear all events stuff
	s.events = "";
	s.eVar8 = "";
	s.eVar9 = "";
	s.eVar10 = "";
	s.eVar11 = "";		
	s.eVar12 = "";		
	
	//Clear campaign
	s.campaign = "";	

};
//------------------------------------------------------------------------------
// CrossBrowser.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Eshinn
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


// Cleans up potentially unsafe strings for display on an HTML page.
function SanitizeHtmlString(s)
{
	if (!s || typeof(s) != "string") 
	{
		return s;
	}
	
	return IOSec.EncodeHtml(s);
}

// Returns the X position of the mouse when the event was fired.
function GetMousePosX(e)
{
	var posX = 0;
	if (e.pageX)
	{
		posX = e.pageX;
	}
	else if (e.clientX)
	{
		posX = e.clientX + document.body.scrollLeft;
	}
	return posX;
}

// Returns the Y position of the mouse when the event was fired.
function GetMousePosY(e)
{
	var posY = 0;
	if (e.pageY)
	{
		posY = e.pageY;
	}
	else if (e.clientY)
	{
		posY = e.clientY + document.body.scrollTop;
	}
	return posY;
}

// Returns the target of the event
function GetTarget(e)
{
	if (!e) var e = window.event;
	var eventTarget;
	if (e.srcElement) eventTarget = e.srcElement;
	else if (e.target) eventTarget =  e.target;
	if (eventTarget.nodeType == 3) // defeat Safari bug
		eventTarget = targ.parentNode;
	return eventTarget;
}

// Selects the character range specified in the textbox passed in.
function SelectText(textbox, start, end)
{
	if (!textbox) return;
	
	// IE specific
	if (textbox.createTextRange)
	{
		var textRange = textbox.createTextRange();
		textRange.moveStart("character", start);
		textRange.moveEnd("character", end);
		textRange.select();
	}
	// Mozilla specific
	else if (textbox.setSelectionRange)
	{
		textbox.setSelectionRange(start, end);
	}
}

// Gets left position of element
function GetElementLeftPosition(elemID) 
{
    var offsetTrail = document.getElementById(elemID);
    var offsetLeft = 0;
    while (offsetTrail) {
        offsetLeft += offsetTrail.offsetLeft;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 && 
        typeof(document.body.leftMargin) != "undefined") {
        offsetLeft += document.body.leftMargin;
    }
    return offsetLeft;
}

// Gets top position of element
function GetElementTopPosition(elemID) 
{
    var offsetTrail = document.getElementById(elemID);
    var offsetTop = 0;
    while (offsetTrail) {
        offsetTop += offsetTrail.offsetTop;
        offsetTrail = offsetTrail.offsetParent;
    }
    if (navigator.userAgent.indexOf("Mac") != -1 && 
        typeof(document.body.topMargin) != "undefined") {
        offsetTop += document.body.topMargin;
    }
    return offsetTop;
}

function SelectedTextLength(textbox)
{
	if ( !textbox ) return 0;
	
	// IE specific
	if (textbox.document)
	{
		var selectedTextObj = textbox.document.selection.createRange();
		return selectedTextObj.text.length;
	}
	// Mozilla specific
	else 
	{
		var selStart = textbox.selectionStart;
		var selEnd = textbox.selectionEnd;
		return (selEnd-selStart); 		
	}
}

var tab = null;
var map = null;
var MinTabHeight = 100;
var MinContentWidth = 700;

// Map pushpin container.  Used for legacy support.
function VE_MapPushpin(){}

// Pushpins.
// Base is 11.  Each search should be sequentially higher.
// Searches on top have higher numbers.
VE_MapPushpin.baseZIndex = 11;

// This is for when we absolutely want to ripple a pushpin to the top.
VE_MapPushpin.topZIndex = 20;

function init()
{
	window.attachEvent('onresize', onWindowResize);

	// set the Window Title
	window.document.title = L_DetailsWindowTitle_Text.replace(/%1/g,Msn.VE.Features.ProductName);
		
	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{
 		if (VE_Click2Call.isAllowedCountry(YPCountry))
 		{
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.DetailsPage);
 			Click2Call.CreateRenderWidget('mpc.' + YPId + '@search.msn.com', 'c2cIntro');
 		}
 	}
 	
	refreshContentWidth();
	buildFooter();
	tabLoad();
	refreshTabHeight();
		
	//var menu = document.getElementById('menu').firstChild;
	//pseudoHoverForChildren(menu);
}

function DetailsPageEnterHandler()
{
	setupClick2Call();
	SetupDetailsMap();
}

function setupClick2Call()
 {	
 	if (click2callenabled && Msn.VE.Marketization.IsEnabled(Msn.VE.Features.Click2Call.Enabled))
 	{
 		if (VE_Click2Call.isAllowedCountry(YPCountry))
 		{	
 			var Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.DetailsPage);
 			Click2Call.CreateRenderWidget('mpc.' + YPId + '@search.msn.com', 'c2cDetails');
 		}
 	}
 }

function onWindowResize()
{
	refreshTabHeight();
	refreshContentWidth();
}

function buildFooter()
{
	var wll_FooterLeft = document.getElementById('details_listOne');
	// Privacy link
	if ( Msn.VE.Marketization.IsEnabled( Msn.VE.Features.Footer.Privacy ) )
	{
		var oNewItem = document.createElement('li');			
		oNewItem.innerHTML = '<a href = ' + privacyStatement + ' target = "_new">' + L_Privacy_Text + '</a>';
		BuildHeaderFooterItem( oNewItem , wll_FooterLeft );
		oNewItem = null;
	}
}

function BuildHeaderFooterItem( element, containerElement )
{	
	containerElement.appendChild( element );
}

function tabLoad()
{
	var tabparent = document.getElementById('tabdiv');
	tab = new Tab(tabparent);
	
	var backlinkText = L_DetailsBackHome_Text.replace(/%1/g,Msn.VE.Features.ProductName);
	
	//tab.addTabPage('Editorial Profile','');
	var maphtml = '<div id="mapArea">' + 
								'<div id="mapContainer"></div>' +
								'<div id="directions">' +
								'<span id="idDirections"></span><br>' +
								'<a id="toDirLink" href="#" onclick="' + DriveToOnClick + '"></a><span class="bluepipe">|</span>' +
								'<a id="fromDirLink" href="#" onclick="' + DriveFromOnClick + '"></a>' +
								'<br><a href="http://local.live.com/">' + backlinkText + '</a>' +
								'</div>' +
					 '</div>';
	var divDetailsContent = '<div id="divDetailsContent">' + DetailsContent + '</div>';
	var page = tab.addTabPage('Details',divDetailsContent + maphtml);
	page.setEnterHandler(DetailsPageEnterHandler);
	page.setLeavingHandler(DestroyMap);
	//tab.addTabPage('Reviews','');
	tab.addTabPage('WebResults','<iframe src="' + msnResultsLink + '" id="WebResultIframe" border = "0" frameborder = "0" width="100%" height="100%"></iframe>');
	tab.selectTabPage(page);
}

function getWindowWidth() 
{
	var width;	
	if(typeof(window.innerWidth) == 'number')
	{
		width =  window.innerWidth;
	}
	else if(document.documentElement && document.documentElement.clientWidth)
	{
		width =  document.documentElement.clientWidth;
	}
	else if(document.body && document.body.clientWidth)
	{
		width =  document.body.clientWidth;
	}	
	return width;
}

function getWindowHeight()
{
	var height;
	if(typeof(window.innerHeight) == 'number')
	{
		height = window.innerHeight;		
	}
	else if(document.documentElement && document.documentElement.clientHeight)
	{ 
		height = document.documentElement.clientHeight;
	}
	else if(document.body && document.body.clientHeight)
	{ 
		height = document.body.clientHeight;
	}
	return height;
}

function refreshContentWidth()
{	
	var winWidth = getWindowWidth();
	var contentwidth;
	if (document.all)	
		contentwidth = winWidth - 20;	
	else
		contentwidth = winWidth - 40;
	if (contentwidth < MinContentWidth)
		contentwidth = MinContentWidth;
	document.getElementById('wl_ve_ContentCell').style.width = contentwidth + 'px';	
}

function refreshTabHeight()
{
	var winHeight = getWindowHeight();
	var headerHeight = document.getElementById('wl_ve_headerCell').offsetHeight;	
	//var menuHeight = document.getElementById('menu').offsetHeight;
	var menuHeight = 0;	
	var introHeight = document.getElementById('intro').offsetHeight;
	var tabHeaderHeight = document.getElementById('TabHeaderDiv').offsetHeight;	
	var footerHeight = document.getElementById('wl_ve_footerCell').offsetHeight;	
	var margins = 40;
	var tabHeight = winHeight - headerHeight - menuHeight - introHeight - tabHeaderHeight - footerHeight - margins;
	if (tabHeight < MinTabHeight)
		tabHeight = MinTabHeight;
	
	document.getElementById('divTabFrame').style.height = tabHeight + 'px';
	
	//IE can not update the iframe height, so we reset the height.
	var WebResultIframe = document.getElementById('WebResultIframe');
	if (WebResultIframe)
		WebResultIframe.style.height=tabHeight+'px';	
}

function DestroyMap()
{
	if (map) map.Destroy();
}

function SetupDetailsMap()
{	
	if ( document.getElementById('mapContainer') != null )
	{
		document.getElementById('idDirections').innerText = L_DetailsGetDirections_Text;
		document.getElementById('toDirLink').innerText = L_DetailsToDirLink_Text;
		document.getElementById('fromDirLink').innerText = L_DetailsFromDirLink_Text;
		
	}
	else
	{
		document.getElementById('idError').innerText = L_DetailsError_Text;
		return;
	}
	
	
	if(latitude == null || longitude == null)
	{
		return;
	}

	//TODO: <Localization> : Need to set the following values based on Locales
	var zoom = 12;
	if (mapStyle == null) {
		mapStyle = "r";
	}
	
	StartMap(latitude, longitude, zoom, mapStyle, "absolute", 0, 0, 300, 200);
	
	LogAnalytics();
}


// Creates the initial map.  This method should only be called once!!
function StartMap(latitude, longitude, zoom, mapStyle, position, x, y, windowW, windowH)
{
	// Create the control	
	var params = new Object();
	params.latitude = latitude;
	params.longitude = longitude;
	params.zoomlevel = zoom;
	params.mapstyle = mapStyle;
	params.showScaleBar = false;
	params.showDashboard = true;
	params.dashboardX = 0;
	params.dashboardY = 5;
	params.dashboardSize = "small";
	params.obliqueEnabled = false;
	params.fixedView = false;
	params.disableLogo = true;

	if ( document.getElementById('mapContainer'))
	{
		map = new Msn.VE.MapControl(document.getElementById("mapContainer"), params);
		map.Init();
			
		map.AddPushpin(
			"myPin",                         // pushpinID
			latitude,                        // latitude
			longitude,                       // longitude
			24,                              // width
			24,                              // height
			"VE_Pushpin",    // className
			"<img src=\"i/pins/poi_businesslisting.gif\"/>",							 // innerHTML 
			VE_MapPushpin.baseZIndex,		// z-index
			Msn.VE.PushPinTypes.Annotation
			);
	}
}


// Changes the map style.
function ChangeMapStyle(mapStyle)
{
	map.SetMapStyle(mapStyle);
}

function LogAnalytics()
{
	// Disable the omniture onclick event handler stuck to the body of the element.
	// This will get around the bug in their element type detection code.
	document.body.detachEvent("onclick", s.bc);

	s.linkInternalFilters="javascript:,.msn.";
	s_account  = omnitureAccount;
	s.server   = location.hostname;
	s.pageName = "Details Page";
	s.channel  = "VirtualEarth";
	/* Product Name */
	s.prop1 = "VirtualEarth";
	/* Culture and Language */
	s.prop2 = window.locale;
	/* MapTheme */
	s.prop3 = "";
	/* ZoomLevel */
	s.prop4 = "";
	/* Region Code */
	s.prop5 = "";
	/* Navigation Action */
	s.prop6 = "";
	/* Navigation Control */
	s.prop7 = "";
	/* Search Keyword */
	s.prop8 = "";
	/* Search Location */
	s.prop9 = "";
	/* YPID */
	s.prop38 = YPId;

	//Log Analytics	
	var elm = document.getElementById("logging");
	if(elm)
	{
		elm.innerHTML = s.t();
	}	
}

var windowWidth = 0;
var windowHeight = 0;
var scrollbarWidth = null;

// Gets the width of the window, minimum 100 pixels
function GetWindowWidth() 
{
	var width = 0;
	
	if(typeof(window.innerWidth) == 'number')
	{
		width =  window.innerWidth;
	}
	else if(document.documentElement && document.documentElement.clientWidth)
	{
		width =  document.documentElement.clientWidth;
	}
	else if(document.body && document.body.clientWidth)
	{
		width =  document.body.clientWidth;
	}
	
	if(!width || width < 100)
	{
		width = 100;
	}
		
	return width;
}

// Gets the height of the window, minimum 100 pixels
function GetWindowHeight() 
{
	var height = 0;
	
	if(typeof(window.innerHeight) == 'number')
	{
		height = window.innerHeight;
	}
	else if(document.documentElement && document.documentElement.clientHeight)
	{ 
		height = document.documentElement.clientHeight;
	}
	else if(document.body && document.body.clientHeight)
	{ 
		height = document.body.clientHeight;
	}
	
	if(!height || height < 100)
	{
		height = 100;
	}
		
	return height;
}

// creates a div with just a scrollbar and gets its size
// this works in IE but not in firefox.
function GetScrollbarWidth ()
{
	if (scrollbarWidth)
	{
		return scrollbarWidth;
	}

  if(navigator.userAgent.indexOf("IE")>=0)
  {  	
	var div=document.createElement("div");
	var sbWidth = null;
	  
	div.style.visible = 'hidden';
	div.style.overflowY = 'scroll';
	div.style.position = 'absolute';
	div.style.width = 0;
	document.body.insertAdjacentElement("afterBegin", div);
	sbWidth = div.offsetWidth;
	div.parentNode.removeChild(div);
	  
	if ( !sbWidth )
	{
			sbWidth = 16;
	}
	  
	scrollbarWidth = sbWidth;  
	return sbWidth;
  }  
  else
	  return 0;
}

// Returns the full url path up to and including the last forward slash
function GetUrlPrefix()
{
	var lastfslash = window.location.pathname.lastIndexOf("/");
	var hosturl = window.location.protocol+"//"+window.location.hostname+window.location.pathname.substring(0,lastfslash+1);
	return hosturl;
}

function GetUrlParameterString()
{
	var urlParameterString = window.location.search;
	
	// Exit early if we have no parameters passed in the url.
	if (urlParameterString.length == 0 || urlParameterString.indexOf("?") == -1)
	{
		return "";
	}

	// Strip out initial ?
	return urlParameterString.substr(urlParameterString.indexOf("?") + 1);
}

// Constructs an array of the parameters passed in via the url
// Format is [parameter name, value, parameter name, value, ...]
function GetUrlParameters()
{
	var parameters = new Array();
	var urlParameterString = GetUrlParameterString();
	
	if (!urlParameterString)
	{
		return parameters;
	}
	
	// Split into parameter strings on & - ex. abcd=jas%20ew&akw9=29  [abcd=jaw%20ew, akw9=29, etc.]
	var parameterStrings = urlParameterString.split("&");
	
	// Split the parameter strings into name/value pairs on = - ex  abcd=jas%20ew -> [abcd, 'jas ew']
	for (var i = 0; i < parameterStrings.length; i++)
	{
		var parameterParts = parameterStrings[i].split("=");
		// Only bother with those that actually have both a name & value.
		if (parameterParts.length == 2 && parameterParts[0] && parameterParts[1])
		{
			parameters.push(unescape(parameterParts[0]));
			parameters.push(unescape(parameterParts[1]));
		}
	}
	
	return parameters;
}

// It parses for Shift key pressed. To be called from onclick event of an <A> tag.
// This prevent new window from popping up when "Shift" key + hyperlink is clicked.
function ParseShiftKeyForLinks(e) 
{ 
	if(e.shiftKey) 
	{ 
		return false; 
	} 	
	return true; 		
}

 //------------------------------------------------------------------------------
 // ./Details/Click2Call.js 
 //
 // <copyright from='2004' to='2005' company='Microsoft Corporation' >
 // Copyright (c) Microsoft Corporation. All Rights Reserved. 
 // Information Contained Herein is Proprietary and Confidential. 
 // </copyright>
 //
 // Owner: a-haowu
 //
 //  
 // <header>	$Header$</header>
 //------------------------------------------------------------------------------
 
 Click2CallEntryPoint =
 {
 	SearchResultPane0: 0,
 	SearchResultPane1: 1,
 	SearchResultPane2: 2,
 	SearchResultERO: 3,
 	BusinessListingERO: 4,
 	DetailsPage: 5
 };
 
 //avoid too many widgets created without cleanup
 WidgetsSize = 
 {
	SearchResultPane: 0,
	SearchResultERO: 1,
	BusinessListingERO: 1,
	DetailsPage: 2
 };
 
 var VE_Click2Call =
 {
 	SearchResultPane0Manager : null,
 	SearchResultPane1Manager : null,
 	SearchResultPane2Manager : null,
 	SearchResultEROManager : null,
 	BusinessListingEROManager : null,
 	DetailsPageManager : null, 	
 	
 	isAllowedCountry : function(country)
 	{
 		if (!country || country == '') return false;
 		var list = Msn.VE.Features.Click2Call.CountryList;
 		for (var i=0; i<list.length; i++)
 		{
 			if (list[i] == country) return true;
 		}
 		return false;
 	},
 	
 	setSearchResultPaneWidgetsSize : function(size)
 	{
 		WidgetsSize.SearchResultPane = size;
 	},
 	
	removeAllWidgets : function()
	{
		var Click2Call;
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.SearchResultPane);
		Click2Call.DestroyAllWidgets();
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.SearchResultERO);
		Click2Call.DestroyAllWidgets();
		Click2Call = VE_Click2Call.getClick2CallManager(Click2CallEntryPoint.BusinessListingERO);
		Click2Call.DestroyAllWidgets();
	},
	
 	getClick2CallManager : function(SceID)
 	{
 		switch (SceID)
 		{
 		case Click2CallEntryPoint.SearchResultPane0:
 			if (!VE_Click2Call.SearchResultPane0Manager)
 				VE_Click2Call.SearchResultPane0Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane0, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane0Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultPane1:
 			if (!VE_Click2Call.SearchResultPane1Manager)
 				VE_Click2Call.SearchResultPane1Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane1, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane1Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultPane2:
 			if (!VE_Click2Call.SearchResultPane2Manager)
 				VE_Click2Call.SearchResultPane2Manager = new Click2CallManager(Click2CallEntryPoint.SearchResultPane2, WidgetsSize.SearchResultPane);
 			return VE_Click2Call.SearchResultPane2Manager;
 			break;
 		case Click2CallEntryPoint.SearchResultERO:
 			if (!VE_Click2Call.SearchResultEROManager)
 				VE_Click2Call.SearchResultEROManager = new Click2CallManager(Click2CallEntryPoint.SearchResultERO, WidgetsSize.SearchResultERO);
 			return VE_Click2Call.SearchResultEROManager;
 			break;
 		case Click2CallEntryPoint.BusinessListingERO:
 			if (!VE_Click2Call.BusinessListingEROManager)
 				VE_Click2Call.BusinessListingEROManager = new Click2CallManager(Click2CallEntryPoint.BusinessListingERO, WidgetsSize.BusinessListingERO);
 			return VE_Click2Call.BusinessListingEROManager;
 			break;
 		case Click2CallEntryPoint.DetailsPage:
 			if (!VE_Click2Call.DetailsPageManager)
 				VE_Click2Call.DetailsPageManager = new Click2CallManager(Click2CallEntryPoint.DetailsPage, WidgetsSize.DetailsPage);
 			return VE_Click2Call.DetailsPageManager;
 			break;				
 		}
 		
 		function Click2CallManager(SceID, MaxWidgets)
 		{
 			var mpcWidgetManager;
 			var calls = new Array();
 			var ScenarioID = SceID; 			
 			var Widgets = new Array();
 			var widgetnumber = MaxWidgets;
 			
 			MPCall_SetWidgetGlobals("mpcallbaseurl", click2callurl);
			MPCall_SetWidgetGlobals("mpcallhigstate", 1); 			
			
 			mpcWidgetManager = new MPCall_WidgetManager('WLL', ScenarioID, window.locale, true);	 			 	
 			 	
 			try
 			{	
				mpcWidgetManager.Set("mpcwidgetclickcb", VE_Analytics.LogClick2Call);
				mpcWidgetManager.Set("mpcwidgetkpresscb", VE_Analytics.LogClick2Call); 			
			}
			catch(mpcerror)
			{
				//swallo
			}
 			
 			this.CreateWidget = function(mid, parentid)
 			{
 				var call = new Object();
 				call.mid = mid;
 				call.pid = parentid;
 				calls.push(call);
 			}
 			
 			this.RenderWidgets = function()
 			{
 				//this is not good. 225 and 335 are the height and width of the widget.
 				var top = (document.body.clientHeight - 225) / 2;
 				var left = (document.body.clientWidth - 335) / 2; 				
 				while (calls.length>0)
 				{
 					var call = calls.shift();
 					var mpc = new MPCall_Widget(call.mid, 2, L_CallForFress_Text, top, left);
 					_push(mpc);
 					mpc.SetParent(call.pid);
 					mpcWidgetManager.AddWidget(mpc);
 					call = null;
 				}
 			}
 			
 			this.CreateRenderWidget = function(mid, parentid)
 			{	
 				//this is not good. 225 and 335 are the height and width of the widget.
 				var top = (GetWindowHeight() - 225) / 2;
 				var left = (GetWindowWidth() - 335) / 2;
 				var mpc = new MPCall_Widget(mid, 2, L_CallForFress_Text, top, left);
 				_push(mpc); 				
 				mpc.SetParent(parentid);
 				mpcWidgetManager.AddWidget(mpc);
 			}
 			
 			function _push(mpc)
 			{
 			
 				if (Widgets.length == widgetnumber) 
 				{
 					var temp = Widgets.shift();

 					if(mpcWidgetManager.Destroy)
 					{
 						try{
 							mpcWidgetManager.Destroy(temp);
 						}
 						catch(e)
						{
							//swallow
						}
 					}
 				} 				
 				Widgets.push(mpc); 
 			}
 			
 			this.Destroy = function()
 			{
 				DestroyAllWidgets();
 				Widgets = null;
 				calls = null;
 			}
 			
 			this.DestroyAllWidgets = function()
 			{
 				while (Widgets.length>0)
 				{ 					
 					var mpc = Widgets.pop(); 					
 					if(mpcWidgetManager.Destroy)
 						mpcWidgetManager.Destroy(temp);					

 				} 				
 			}
 			
 		}	
 	}
 }
//------------------------------------------------------------------------------
// ./Details/Tab.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: Hao
//
//  
// <header>	$Header$</header>
//------------------------------------------------------------------------------


//Tab class
var Tab = function(parent)
{
	var tabPages = new Array();
	
	//tabPage inner class
	var tabPage = function(header, content, parentTab)
	{
		var _EnterHandler = null;
		var _LeavingHandler = null;
		
		pagecounter++;
		var id = "tab_" + header + pagecounter;
		var pageHeader = document.createElement('li');
		
		pageHeader.className = 'tabOff';
		pageHeader.attachEvent('onclick', function() {parentTab.selectTabPagebyId(id);});
		pageHeader.innerHTML = '<p>' + header + '</p>';
		
		var pageContent = content;
				
		this.Destroy = function()
		{
			pageHeader.onclick = null;
			pageHeader = null;
			//here may leak memory, for the pageContent inner html could cause circular reference which is unknown for Tab. 
			pageContent = null;
		}
		
		this.setEnterHandler = function(handler)
		{
			_EnterHandler = handler;			
		}
		
		this.setLeavingHandler = function(handler)
		{
			_LeavingHandler = handler;
		}
		
		this.fireLeavingHandler = function()
		{
			pageHeader.className = "tabOff";
			if (_LeavingHandler)	_LeavingHandler();
		}
		
		this.fireEnterHandler = function()
		{
			pageHeader.className = "tabOn";			
			if (_EnterHandler)	_EnterHandler();
		}
		
		this.id = id;
		this.pageHeader = pageHeader;
		this.pageContent = pageContent;
	}
	
	var selectedIndex = null;
	var pagecounter = 0;
	
	//Tab Header
	var tdiv = document.createElement('div');
	tdiv.id = 'TabHeaderDiv';
	parent.appendChild(tdiv);
	
	var TabHeader = document.createElement('ul');
	TabHeader.id = 'TabHeaderul';
	tdiv.appendChild(TabHeader);
	
	//Tab content frame
	var divTabFrame = document.createElement('div');
	divTabFrame.id = 'divTabFrame';
	parent.appendChild(divTabFrame);
			
	this.addTabPage = function(header, content)
	{
		var page = new tabPage(header, content, this);
		tabPages.push(page);
		TabHeader.appendChild(page.pageHeader);
		return page;
	}
	
	this.getTabPageById = function(id)
	{
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if(p.id == id)
				return p;
		}
	}
	
	this.RemoveTabPage = function(id)
	{
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if(p.id == id)
			{
				TabHeader.removeChild(p.pageHeader);
				p.pageHeader = null;
				tabPages.splice(i, 1);
				p.Destroy();
				return;
			}
		}
	}
	
	this.selectTabPagebyId = function(id)
	{
		var tabPage = this.getTabPageById(id);
		
		//fire LeavingEvent for the previous tabpage.
		for (var i=0; i<tabPages.length; i++)
		{
			var p = tabPages[i];
			if (selectedIndex == p.id) p.fireLeavingHandler();
		}
		
		selectedIndex = id;
		divTabFrame.innerHTML = tabPage.pageContent;
		
		//fire the EnteringEvent for the currrent tabpage.
		tabPage.fireEnterHandler();
	}
	
	this.selectTabPage = function(page)
	{
		if (page && page.id)
			this.selectTabPagebyId(page.id);
	}
	
	this.Destroy = function()
	{
		for (var i=0; i<tabPages.length; i++)
		{
			p.Destroy();
		}
	}
}

