//------------------------------------------------------------------------------
// JS/Scratchpad/scratchpadbuilderfunctions.js 
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur,shankak, a-pratin
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

function buildScratchPadHeader()
{
	// Header Text
	scratchPad.setHeaderText( L_ScratchPadBuilderFunctionsScratchpad_Text );
}

function buildScratchPadTitleList()
{
	scratchPad.addTitle( VE_CollectionsManager.unsavedCollectionIndex, VE_CollectionsManager.unsavedCollectionTitle);

	//Set the stage for CollectionsManager.
	VE_CollectionsManager.collectionIndex = VE_CollectionsManager.unsavedCollectionIndex;
}

function buildScratchPadInfoBar()
{	
	var saveHtml = L_ScratchPadBuilderFunctionsNotSaved_Text.replace(/%1/g, '<a href=\'\' onclick="showSaveUI(false); return false;">' ).replace(/%2/g,'</a>');
	
	
	
	if(VE_CollectionsManager.CheckingSignIn)
	{
		//Build loading text
		scratchPad.hideInfoBar();
		scratchPad.setContent('<div class = "loading">' + L_SearchLoading_Text + '</div>',Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.EmptyMessage);
		return;
	}
	else
	{
		buildScratchPadEmptyListContent();		
	}
		
	if(VE_CollectionsManager.SignedIn)
	{
		if(VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
		{
			scratchPad.showInfoBar();
			scratchPad.setContent(saveHtml, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.Info);
		}
		else 
		{
			scratchPad.hideInfoBar();
		}
	}
	else 
	{
		scratchPad.showInfoBar();
		var content  = L_ScratchPadSignInMessage_Text.replace(/%1/g,window.passportLoginButtonHtml);
		scratchPad.setContent(content, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.Info);	
		content = null;
		
		if(VE_CollectionsManager.CollectionList && VE_CollectionsManager.CollectionList.length > 0)
		{
			scratchPad.clearTitles();
		}
	}
	
	saveHtml = null;
	actionCode = null;
	
}

function showSaveUI(IsUpdate)
{
		//First verify if the user has logged in or not. If not, ask them to login and return
		if(!VE_Passport || !VE_Passport.isAuthenticated)
		{
			ShowMessage(L_FavoritesSignInSuggestion_Text);							
			return false;
		}

	// In case the Save Panel is already open, and the user clicked save again...
	//if (scratchPad.propertiesPanel)
	//	return;

	 	var p = new VE_Panel(
		"saveCollectionPanel",					// id
		0,							          	// x
		0,								          // y
		'auto',			// width
		'auto',		// height
		'savecollection',							        // color
		VE_SearchManager.popupZIndex,	// z index
		'Collection Properties',				// title
		"",								// body
		"",							// footer
		null,						// mouseover title
		true);					// opaque?
		
		p.SetFooterSize(0);
		p.SetToolbarSize(0);
		p.onCloseClick = cancelSaveCollection;
		
		var action = 'save';
		
		if(IsUpdate)
			action = 'update';
		else
		{
			//call ominiture logging
			VE_Analytics.Log("VE | ScratchPad Menu Bar","Save Collection");
		}
		
		var html = '<form id = "wl_ve_saveCollectionForm" onkeydown = "return PanelKeyDownHandler(event, \'' + action  + '\');" onsubmit = "return false;">' +
							'<fieldset>' +
								'<legend></legend>' +
								'<label>' + L_Title_Text + '</label>' +
								'<input id = "collectionFormTitle" type = "text" maxlength="'+VE_Annotations.MaxAnnotationTitle+'"/>' +
							'</fieldset>' +
							
							'<fieldset>' +
							'<legend></legend>' +
							'<label>' + L_Notes_Text + '</label>' +
							'<textarea id = "collectionFormNotes" onkeypress = "return VE_Annotations.checkMaxLength(this, '+VE_Annotations.MaxAnnotationNotes+');" ' +
							'onpaste = "return VE_Annotations.doPaste(this, ' + VE_Annotations.MaxAnnotationNotes + ');" ' + '></textarea>' +
							'</fieldset>' +
							
							'<fieldset>' +
							'<legend></legend>' +
							'<input id = "collectionFormAccess" type = "checkbox" />' +
							'<label id = "collectionFormAccessLabel" for="collectionFormAccess">' + L_ScratchPadBuilderFunctionsPublic_Text + '</label>' +
							'<span class=\"viewer_help\" onclick=\"showPublicPrivateHelp();\"></span><br><br>'+
							'<span>' + L_ScratchPadPrivacySafetyMessage_Text.replace(/%1/g, '<a href="#" onclick="return showSafetyHelp(\'safety.htm\');">').replace(/%2/g, '</a>').replace(/%3/g, '<a href="#" onclick="return showSafetyHelp(\'cPublicPrivate.htm\');">').replace(/%2/g, '</a>') + '</span>'+
							
							'</fieldset>' +
							
							'<fieldset id = "annotationForm_saveOptions">' +
								'<legend></legend>' +
								'<input id = "wl_ve_annotations_cancel" class = "higButton" type = "button" onclick = "cancelSaveCollection();" value = "' + L_Cancel_Text + '" />' +
								'<input id = "wl_ve_annotations_save" class = "higButton" type = "button" onclick = "%ACTION%" value = "' + L_AnnotationPanelSave_Text + '" />' +			
							'</fieldset>' +
					'</form>';
		if(IsUpdate)
		{
			html = html.replace(/%ACTION%/g,'updateCollection();');
		}
		else
		{
			html = html.replace(/%ACTION%/g,'VE_CollectionsManager.SaveCollection();');
		}
	
	p.body.style.width = 'auto';
	p.body.style.height = 'auto';
	p.SetBody(html);	
	
	scratchPad.propertiesPanel = p;	
	//scratchPad.addControl(p.el, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.Info);
	scratchPad.clearControls(Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);
	scratchPad.addControl(p.el, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);
	scratchPad.showActionPanel();
	scratchPad.hideInfoBar();
	
	var textElement = document.getElementById('collectionFormTitle');
	if(textElement)
		textElement.focus();
	textElement = null;
	
	html = null;
	
	return false;
}

function showDeleteUI(IsClear)
{
	var cTitle = '';
	
	if(VE_CollectionsManager.collectionIndex == null || VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
	{
		cTitle = VE_CollectionsManager.unsavedCollectionTitle;
		
		if(VE_CollectionsManager.Collection == null || VE_CollectionsManager.Collection.Annotations == null || VE_CollectionsManager.Collection.Annotations.length == 0)
			return;
	}
	else 
	{
		cTitle = VE_CollectionsManager.RetrieveByKey(VE_CollectionsManager.collectionIndex).Name;
		 
		if(IsClear && (VE_CollectionsManager.Annotations == null || VE_CollectionsManager.Annotations.length == 0))
			return;
	}
	
	var action = 'delete';
	
	if(IsClear)
		action = 'clear';
	
	var title = L_ScratchPadBuilderFunctionsDeleteCollection_Text;		
	
	if(IsClear)
		title = L_ScratchPadBuilderFunctionsClearCollection_Text;			
		
	 	var p = new VE_Panel(
		"deleteCollectionPanel",					// id
		0,							          	// x
		0,								          // y
		'auto',			// width
		'auto',		// height
		'deletecollection',							        // color
		VE_SearchManager.popupZIndex,	// z index
		title,				// title
		"",								// body
		"",							// footer
		null,						// mouseover title
		true);					// opaque?
		
		p.SetFooterSize(0);
		p.SetToolbarSize(0);
		p.onCloseClick = cancelDeleteCollection;
	
		var collectionName = '<b>' + cTitle + '</b>' + '?';
		
		var message = L_ScratchPadDeleteCollectionQuestion_Text.replace(/%1/g,collectionName);
		var buttonText = L_Yes_Text;
		
		if(IsClear)
		{
			message = L_ScratchPadBuilderFunctionsClearCollectionQuestion_Text;
		}
		
		var html = '<form id = "wl_ve_deleteCollectionForm" onkeydown = "return PanelKeyDownHandler(event, \'' + action  + '\');" onsubmit = "return false;">' +
							'<fieldset>' +
								'<legend></legend>' +
								'<label>' + message + '</label>' +
							'</fieldset>' +
						
							'<fieldset id = "annotationForm_deleteOptions">' +
								'<legend></legend>' +
								'<input id = "wl_ve_annotations_cancel" class = "higButton" type = "button" onclick = "cancelDeleteCollection();" value = "' + L_No_Text + '" />' +
								'<input id = "wl_ve_annotations_save" class = "higButton" type = "button" onclick = "%ACTION%" value = "' + buttonText + '" />' +			
							'</fieldset>' +
					'</form>';
			
		if(IsClear)
			html = html.replace(/%ACTION%/g,'VE_Scratchpad.Clear();');
		else
			html = html.replace(/%ACTION%/g,'VE_CollectionsManager.DeleteCollection();');
		
	
	//hack for now..
	p.body.style.height = 'auto';
	p.body.style.width = 'auto';
	
	p.SetBody(html);
	
	scratchPad.deletePanel = p;
	scratchPad.clearControls(Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);	
	scratchPad.addControl(p.el, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);
	scratchPad.showActionPanel();

	var  deleteButton = document.getElementById('wl_ve_annotations_save');
	if(deleteButton)
		deleteButton.focus();
	deleteButton = null;
	
	collectionName = null;
	html = null;
	
	return false;
}

function PanelKeyDownHandler (e, action)
{
	if (!e)
	{
		e = window.event;
	}
	
	switch (e.keyCode)
	{
		case 27: // esc
			PanelKeyDownHandlerSentinel(action,true);
			return false;
			break;
		case 13: // enter
			if (e.ctrlKey || e.shiftKey || e.altKey)
			{
				break;
			}
			if ( e.srcElement.id == "wl_ve_annotations_cancel" )
				PanelKeyDownHandlerSentinel(action,true);
			else	
				PanelKeyDownHandlerSentinel(action,false);
			return false;
			break;
		default:
			break;
	}
	
	return true;
}

function PanelKeyDownHandlerSentinel(action,isEscape)
{
	if(!action || action == '' || action == 'undefined' || isEscape == 'undefined' || isEscape == null)
	{
		return true;
	}
	
	switch(action)
	{
		case "save":		//save new data
			if(!isEscape)
				VE_CollectionsManager.SaveCollection();
			else 
				cancelSaveCollection();
			return false;
			break;
		case "update":		//update the exisiting data
			if(!isEscape)
				updateCollection();
			else
				cancelSaveCollection();
			return false;
			break;
		case "delete":		//delete exisiting data
			if(!isEscape)
				VE_CollectionsManager.DeleteCollection();
			else 
				cancelDeleteCollection();
			return false;
			break;
		case "clear":		//clear scratchPad
			if(!isEscape)	
				VE_Scratchpad.Clear();
			else 
				cancelDeleteCollection();
			return false;
			break;
		case "access":		//set visibility access 
			if(!isEscape)
				VE_CollectionsManager.UpdateCollectionVisibility();
			else
				cancelVisibilityChange(true);
			return false;
			break
		default:			//no action just return false
			break;
	}

	
	return true;
}


function cancelDeleteCollection()
{
	if(scratchPad.deletePanel)
	{
		scratchPad.deletePanel.Destroy();
		scratchPad.deletePanel = null;
	}
	scratchPad.hideInfoBar();
	scratchPad.hideActionPanel();
	buildScratchPadInfoBar();
}

function cancelSaveCollection()
{
	if(scratchPad.propertiesPanel)
	{
		scratchPad.propertiesPanel.Destroy();
		scratchPad.propertiesPanel = null;
	}
	scratchPad.hideInfoBar();
	scratchPad.hideActionPanel();
	buildScratchPadInfoBar();
}

function cancelVisibilityChange(isUiCancel)
{
	if(isUiCancel)
	{
		if(document.getElementById('chkMakeCollectionPublic').checked)
			document.getElementById('chkMakeCollectionPublic').checked = false;
		else 
			document.getElementById('chkMakeCollectionPublic').checked = true;
	}
	if(scratchPad.updatePanel)
	{
			scratchPad.updatePanel.Destroy();
			scratchPad.updatePanel = null;
	}
	scratchPad.hideInfoBar();
	scratchPad.hideActionPanel();
	buildScratchPadInfoBar();
}

function showVisibilityUI(isChecked)
{
		scratchPad.clearControls();
	 	var p = new VE_Panel(
		"UpdateCollectionPanel",					// id
		0,							          	// x
		0,								          // y
		'auto',			// width
		'auto',		// height
		L_ScratchPadAccessSecurityTitle_Text,				// title
		VE_SearchManager.popupZIndex,	// z index
		L_ScratchPadAccessSecurityTitle_Text,				// title
		"",								// body
		"",							// footer
		null,						// mouseover title
		true);					// opaque?
		
		p.SetFooterSize(0);
		p.SetToolbarSize(0);
		p.onCloseClick = cancelVisibilityChange;
		
		var action = 'access';
		
		var message = ' ';
		
		if(isChecked)
			message = L_ScratchPadChangePublicVisibile_Text.replace(/%1/g,'<b>' + L_ScratchPadPublic_Text + '</b>');
		else 
			message = L_ScratchPadChangePrivateVisibile_Text.replace(/%1/g,'<b>' + L_ScratchPadPrivate_Text + '</b>');
		
		var html = '<form id = "wl_ve_updateCollectionForm" onkeydown = "return PanelKeyDownHandler(event, \'' + action  + '\');" onsubmit = "return false;">' +
							'<fieldset>' +
								'<legend></legend>' +
								'<label>' + message + '</label>' +
							'</fieldset>' +
						
							'<fieldset id = "annotationForm_UpdateOptions">' +
								'<legend></legend>' +
								'<input id = "wl_ve_annotations_cancel" class = "higButton" type = "button" onclick = "cancelVisibilityChange(true);" value = "' + L_No_Text + '" />';
							
					if(isChecked)
						html += '<input id = "wl_ve_annotations_save" class = "higButton" type = "button" onclick = "VE_Analytics.Log(\'VE | ScratchPad\',\'Make Collection public\'); VE_CollectionsManager.UpdateCollectionVisibility();" value = "' + L_Yes_Text + '" />'	;
					else
						html += '<input id = "wl_ve_annotations_save" class = "higButton" type = "button" onclick = "VE_Analytics.Log(\'VE | ScratchPad\',\'Make Collection private\'); VE_CollectionsManager.UpdateCollectionVisibility();" value = "' + L_Yes_Text + '" />' ;			
			
					html += '</fieldset>' + '</form>';


	
	//hack for now..
	p.body.style.height = 'auto';
	p.body.style.width = 'auto';
	
	p.SetBody(html);
	
	scratchPad.updatePanel = p;
	scratchPad.clearControls(Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);
	scratchPad.addControl(p.el, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.ActionPanel);
	scratchPad.showActionPanel();
	scratchPad.hideInfoBar();
	
	
	var  accessButton = document.getElementById('wl_ve_annotations_save');
	if(accessButton)
		accessButton.focus();
	accessButton = null;
	
	collectionName = null;
	html = null;
}


function buildScratchPadMenuBar()
{
	// Add Pushpin
	scratchPad.addMenuItem(L_MainAddPushpinLink_Text, function() { VE_Analytics.Log('VE | ScratchPad Menu Bar','Add Pushpin');VE_Annotations.AnnotateMapCenter(); } );
		
	// Map all
	if (Msn.VE.Marketization.IsEnabled('Msn.VE.Features.MenuOption.MapAllScratchPadItems'))
		scratchPad.addMenuItem(L_MainMapAll_Text, VE_Scratchpad.SetBestMapView);
	
	// Clear	
	scratchPad.addMenuItem(L_MainClear_Text, ClearAnnotations);				
						
	// Start build the scratchPad's menu bar

	if ( !Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.DisplayNone) )
	{
		var shareMenuOption = 
		L_MainShare_Text + '<span></span>' +
		'<ul>' + 
			
			(Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.SendEmail ) ? 
			'<li onclick = "VE_Analytics.Log(\'VE | ScratchPad Menu Bar\',\'Share - Send to a friend\');VE_Scratchpad.Email(VE_CollectionsManager.collectionIndex);">' + L_MainShareSendToAFriend_Text + '</li>' : '') +
			(document.all && Msn.VE.Marketization.IsEnabled( Msn.VE.Features.MenuOption.ShareScratchPadItems.CopyToClipboard ) ?
			'<li onclick = "VE_Analytics.Log(\'VE | ScratchPad Menu Bar\',\'Share  Copy to Clipboard\');VE_Scratchpad.CopyToClipboard(VE_CollectionsManager.collectionIndex);">' + L_MainShareCopyToClipboard_Text + '</li>' : '') +
			(Msn.VE.Marketization.IsEnabled(Msn.VE.Features.MenuOption.ShareScratchPadItems.AddBlogEntry) ?
			'<li onclick = "VE_Analytics.Log(\'VE | ScratchPad Menu Bar\',\'Share  Blog\');VE_Scratchpad.Blog(VE_CollectionsManager.collectionIndex);">' + L_MainShareAddBlogEntry_Text + '</li>' : '') +

			//'<li>' + L_MainShareSendIM_Text + '</li>' +
		'</ul>';
		
		scratchPad.addMenuItem(shareMenuOption, null, true, true);
	}
}

function ClearAnnotations()
{
	showDeleteUI(true);
}

function buildScratchPadEmptyListContent()
{
	// Set content for the ScratchPad's EmptyMessage Container	
	var newemptyMessageMarkup =  L_ScratchPadBuilderFunctionsNewEmptyScratchPadMessage_Text.replace(/%1/g, '<p align=center>').replace(/%2/g, '<br>').replace(/%3/g, '<br>').replace(/%4/g, '<b>').replace(/%5/g, '</b>').replace(/%8/g, '</p>');
	scratchPad.setContent(newemptyMessageMarkup, Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.EmptyMessage);
}

function setProperties()
{
	VE_Analytics.Log('VE | ScratchPad','Collection Properties');

	if(	VE_CollectionsManager.collectionIndex && 
		VE_CollectionsManager.collectionIndex != VE_CollectionsManager.unsavedCollectionIndex && 
		VE_CollectionsManager.collectionIndex != '' && 
		VE_CollectionsManager.collectionIndex != 'undefined')
	{ 
		showSaveUI(true); 
		if(scratchPad.propertiesPanel) 
		{
			var cItem = VE_CollectionsManager.RetrieveByKey(VE_CollectionsManager.collectionIndex);
			if(cItem)
			{
				var cTitle = document.getElementById('collectionFormTitle');
				var cNotes = document.getElementById('collectionFormNotes');
				var cChecked = document.getElementById('collectionFormAccess');
				
				if(cTitle)
				{
					cTitle.value = cItem.Name;
				}
				
				if(cNotes)
				{
					var tempNotes = cItem.keywords.join(" ");
					cNotes.value = tempNotes == 'undefined' ? "" : tempNotes;
					tempNotes = null;
				}				
				
				if(cChecked)
				{
					if(cItem.IsPublic)
						cChecked.checked = true;
					else
						cChecked.checked = false;
				}
			}
			cItem = null;
		}
		else
		{
			
		}
	}	
	
	return false;
}


function updateCollection()
{
	var cTitle = document.getElementById('collectionFormTitle');
	var cNotes = document.getElementById('collectionFormNotes');
	var cChecked = document.getElementById('collectionFormAccess');
	
	if(cTitle && cNotes && cChecked && VE_CollectionsManager.collectionIndex && 
		VE_CollectionsManager.collectionIndex != VE_CollectionsManager.unsavedCollectionIndex && 
		VE_CollectionsManager.collectionIndex != '' && 
		VE_CollectionsManager.collectionIndex != 'undefined')
	{
		var cItem = VE_CollectionsManager.RetrieveByKey(VE_CollectionsManager.collectionIndex);
		if(cItem)
		{
			//remove pipes,carrots, leading and trailing white spaces
			var name =  escape(cTitle.value).replace(/^(%20)*/g, "").replace(/(%20)*$/g, "").replace(/^(%09)*/g, "").replace(/(%09)*$/g, "");
			var notes =  escape(cNotes.value).replace(/^(%20)*/g, "").replace(/(%20)*$/g, "").replace(/^(%09)*/g, "").replace(/(%09)*$/g, "");
			var isChecked = cChecked.checked;
			
			
			if(name.length > 0)
			{
				cItem.Name = unescape(name);
				if(cItem.keywords == null)
				{
					cItem.keywords = new Array();
					cItem.keywords.push(unescape(notes));
				}
				else
				{
					if(cItem.keywords.length > 0)
					{
						if(cItem.keywords[0] != unescape(notes))
						{
							cItem.keywords[0] = unescape(notes);
						}
					}
					else
					{
						cItem.keywords.push(unescape(notes));						
					}
				
				}
				cItem.IsPublic = isChecked;
				
				//update the  footer's pub/priv checkbox
				setCollectionVisibility(cItem.IsPublic);
					
				cItem.Dirty = true;
				
				//Update the collection.
				//TODO : get scratchpad title to change title instantly.
				VE_CollectionsManager.UpdateCollection(VE_CollectionsManager.collectionIndex, VE_CollectionsManager.Annotations,window.locale,VE_CollectionsManagerConstants.MinimizedTimerDelay); 
				
				//Remove the current item from drop down
				//And add the new title back
				scratchPad.removeCurrentTitle();
				scratchPad.addTitle(cItem.ID, cItem.Name);
				//Now get the collections
				if(VE_CollectionsManager.CollectionList != null)
				{
					var len = VE_CollectionsManager.CollectionList.length;
					scratchPad.selectTitle(len);
				}								
			}
			else
			{
				//There was no name and hence we select the text box spaces 
				//for feedback to user and keep the panel open and wait....
				SelectText(cTitle,0,0);
				cItem = null;
				return;
			}
		}
		cItem = null;
	}
}

function buildScratchPadFooter()
{
	var col = Microsoft.Web.VirtualEarth.Collections;
	
	var li, lnk;		// reusuable
	var ul = document.createElement('ul');
	scratchPad.addControl(ul, col.ScratchPadComponents.Footer);
	
	li = document.createElement('li');
	ul.appendChild(li);
	lnk = document.createElement('a');	
	lnk.href = '';
	lnk.onclick = setProperties; 
	lnk.appendChild(document.createTextNode( L_ScratchPadBuilderFunctionsProperties_Text ));
	li.appendChild(lnk);
	
	li = document.createElement('li');
	ul.appendChild(li);
	lnk = document.createElement('a');
	lnk.href = '';
	lnk.onclick = function() { VE_Analytics.Log('VE | ScratchPad','Delete Collection'); return showDeleteUI(false);};
	lnk.appendChild(document.createTextNode( L_ScratchPadBuilderFunctionsDelete_Text ));
	li.appendChild(lnk);

	li = document.createElement('li');
	ul.appendChild(li);
	var chk = document.createElement('input');	
	chk.id = 'chkMakeCollectionPublic';
	chk.onclick = function() { cancelVisibilityChange(false); showVisibilityUI(chk.checked); }	
	chk.setAttribute('type', 'checkbox');
	li.appendChild(chk);
	var lbl = document.createElement('label');	
	lbl.setAttribute('for', chk.id);
	lbl.appendChild(document.createTextNode( L_ScratchPadBuilderFunctionsPublic_Text ));
	li.appendChild(lbl);
	
	li = document.createElement('li');
	ul.appendChild(li);
	var icnHelp = document.createElement('div');
	icnHelp.className = 'icnHelp';	
	icnHelp.attachEvent('onclick', function() { VE_Help.Open(L_Help_Text, './help/' + window.locale + VE_CollectionsManagerConstants.HELP_FILE_PATH); });
	li.appendChild(icnHelp);
	
	var clearDiv = document.createElement('div');
	clearDiv.className = 'clear';
	scratchPad.addControl(clearDiv, col.ScratchPadComponents.Footer);
	
	if(VE_CollectionsManager.collectionIndex == null || VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
		scratchPad.hideFooter();
	else
		scratchPad.showFooter();
}

function showPublicPrivateHelp()
{
	VE_Help.Open(L_Help_Text, './help/' + window.locale + VE_CollectionsManagerConstants.HELP_FILE_PATH);
}

function showSafetyHelp(fileName)
{
	VE_Help.Open(L_Help_Text, './help/' + window.locale + '/' + fileName);
	return false;
}


function setCollectionVisibility(IsPublic)
{
	if(document.getElementById('chkMakeCollectionPublic'))
	{
		if(IsPublic)
			document.getElementById('chkMakeCollectionPublic').checked=true;
		else
			document.getElementById('chkMakeCollectionPublic').checked=false;
	}	
}

function buildScratchPadItemTools()
{
	var toolReorderUp = document.createElement('div');
	toolReorderUp.className = 'toolReorderUp'	
	toolReorderUp.onclick = function()
	{
		var spItem = this.ScratchPadItemRef;					
		var index = scratchPad.indexOf(spItem);				
		scratchPad.moveItem(spItem, index - 1);
		
		VE_CollectionsManager.MoveAnnotationUp(index,VE_CollectionsManager.collectionIndex);
	}
	
	var toolReorderDown = document.createElement('div');
	toolReorderDown.className = 'toolReorderDown';
	toolReorderDown.onclick = function()
	{
		var spItem = this.ScratchPadItemRef;
		var index = scratchPad.indexOf(spItem);				
		scratchPad.moveItem(spItem, index + 1);
		
		VE_CollectionsManager.MoveAnnotationDown(index,VE_CollectionsManager.collectionIndex);
	}
	
	var toolRemoveItem = document.createElement('div');
	toolRemoveItem.className = 'toolRemoveItem';
	toolRemoveItem.onclick = function()
	{
		// The ScratchPad's removeItem(...)function calls removeItem(...) of an underlying Hashtable.  The Hashtable's funtion is designed to return false if the attempt to remove fails.  The ScratchPad's function will not return anything, but simply
		// ignore the request to remove the item.   Therefore, we should check that the ScratchPadItem object is valid before we try to destroy it.
		var spItem = this.ScratchPadItemRef;
		scratchPad.removeItem(spItem);				
	
	}
	
	scratchPad.addItemTool(toolReorderUp);
	scratchPad.addItemTool(toolReorderDown);
	scratchPad.addItemTool(toolRemoveItem);
}

function scratchPadPostAddactions(_spiea)
{
		var col = Microsoft.Web.VirtualEarth.Collections;
		
		var spItem = _spiea.ScratchPadItem;
		
		if (!VE_CollectionsManager.isLoading)
			{ scratchPad.scrollTo(spItem); }
		
		var elem = spItem.getElement();	
		pseudoHover(elem);
		var poi = spItem.getPoi();
		if(elem)
		{
			elem = elem.getElementsByTagName('h4');
			
			if(elem != null && elem != 'undefined' && elem != '' && elem.length > 0)
			{
				elem = elem[0];
				
				if(elem)
				{
					elem.onmouseover = function(e)
					{
						if (VE_ContextMenu.MenuOpen) 
						{
							VE_ContextMenu.RemoveContextPin();
							VE_ContextMenu.CloseMenu();
						}

						//Fix: Bug 3909
						//Do not close the Annotations Panel because it is annoying if the 
						//user clicks on Add Pushpin and then hovers over a pin on the way to the panel
						//VE_ContextMenu.RemoveContextPin ();
						//VE_Annotations.ClosePanel ();
						
						try
						{
							if(spItem && spItem != 'undefined' && spItem != '')
							{
								var content = VE_CollectionsManager.CreateEroContent(spItem);
								
								if(content && content != 'undefined' && content != '' && content.length > 0)
									ero.setContent(content);
							}
						}
						catch (ex) 
						{ 
							//alert(e.message);
						}
						
						var dockElement = this;
						var target =  GetTarget(e);
						if(!dockElement)
							dockElement = target;
							
						ero.dockToElement(dockElement, e);
					}
					
					elem.onmouseout = function(e)
					{
						ero.hide();
					}
				}
			}
		}
		poi.onmouseover = function()
		{
			if (VE_ContextMenu.MenuOpen) 
			{
				VE_ContextMenu.RemoveContextPin();
				VE_ContextMenu.CloseMenu();
			}
			
			//Fix: Bug 3909
			//Do not close the Annotations Panel because it is annoying if the 
			//user clicks on Add Pushpin and then hovers over a pin on the way to the panel
			//VE_ContextMenu.RemoveContextPin ();
			//VE_Annotations.ClosePanel ();
			
			var guid = spItem.getGuid();
			var match = guid.match(REGEX_PUSHPIN_ID);
						
			var entityId = null;
			
			// If the ScratchPad Item's GUID does not match the regEx above, the validity of the  is suspect, ad so, as a safety, we simply abandon this ERO request altogether
			if (!match)
			{
				if(!spItem.getBusinessListingId())
					return;
				else
					entityId = spItem.getBusinessListingId();
			}
			else entityId = match[2];
		
			try
			{
				if(spItem && spItem != 'undefined' && spItem != '')
				{
					var content = VE_CollectionsManager.CreateEroContent(spItem);
					
					if(content && content != 'undefined' && content != '' && content.length > 0)
						ero.setContent(content);
				}
			}
			catch (e) 
			{ 
				//alert(e.message);
			}

			ero.dockToElement(poi);
		}
		poi.onmouseout = function() { ero.hide(); }
		
		/* hack -- expose the title element so we don't have to reference a specific child node */
		var h4Title = spItem.getElement().childNodes[1];
		h4Title.onclick = function()
		{
			try
			{
				map.PanToLatLong(parseFloat(spItem.getLatitude()), parseFloat(spItem.getLongitude()));
			}
			catch(e) { /*swallow for now*/ }
		}
		pseudoHover(h4Title);			// for IE
		
		return spItem;
}


function addScratchPadEventListeners()
{
	scratchPad.onadditem = function(_spiea)
	{
		var spItem = scratchPadPostAddactions(_spiea);
		 
		try
		{
			var guid = spItem.getGuid();
			var collectionId = VE_CollectionsManager.collectionIndex;
			
			if(guid.indexOf('scratchpin') > -1)
			{			
				VE_CollectionsManager.CreateAnnotation (spItem.getGuid(),
														collectionId,
														spItem.getTitle(),
														spItem.getLatitude(),
														spItem.getLongitude(),
														spItem.getDescription(),
														spItem.getKeywords(),
														spItem.getInfoUrl(),
														spItem.getPhotoUrl(),					
														spItem.getUserDate(),
														spItem.getDisplayOrder(),								
														spItem.getBusinessListingId(),
														spItem.getIconId(),
														VE_AnnotationState.Added,
														window.locale
														);
			}															
		}
		catch(everything){}
		
		// The following call will open the scratchpad whenever an item is added.
		// NOTE: If the Scratch Pad is already open, this call will not hurt anything and causes no significant overhead.
		scratchPad.show();
		
	}
	
	scratchPad.onmoveitem = function(_spiea)
	{
		//Close all related popups
		closeAllPopups();
		
		var spItem = _spiea.ScratchPadItem;
		var moveAmount = _spiea.MoveAmount;
		var elem = spItem.getElement();
		
		var index1, index2;
		index1 = scratchPad.indexOf(spItem);
		index2 = index1 - moveAmount;
		var swappedItem = scratchPad.getItems().retrieveByIndex(index2);
		
		var pin1 = document.getElementById(spItem.getGuid());
		var pin2 = document.getElementById(swappedItem.getGuid());
		var tmp = pin1.innerHTML;
		pin1.innerHTML = pin2.innerHTML;
		pin2.innerHTML = tmp;

		pseudoHoverRemove(elem);
	}
	
	scratchPad.onupdateitem = function(_spiea)
	{
		var spItem = _spiea.ScratchPadItem;	

		var index = scratchPad.indexOf(spItem);

		VE_CollectionsManager.UpdateAnnotation(			spItem.getGuid(),
														spItem.msnId,
														spItem.getTitle(),
														spItem.getLatitude(),
														spItem.getLongitude(),
														spItem.getDescription(),
														spItem.getKeywords(),
														spItem.getInfoUrl(),
														spItem.getPhotoUrl(),					
														spItem.getUserDate(),
														spItem.getDisplayOrder(),				
														spItem.getBusinessListingId(),
														spItem.getIconId(),
														VE_AnnotationState.Updated,
														window.locale,
														index
												);

	}
	
	scratchPad.onremoveitem = function(_spiea, isClear)
	{
		var spItem = _spiea.ScratchPadItem;		
		VE_Scratchpad.RemoveEntity(null, spItem.getGuid());		
		
		//Call to the client side CollectionManager to delete the item from storage
		//Check if the item has a local Id. If so delete using the item's msnid
		if(!isClear)
		{
			closeAllPopups();	
			
			if(spItem.msnId)
				VE_CollectionsManager.DeleteAnnotation(spItem.msnId,window.locale);
			else VE_CollectionsManager.DeleteAnnotation(spItem.getGuid(),window.locale);
		}
		
		spItem.destroy();
	}
	
	scratchPad.onselecttitle = function(_sptea)
	{
		closeAllPopups();
		//UI Cleaup
		
		if(scratchPad.propertiesPanel)
		{
			cancelSaveCollection();
		}
		
		if(scratchPad.deletePanel)
		{
			cancelDeleteCollection();
		}
		
		if(scratchPad.updatePanel)
		{
			cancelVisibilityChange();
		}
		
		scratchPad.hideInfoBar();
		
		scratchPad.hideActionPanel();
		scratchPad.hideFooter();
		scratchPad.clear();
		scratchPad.setContent('<div class = "loading">' + L_SearchLoading_Text + '</div>',Microsoft.Web.VirtualEarth.Collections.ScratchPadComponents.EmptyMessage);
		VE_CollectionsManager.RetrieveAllAnnotations(_sptea.Id,window.locale);
		
		VE_Analytics.Log('VE | ScratchPad','Load Collection');		
	}
	
	scratchPad.ontoggleboxclick = function()
	{
		var ani = Microsoft.Web.Animation;
		
		spRoller.LeaveAmount = 29;
		
		if (spRoller.isExpanded())
			spRoller.rollIn(ani.RollDirection.BottomUp);
		else
			spRoller.rollOut(ani.RollDirection.TopDown);
	}
	
	scratchPad.oncloseboxclick = function()
	{
		scratchPad.hide();
		VE_Scratchpad._HidePins();
	}
	
	scratchPad.onshow = function()
	{
		//on show of scratchpad
		if(VE_CollectionsManager.collectionIndex == VE_CollectionsManager.unsavedCollectionIndex)
		{
			if(VE_CollectionsManager.Collection instanceof VE_Collection && VE_CollectionsManager.Collection.AnnotationCount() > 0)
			{
				while(VE_CollectionsManager.Annotations.length)
				{
					var item = VE_CollectionsManager.Annotations.pop();
					item = null;
				}
				
				VE_CollectionsManager.Annotations = VE_CollectionsManager.Annotations.concat(VE_CollectionsManager.Collection.Annotations);
			}
		}
		VE_Scratchpad._HidePins();
		VE_CollectionsManager.CreatePushPins();
	}
	
	scratchPad.onhide = function()
	{
		// code for onhide
		//clear the pushpins on the map
		closeAllPopups();
		VE_CollectionsManager.ClearPushPins();

	}
	
	scratchPad.oninsertitem = function(_spiea)
	{
		var spItem = scratchPadPostAddactions(_spiea);
		
		if (spItem && spItem != '' && spItem != "undefined")
		{
			var insertIndex = scratchPad.indexOf(spItem);
			var guid = spItem.getGuid();
			var collectionId = VE_CollectionsManager.collectionIndex;
						
			if(	guid.indexOf('scratchpin') > -1 && 
				typeof(insertIndex) == "number")
			{
				VE_CollectionsManager.CreateAnnotation (spItem.getGuid(),
														collectionId,
														spItem.getTitle(),
														spItem.getLatitude(),
														spItem.getLongitude(),
														spItem.getDescription(),
														spItem.getKeywords(),
														spItem.getInfoUrl(),
														spItem.getPhotoUrl(),					
														spItem.getUserDate(),
														spItem.getDisplayOrder(),								
														spItem.getBusinessListingId(),
														spItem.getIconId(),
														VE_AnnotationState.Added,
														window.locale,
														insertIndex
														);								
			}
			else
			{
				VE_CollectionsManager.CreateAnnotation (spItem.getGuid(),
														collectionId,
														spItem.getTitle(),
														spItem.getLatitude(),
														spItem.getLongitude(),
														spItem.getDescription(),
														spItem.getKeywords(),
														spItem.getInfoUrl(),
														spItem.getPhotoUrl(),					
														spItem.getUserDate(),
														spItem.getDisplayOrder(),								
														spItem.getBusinessListingId(),
														spItem.getIconId(),
														VE_AnnotationState.Added,
														window.locale
														);			
			}			
		}
		
		scratchPad.show();			
	}
}

function closeAllPopups()
{
	// close the edit / save panel if it  is open
	VE_Annotations.CancelAnnotation ();
 	// close the search popup if it's open
	//VE_SearchManager.CloseSearchPopup ();
	// close the context menu if it's open
	VE_ContextMenu.CloseMenu ();
	// close the annotations panel if it's open
	VE_Annotations.ClosePanel ();
	// close the annotations popup if it's open
	VE_Annotations.ClosePopup ();	
}


function setScratchPadPseudoHover()
{
	// TitleBar
	pseudoHover(scratchPad.getElement().firstChild);
	
	// MenuBar
	pseudoHoverForChildren(scratchPad.getMenu());
}
