//------------------------------------------------------------------------------
// Microsoft.Web.ADT.Hashtable
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
// Dependencies: none
//
// Comments:  Javascript implementation of a Hashtable
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------

var Microsoft;
if (!Microsoft) Microsoft = {};
if (!Microsoft.Web) Microsoft.Web = {};
if (!Microsoft.Web.ADT) Microsoft.Web.ADT = {};

Microsoft.Web.ADT.Hashtable = function()
{
	// Account for IE 'this' bug
	var self = this;
	
	var m_collection = new Array();
	var m_keys = new Array();
	Construct();
	
	function Construct()
	{
		// Nothing to construct really, but it's good habit to have a constructor (yes, even in Javascript)
	}
	
	this.destroy = function()
	{
		// remove the collections array and the keys array
		m_collection = null;
		m_keys = null;
		
		// self reference cleanup
		self = null;		
	}
	
	
	// -- PUBLIC FUNCTIONS -- //
	this.addItem = function(_key, _value)
	{
		if (m_collection[_key])		
			return false;
		
		var len = m_collection.push(_value);
		m_collection[_key] = m_collection[len - 1];		
		m_keys.push(_key);
		
		// add succeeded
		return true;
	}
	
	this.removeItem = function(_index)
	{
		if (!m_collection[_index])		
			return false;
		
		// remove the item from the hashtable
		m_collection.splice(_index, 1);		
		
		// remove the key from the keycollection, and grab a reference to the key that was removed
		var removeKey = m_keys.splice(_index, 1);
		
		// delete the property of the m_collection array whose name corresponds to the key we just removed
		delete m_collection[removeKey];
		
		// remove succeeded
		return true;
	}
	
	this.insertItem = function(_key, _value, _index)
	{
		if (m_collection[_key] || _index < 0 || _index > m_collection.length)
			return false;
		
		m_collection.splice(_index, 0, _value);		
		m_collection[_key] = m_collection[_index];
		
		m_keys.splice(_index, 0, _key);
		
		// insert succeeded
		return true;
	}
	
	this.moveItem = function(_key, _index)
	{
		if (!m_collection[_key] || _index < 0 || _index > m_collection.length - 1)			
			return false;		

		var i = self.indexOf(_key);
		var itemToMove = m_collection.splice(i, 1)[0];
		var keyToMove = m_keys.splice(i, 1)[0];
		m_collection.splice(_index, 0, itemToMove);
		m_keys.splice(_index, 0, keyToMove);
		
		return true;		
		
	}
	
	this.indexOf = function(_key)
	{
		var i;
		for (i = 0; i < m_keys.length; i++)
		{
			if (m_keys[i] == _key)
				return i;
		}
		
		return -1;			// Key not found
	}
	
	this.retrieveByKey = function(_key)
	{
		return m_collection[_key];
	}
	
	this.retrieveByIndex = function(_index)
	{
		return m_collection[_index];
	}
	
	this.getKeys = function()
	{
		return m_keys;
	}
	
	this.getCount = function()
	{
		return m_collection.length;
	}
}