//------------------------------------------------------------------------------
// stylefunctions.js
//
// <copyright from='2004' to='2005' company='Microsoft Corporation'> 
// Copyright (c) Microsoft Corporation. All Rights Reserved. 
// Information Contained Herein is Proprietary and Confidential. 
// </copyright>
//
// Owner: sstchur
// Dependencies: 
// 2. ./util/microsoft.web.css.js
//
// Comments:  This is a file where we stored generalized function designed to aid in UI-type routines (getting an element's position on the screen, setting an element's style, etc...)
//
// <header>	$Header$</header>
//------------------------------------------------------------------------------


function setScrollPosition(elem, x, y)
{
	if (!elem)
		return;
		
	elem.scrollTop = y;
	elem.scrollLeft = x;
}


function pseudoHover(elem)
{
	// Mozilla does not need this silly function
	if (!document.all)
		return;
		
	//var existingMouseOverEvent = elem.onmouseover;
	//var existingMouseOutEvent = elem.onmouseout;
	var pseudoHoverOn = function() { elem.className += ' ms_pseudoHover'; };
	var pseudoHoverOff = function() { elem.className = elem.className.replace(/\s*ms_pseudoHover/g, ''); };
	
	elem.attachEvent('onmouseover', pseudoHoverOn);
	elem.attachEvent('onmouseout', pseudoHoverOff);
	document.body.attachEvent('onunload', ReleasePseudoHoverEvents);
	
	function ReleasePseudoHoverEvents()
	{
		elem.detachEvent('onmouseover', pseudoHoverOn);
		elem.detachEvent('onmouseout', pseudoHoverOff);
	}
}	

function pseudoHoverForChildren(parentElement, tag)
{
	// Mozilla does not need this silly function
	if (!document.all)
		return;
		
	if (!tag)
		tag = 'LI';
		
	var elems = parentElement.getElementsByTagName(tag);
	for (var i = 0; i < elems.length; i++)
	{
		this.pseudoHover(elems[i]);
	}		
}

function pseudoHoverRemove(elem)
{
		// Mozilla does not need this silly function
	if (!document.all)
		return;
		
	elem.className = elem.className.replace(/\s*ms_pseudoHover/g, '');
}


function setElementCursor(elem, cursor)
{	
	elem.style.cursor = cursor;	
}


function setElementStyle(elem, cssStyle, value, units)
{
	// Shortcut the Microsoft.Web.Css Namespace Chain
	var css = Microsoft.Web.Css
	
	if (!units)
		units = Microsoft.Web.Css.Units.Pixels;
	
	switch (cssStyle)
	{
		case style.Height:
			SetElementHeight(elem, value, units);
			break;
		
		case style.Width:
			SetElementWidth(elem, value, units);
			break;
			
		case style.Top:
			SetElementTop(elem, value, units);
			break;
		
		case style.Left:
			SetElementLeft(elem, value, units);
			break;
	}
	
	function SetElementHeight(elem, height, units)
	{
		try { elem.style.height = height + units; }
		catch(everything) { } 
	}
	
	function SetElementWidth(elem, width, units)
	{
		try { elem.style.width = width + units; }
		catch(everything) { }
	}
	
	function SetElementTop(elem, top, units)
	{
		try { elem.style.top = top + units; }
		catch(everything) { }
	}
	
	function SetElementLeft(elem, left, units)
	{
		try { elem.style.left = left + units; }
		catch(everything) { }
	}	
}